#ifndef __included_abf_api_json
#define __included_abf_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_abf_plugin_get_version_reply;
extern vapi_msg_id_t vapi_msg_id_abf_itf_attach_add_del;
extern vapi_msg_id_t vapi_msg_id_abf_plugin_get_version;
extern vapi_msg_id_t vapi_msg_id_abf_itf_attach_dump;
extern vapi_msg_id_t vapi_msg_id_abf_itf_attach_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_abf_policy_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_abf_policy_add_del;
extern vapi_msg_id_t vapi_msg_id_abf_policy_dump;
extern vapi_msg_id_t vapi_msg_id_abf_itf_attach_details;
extern vapi_msg_id_t vapi_msg_id_abf_policy_details;

#define DEFINE_VAPI_MSG_IDS_ABF_API_JSON\
  vapi_msg_id_t vapi_msg_id_abf_plugin_get_version_reply;\
  vapi_msg_id_t vapi_msg_id_abf_itf_attach_add_del;\
  vapi_msg_id_t vapi_msg_id_abf_plugin_get_version;\
  vapi_msg_id_t vapi_msg_id_abf_itf_attach_dump;\
  vapi_msg_id_t vapi_msg_id_abf_itf_attach_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_abf_policy_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_abf_policy_add_del;\
  vapi_msg_id_t vapi_msg_id_abf_policy_dump;\
  vapi_msg_id_t vapi_msg_id_abf_itf_attach_details;\
  vapi_msg_id_t vapi_msg_id_abf_policy_details;


#ifndef defined_vapi_type_fib_mpls_label
#define defined_vapi_type_fib_mpls_label
typedef struct __attribute__((__packed__)) {
  u8 is_uniform;
  u32 label;
  u8 ttl;
  u8 exp;
} vapi_type_fib_mpls_label;
#endif

#ifndef defined_vapi_type_fib_path
#define defined_vapi_type_fib_path
typedef struct __attribute__((__packed__)) {
  u32 sw_if_index;
  u32 table_id;
  u8 weight;
  u8 preference;
  u8 is_local;
  u8 is_drop;
  u8 is_udp_encap;
  u8 is_unreach;
  u8 is_prohibit;
  u8 is_resolve_host;
  u8 is_resolve_attached;
  u8 is_dvr;
  u8 is_source_lookup;
  u8 afi;
  u8 next_hop[16];
  u32 next_hop_id;
  u32 rpf_id;
  u32 via_label;
  u8 n_labels;
  vapi_type_fib_mpls_label label_stack[16];
} vapi_type_fib_path;
#endif

#ifndef defined_vapi_type_abf_policy
#define defined_vapi_type_abf_policy
typedef struct __attribute__((__packed__)) {
  u32 policy_id;
  u32 acl_index;
  u8 n_paths;
  vapi_type_fib_path paths[0];
} vapi_type_abf_policy;
#endif

#ifndef defined_vapi_type_abf_itf_attach
#define defined_vapi_type_abf_itf_attach
typedef struct __attribute__((__packed__)) {
  u32 policy_id;
  u32 sw_if_index;
  u32 priority;
  u8 is_ipv6;
} vapi_type_abf_itf_attach;
#endif

#ifndef defined_vapi_payload_abf_plugin_get_version_reply
#define defined_vapi_payload_abf_plugin_get_version_reply
typedef struct __attribute__ ((__packed__)) {
  u32 major;
  u32 minor; 
} vapi_payload_abf_plugin_get_version_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_abf_plugin_get_version_reply payload;
} vapi_msg_abf_plugin_get_version_reply;
#endif

#ifndef defined_vapi_payload_abf_itf_attach_add_del
#define defined_vapi_payload_abf_itf_attach_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_abf_itf_attach attach; 
} vapi_payload_abf_itf_attach_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_abf_itf_attach_add_del payload;
} vapi_msg_abf_itf_attach_add_del;
#endif

#ifndef defined_vapi_payload_abf_plugin_get_version
#define defined_vapi_payload_abf_plugin_get_version
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_abf_plugin_get_version;
#endif

#ifndef defined_vapi_payload_abf_itf_attach_dump
#define defined_vapi_payload_abf_itf_attach_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_abf_itf_attach_dump;
#endif

#ifndef defined_vapi_payload_abf_itf_attach_add_del_reply
#define defined_vapi_payload_abf_itf_attach_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_abf_itf_attach_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_abf_itf_attach_add_del_reply payload;
} vapi_msg_abf_itf_attach_add_del_reply;
#endif

#ifndef defined_vapi_payload_abf_policy_add_del_reply
#define defined_vapi_payload_abf_policy_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_abf_policy_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_abf_policy_add_del_reply payload;
} vapi_msg_abf_policy_add_del_reply;
#endif

#ifndef defined_vapi_payload_abf_policy_add_del
#define defined_vapi_payload_abf_policy_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_abf_policy policy; 
} vapi_payload_abf_policy_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_abf_policy_add_del payload;
} vapi_msg_abf_policy_add_del;
#endif

#ifndef defined_vapi_payload_abf_policy_dump
#define defined_vapi_payload_abf_policy_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_abf_policy_dump;
#endif

#ifndef defined_vapi_payload_abf_itf_attach_details
#define defined_vapi_payload_abf_itf_attach_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_abf_itf_attach attach; 
} vapi_payload_abf_itf_attach_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_abf_itf_attach_details payload;
} vapi_msg_abf_itf_attach_details;
#endif

#ifndef defined_vapi_payload_abf_policy_details
#define defined_vapi_payload_abf_policy_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_abf_policy policy; 
} vapi_payload_abf_policy_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_abf_policy_details payload;
} vapi_msg_abf_policy_details;
#endif


#ifndef defined_inline_vapi_type_fib_mpls_label
#define defined_inline_vapi_type_fib_mpls_label
static inline void vapi_type_fib_mpls_label_hton(vapi_type_fib_mpls_label *msg)
{
  msg->label = htobe32(msg->label);
}

static inline void vapi_type_fib_mpls_label_ntoh(vapi_type_fib_mpls_label *msg)
{
  msg->label = be32toh(msg->label);
}
#endif

#ifndef defined_inline_vapi_type_fib_path
#define defined_inline_vapi_type_fib_path
static inline void vapi_type_fib_path_hton(vapi_type_fib_path *msg)
{
  msg->sw_if_index = htobe32(msg->sw_if_index);
  msg->table_id = htobe32(msg->table_id);
  msg->next_hop_id = htobe32(msg->next_hop_id);
  msg->rpf_id = htobe32(msg->rpf_id);
  msg->via_label = htobe32(msg->via_label);
  do { unsigned i; for (i = 0; i < 16; ++i) { vapi_type_fib_mpls_label_hton(&msg->label_stack[i]); } } while(0);
}

static inline void vapi_type_fib_path_ntoh(vapi_type_fib_path *msg)
{
  msg->sw_if_index = be32toh(msg->sw_if_index);
  msg->table_id = be32toh(msg->table_id);
  msg->next_hop_id = be32toh(msg->next_hop_id);
  msg->rpf_id = be32toh(msg->rpf_id);
  msg->via_label = be32toh(msg->via_label);
  do { unsigned i; for (i = 0; i < 16; ++i) { vapi_type_fib_mpls_label_ntoh(&msg->label_stack[i]); } } while(0);
}
#endif

#ifndef defined_inline_vapi_type_abf_policy
#define defined_inline_vapi_type_abf_policy
static inline void vapi_type_abf_policy_hton(vapi_type_abf_policy *msg)
{
  msg->policy_id = htobe32(msg->policy_id);
  msg->acl_index = htobe32(msg->acl_index);
  do { unsigned i; for (i = 0; i < msg->n_paths; ++i) { vapi_type_fib_path_hton(&msg->paths[i]); } } while(0);
}

static inline void vapi_type_abf_policy_ntoh(vapi_type_abf_policy *msg)
{
  msg->policy_id = be32toh(msg->policy_id);
  msg->acl_index = be32toh(msg->acl_index);
  do { unsigned i; for (i = 0; i < msg->n_paths; ++i) { vapi_type_fib_path_ntoh(&msg->paths[i]); } } while(0);
}
#endif

#ifndef defined_inline_vapi_type_abf_itf_attach
#define defined_inline_vapi_type_abf_itf_attach
static inline void vapi_type_abf_itf_attach_hton(vapi_type_abf_itf_attach *msg)
{
  msg->policy_id = htobe32(msg->policy_id);
  msg->sw_if_index = htobe32(msg->sw_if_index);
  msg->priority = htobe32(msg->priority);
}

static inline void vapi_type_abf_itf_attach_ntoh(vapi_type_abf_itf_attach *msg)
{
  msg->policy_id = be32toh(msg->policy_id);
  msg->sw_if_index = be32toh(msg->sw_if_index);
  msg->priority = be32toh(msg->priority);
}
#endif

static inline void vapi_msg_abf_plugin_get_version_reply_payload_hton(vapi_payload_abf_plugin_get_version_reply *payload)
{
  payload->major = htobe32(payload->major);
  payload->minor = htobe32(payload->minor);
}

static inline void vapi_msg_abf_plugin_get_version_reply_payload_ntoh(vapi_payload_abf_plugin_get_version_reply *payload)
{
  payload->major = be32toh(payload->major);
  payload->minor = be32toh(payload->minor);
}

static inline uword vapi_calc_abf_plugin_get_version_reply_msg_size(vapi_msg_abf_plugin_get_version_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_plugin_get_version_reply_hton(vapi_msg_abf_plugin_get_version_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_plugin_get_version_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_abf_plugin_get_version_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_plugin_get_version_reply_ntoh(vapi_msg_abf_plugin_get_version_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_plugin_get_version_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_abf_plugin_get_version_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_abf_itf_attach_add_del_payload_hton(vapi_payload_abf_itf_attach_add_del *payload)
{
  vapi_type_abf_itf_attach_hton(&payload->attach);
}

static inline void vapi_msg_abf_itf_attach_add_del_payload_ntoh(vapi_payload_abf_itf_attach_add_del *payload)
{
  vapi_type_abf_itf_attach_ntoh(&payload->attach);
}

static inline uword vapi_calc_abf_itf_attach_add_del_msg_size(vapi_msg_abf_itf_attach_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_itf_attach_add_del_hton(vapi_msg_abf_itf_attach_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_abf_itf_attach_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_itf_attach_add_del_ntoh(vapi_msg_abf_itf_attach_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_abf_itf_attach_add_del_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_abf_plugin_get_version_msg_size(vapi_msg_abf_plugin_get_version *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_plugin_get_version_hton(vapi_msg_abf_plugin_get_version *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_plugin_get_version'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_abf_plugin_get_version_ntoh(vapi_msg_abf_plugin_get_version *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_plugin_get_version'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline uword vapi_calc_abf_itf_attach_dump_msg_size(vapi_msg_abf_itf_attach_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_itf_attach_dump_hton(vapi_msg_abf_itf_attach_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_abf_itf_attach_dump_ntoh(vapi_msg_abf_itf_attach_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_abf_itf_attach_add_del_reply_payload_hton(vapi_payload_abf_itf_attach_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_abf_itf_attach_add_del_reply_payload_ntoh(vapi_payload_abf_itf_attach_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_abf_itf_attach_add_del_reply_msg_size(vapi_msg_abf_itf_attach_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_itf_attach_add_del_reply_hton(vapi_msg_abf_itf_attach_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_abf_itf_attach_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_itf_attach_add_del_reply_ntoh(vapi_msg_abf_itf_attach_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_abf_itf_attach_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_abf_policy_add_del_reply_payload_hton(vapi_payload_abf_policy_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_abf_policy_add_del_reply_payload_ntoh(vapi_payload_abf_policy_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_abf_policy_add_del_reply_msg_size(vapi_msg_abf_policy_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_policy_add_del_reply_hton(vapi_msg_abf_policy_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_abf_policy_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_policy_add_del_reply_ntoh(vapi_msg_abf_policy_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_abf_policy_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_abf_policy_add_del_payload_hton(vapi_payload_abf_policy_add_del *payload)
{
  vapi_type_abf_policy_hton(&payload->policy);
}

static inline void vapi_msg_abf_policy_add_del_payload_ntoh(vapi_payload_abf_policy_add_del *payload)
{
  vapi_type_abf_policy_ntoh(&payload->policy);
}

static inline uword vapi_calc_abf_policy_add_del_msg_size(vapi_msg_abf_policy_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_policy_add_del_hton(vapi_msg_abf_policy_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_abf_policy_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_policy_add_del_ntoh(vapi_msg_abf_policy_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_abf_policy_add_del_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_abf_policy_dump_msg_size(vapi_msg_abf_policy_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_policy_dump_hton(vapi_msg_abf_policy_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_abf_policy_dump_ntoh(vapi_msg_abf_policy_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_abf_itf_attach_details_payload_hton(vapi_payload_abf_itf_attach_details *payload)
{
  vapi_type_abf_itf_attach_hton(&payload->attach);
}

static inline void vapi_msg_abf_itf_attach_details_payload_ntoh(vapi_payload_abf_itf_attach_details *payload)
{
  vapi_type_abf_itf_attach_ntoh(&payload->attach);
}

static inline uword vapi_calc_abf_itf_attach_details_msg_size(vapi_msg_abf_itf_attach_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_itf_attach_details_hton(vapi_msg_abf_itf_attach_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_abf_itf_attach_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_itf_attach_details_ntoh(vapi_msg_abf_itf_attach_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_itf_attach_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_abf_itf_attach_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_abf_policy_details_payload_hton(vapi_payload_abf_policy_details *payload)
{
  vapi_type_abf_policy_hton(&payload->policy);
}

static inline void vapi_msg_abf_policy_details_payload_ntoh(vapi_payload_abf_policy_details *payload)
{
  vapi_type_abf_policy_ntoh(&payload->policy);
}

static inline uword vapi_calc_abf_policy_details_msg_size(vapi_msg_abf_policy_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_abf_policy_details_hton(vapi_msg_abf_policy_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_abf_policy_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_abf_policy_details_ntoh(vapi_msg_abf_policy_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_abf_policy_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_abf_policy_details_payload_ntoh(&msg->payload);
}

static inline vapi_msg_abf_itf_attach_add_del* vapi_alloc_abf_itf_attach_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_abf_itf_attach_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_abf_itf_attach_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_abf_itf_attach_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_abf_itf_attach_add_del);

  return msg;
}

static inline vapi_error_e vapi_abf_itf_attach_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_abf_itf_attach_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_abf_itf_attach_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_abf_itf_attach_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_abf_itf_attach_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_abf_plugin_get_version* vapi_alloc_abf_plugin_get_version(struct vapi_ctx_s *ctx)
{
  vapi_msg_abf_plugin_get_version *msg = NULL;
  const size_t size = sizeof(vapi_msg_abf_plugin_get_version);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_abf_plugin_get_version*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_abf_plugin_get_version);

  return msg;
}

static inline vapi_error_e vapi_abf_plugin_get_version(struct vapi_ctx_s *ctx,
  vapi_msg_abf_plugin_get_version *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_abf_plugin_get_version_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_abf_plugin_get_version_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_abf_plugin_get_version_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_abf_itf_attach_dump* vapi_alloc_abf_itf_attach_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_abf_itf_attach_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_abf_itf_attach_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_abf_itf_attach_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_abf_itf_attach_dump);

  return msg;
}

static inline vapi_error_e vapi_abf_itf_attach_dump(struct vapi_ctx_s *ctx,
  vapi_msg_abf_itf_attach_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_abf_itf_attach_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_abf_itf_attach_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_abf_itf_attach_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_abf_policy_add_del* vapi_alloc_abf_policy_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_abf_policy_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_abf_policy_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_abf_policy_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_abf_policy_add_del);

  return msg;
}

static inline vapi_error_e vapi_abf_policy_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_abf_policy_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_abf_policy_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_abf_policy_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_abf_policy_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_abf_policy_dump* vapi_alloc_abf_policy_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_abf_policy_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_abf_policy_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_abf_policy_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_abf_policy_dump);

  return msg;
}

static inline vapi_error_e vapi_abf_policy_dump(struct vapi_ctx_s *ctx,
  vapi_msg_abf_policy_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_abf_policy_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_abf_policy_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_abf_policy_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_abf_plugin_get_version_reply()
{
  static const char name[] = "abf_plugin_get_version_reply";
  static const char name_with_crc[] = "abf_plugin_get_version_reply_9b32cf86";
  static vapi_message_desc_t __vapi_metadata_abf_plugin_get_version_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_abf_plugin_get_version_reply, payload),
    sizeof(vapi_msg_abf_plugin_get_version_reply),
    (generic_swap_fn_t)vapi_msg_abf_plugin_get_version_reply_hton,
    (generic_swap_fn_t)vapi_msg_abf_plugin_get_version_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_plugin_get_version_reply = vapi_register_msg(&__vapi_metadata_abf_plugin_get_version_reply);
  VAPI_DBG("Assigned msg id %d to abf_plugin_get_version_reply", vapi_msg_id_abf_plugin_get_version_reply);
}

static void __attribute__((constructor)) __vapi_constructor_abf_itf_attach_add_del()
{
  static const char name[] = "abf_itf_attach_add_del";
  static const char name_with_crc[] = "abf_itf_attach_add_del_b0b50ab1";
  static vapi_message_desc_t __vapi_metadata_abf_itf_attach_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_abf_itf_attach_add_del, payload),
    sizeof(vapi_msg_abf_itf_attach_add_del),
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_add_del_hton,
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_itf_attach_add_del = vapi_register_msg(&__vapi_metadata_abf_itf_attach_add_del);
  VAPI_DBG("Assigned msg id %d to abf_itf_attach_add_del", vapi_msg_id_abf_itf_attach_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_abf_plugin_get_version()
{
  static const char name[] = "abf_plugin_get_version";
  static const char name_with_crc[] = "abf_plugin_get_version_51077d14";
  static vapi_message_desc_t __vapi_metadata_abf_plugin_get_version = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_abf_plugin_get_version),
    (generic_swap_fn_t)vapi_msg_abf_plugin_get_version_hton,
    (generic_swap_fn_t)vapi_msg_abf_plugin_get_version_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_plugin_get_version = vapi_register_msg(&__vapi_metadata_abf_plugin_get_version);
  VAPI_DBG("Assigned msg id %d to abf_plugin_get_version", vapi_msg_id_abf_plugin_get_version);
}

static void __attribute__((constructor)) __vapi_constructor_abf_itf_attach_dump()
{
  static const char name[] = "abf_itf_attach_dump";
  static const char name_with_crc[] = "abf_itf_attach_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_abf_itf_attach_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_abf_itf_attach_dump),
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_dump_hton,
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_itf_attach_dump = vapi_register_msg(&__vapi_metadata_abf_itf_attach_dump);
  VAPI_DBG("Assigned msg id %d to abf_itf_attach_dump", vapi_msg_id_abf_itf_attach_dump);
}

static void __attribute__((constructor)) __vapi_constructor_abf_itf_attach_add_del_reply()
{
  static const char name[] = "abf_itf_attach_add_del_reply";
  static const char name_with_crc[] = "abf_itf_attach_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_abf_itf_attach_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_abf_itf_attach_add_del_reply, payload),
    sizeof(vapi_msg_abf_itf_attach_add_del_reply),
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_itf_attach_add_del_reply = vapi_register_msg(&__vapi_metadata_abf_itf_attach_add_del_reply);
  VAPI_DBG("Assigned msg id %d to abf_itf_attach_add_del_reply", vapi_msg_id_abf_itf_attach_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_abf_policy_add_del_reply()
{
  static const char name[] = "abf_policy_add_del_reply";
  static const char name_with_crc[] = "abf_policy_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_abf_policy_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_abf_policy_add_del_reply, payload),
    sizeof(vapi_msg_abf_policy_add_del_reply),
    (generic_swap_fn_t)vapi_msg_abf_policy_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_abf_policy_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_policy_add_del_reply = vapi_register_msg(&__vapi_metadata_abf_policy_add_del_reply);
  VAPI_DBG("Assigned msg id %d to abf_policy_add_del_reply", vapi_msg_id_abf_policy_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_abf_policy_add_del()
{
  static const char name[] = "abf_policy_add_del";
  static const char name_with_crc[] = "abf_policy_add_del_40432d41";
  static vapi_message_desc_t __vapi_metadata_abf_policy_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_abf_policy_add_del, payload),
    sizeof(vapi_msg_abf_policy_add_del),
    (generic_swap_fn_t)vapi_msg_abf_policy_add_del_hton,
    (generic_swap_fn_t)vapi_msg_abf_policy_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_policy_add_del = vapi_register_msg(&__vapi_metadata_abf_policy_add_del);
  VAPI_DBG("Assigned msg id %d to abf_policy_add_del", vapi_msg_id_abf_policy_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_abf_policy_dump()
{
  static const char name[] = "abf_policy_dump";
  static const char name_with_crc[] = "abf_policy_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_abf_policy_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_abf_policy_dump),
    (generic_swap_fn_t)vapi_msg_abf_policy_dump_hton,
    (generic_swap_fn_t)vapi_msg_abf_policy_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_policy_dump = vapi_register_msg(&__vapi_metadata_abf_policy_dump);
  VAPI_DBG("Assigned msg id %d to abf_policy_dump", vapi_msg_id_abf_policy_dump);
}

static void __attribute__((constructor)) __vapi_constructor_abf_itf_attach_details()
{
  static const char name[] = "abf_itf_attach_details";
  static const char name_with_crc[] = "abf_itf_attach_details_999006a7";
  static vapi_message_desc_t __vapi_metadata_abf_itf_attach_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_abf_itf_attach_details, payload),
    sizeof(vapi_msg_abf_itf_attach_details),
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_details_hton,
    (generic_swap_fn_t)vapi_msg_abf_itf_attach_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_itf_attach_details = vapi_register_msg(&__vapi_metadata_abf_itf_attach_details);
  VAPI_DBG("Assigned msg id %d to abf_itf_attach_details", vapi_msg_id_abf_itf_attach_details);
}

static void __attribute__((constructor)) __vapi_constructor_abf_policy_details()
{
  static const char name[] = "abf_policy_details";
  static const char name_with_crc[] = "abf_policy_details_ca17332a";
  static vapi_message_desc_t __vapi_metadata_abf_policy_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_abf_policy_details, payload),
    sizeof(vapi_msg_abf_policy_details),
    (generic_swap_fn_t)vapi_msg_abf_policy_details_hton,
    (generic_swap_fn_t)vapi_msg_abf_policy_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_abf_policy_details = vapi_register_msg(&__vapi_metadata_abf_policy_details);
  VAPI_DBG("Assigned msg id %d to abf_policy_details", vapi_msg_id_abf_policy_details);
}


static inline void vapi_set_vapi_msg_abf_plugin_get_version_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_abf_plugin_get_version_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_abf_plugin_get_version_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_abf_itf_attach_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_abf_itf_attach_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_abf_itf_attach_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_abf_policy_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_abf_policy_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_abf_policy_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_abf_itf_attach_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_abf_itf_attach_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_abf_itf_attach_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_abf_policy_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_abf_policy_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_abf_policy_details, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
