#ifndef __included_bier_api_json
#define __included_bier_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_bier_imp_dump;
extern vapi_msg_id_t vapi_msg_id_bier_disp_table_details;
extern vapi_msg_id_t vapi_msg_id_bier_disp_entry_add_del;
extern vapi_msg_id_t vapi_msg_id_bier_table_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_bier_imp_del;
extern vapi_msg_id_t vapi_msg_id_bier_table_details;
extern vapi_msg_id_t vapi_msg_id_bier_route_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_bier_imp_del_reply;
extern vapi_msg_id_t vapi_msg_id_bier_route_dump;
extern vapi_msg_id_t vapi_msg_id_bier_table_add_del;
extern vapi_msg_id_t vapi_msg_id_bier_route_add_del;
extern vapi_msg_id_t vapi_msg_id_bier_disp_entry_dump;
extern vapi_msg_id_t vapi_msg_id_bier_disp_entry_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_bier_imp_add;
extern vapi_msg_id_t vapi_msg_id_bier_disp_entry_details;
extern vapi_msg_id_t vapi_msg_id_bier_disp_table_add_del;
extern vapi_msg_id_t vapi_msg_id_bier_route_details;
extern vapi_msg_id_t vapi_msg_id_bier_imp_details;
extern vapi_msg_id_t vapi_msg_id_bier_imp_add_reply;
extern vapi_msg_id_t vapi_msg_id_bier_table_dump;
extern vapi_msg_id_t vapi_msg_id_bier_disp_table_dump;
extern vapi_msg_id_t vapi_msg_id_bier_disp_table_add_del_reply;

#define DEFINE_VAPI_MSG_IDS_BIER_API_JSON\
  vapi_msg_id_t vapi_msg_id_bier_imp_dump;\
  vapi_msg_id_t vapi_msg_id_bier_disp_table_details;\
  vapi_msg_id_t vapi_msg_id_bier_disp_entry_add_del;\
  vapi_msg_id_t vapi_msg_id_bier_table_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_bier_imp_del;\
  vapi_msg_id_t vapi_msg_id_bier_table_details;\
  vapi_msg_id_t vapi_msg_id_bier_route_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_bier_imp_del_reply;\
  vapi_msg_id_t vapi_msg_id_bier_route_dump;\
  vapi_msg_id_t vapi_msg_id_bier_table_add_del;\
  vapi_msg_id_t vapi_msg_id_bier_route_add_del;\
  vapi_msg_id_t vapi_msg_id_bier_disp_entry_dump;\
  vapi_msg_id_t vapi_msg_id_bier_disp_entry_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_bier_imp_add;\
  vapi_msg_id_t vapi_msg_id_bier_disp_entry_details;\
  vapi_msg_id_t vapi_msg_id_bier_disp_table_add_del;\
  vapi_msg_id_t vapi_msg_id_bier_route_details;\
  vapi_msg_id_t vapi_msg_id_bier_imp_details;\
  vapi_msg_id_t vapi_msg_id_bier_imp_add_reply;\
  vapi_msg_id_t vapi_msg_id_bier_table_dump;\
  vapi_msg_id_t vapi_msg_id_bier_disp_table_dump;\
  vapi_msg_id_t vapi_msg_id_bier_disp_table_add_del_reply;


#ifndef defined_vapi_type_fib_mpls_label
#define defined_vapi_type_fib_mpls_label
typedef struct __attribute__((__packed__)) {
  u8 is_uniform;
  u32 label;
  u8 ttl;
  u8 exp;
} vapi_type_fib_mpls_label;
#endif

#ifndef defined_vapi_type_fib_path
#define defined_vapi_type_fib_path
typedef struct __attribute__((__packed__)) {
  u32 sw_if_index;
  u32 table_id;
  u8 weight;
  u8 preference;
  u8 is_local;
  u8 is_drop;
  u8 is_udp_encap;
  u8 is_unreach;
  u8 is_prohibit;
  u8 is_resolve_host;
  u8 is_resolve_attached;
  u8 is_dvr;
  u8 is_source_lookup;
  u8 afi;
  u8 next_hop[16];
  u32 next_hop_id;
  u32 rpf_id;
  u32 via_label;
  u8 n_labels;
  vapi_type_fib_mpls_label label_stack[16];
} vapi_type_fib_path;
#endif

#ifndef defined_vapi_type_bier_table_id
#define defined_vapi_type_bier_table_id
typedef struct __attribute__((__packed__)) {
  u8 bt_set;
  u8 bt_sub_domain;
  u8 bt_hdr_len_id;
} vapi_type_bier_table_id;
#endif

#ifndef defined_vapi_payload_bier_imp_dump
#define defined_vapi_payload_bier_imp_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_bier_imp_dump;
#endif

#ifndef defined_vapi_payload_bier_disp_table_details
#define defined_vapi_payload_bier_disp_table_details
typedef struct __attribute__ ((__packed__)) {
  u32 bdt_tbl_id; 
} vapi_payload_bier_disp_table_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_disp_table_details payload;
} vapi_msg_bier_disp_table_details;
#endif

#ifndef defined_vapi_payload_bier_disp_entry_add_del
#define defined_vapi_payload_bier_disp_entry_add_del
typedef struct __attribute__ ((__packed__)) {
  u16 bde_bp;
  u32 bde_tbl_id;
  u8 bde_is_add;
  u8 bde_payload_proto;
  u8 bde_n_paths;
  vapi_type_fib_path bde_paths[0]; 
} vapi_payload_bier_disp_entry_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_disp_entry_add_del payload;
} vapi_msg_bier_disp_entry_add_del;
#endif

#ifndef defined_vapi_payload_bier_table_add_del_reply
#define defined_vapi_payload_bier_table_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bier_table_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_table_add_del_reply payload;
} vapi_msg_bier_table_add_del_reply;
#endif

#ifndef defined_vapi_payload_bier_imp_del
#define defined_vapi_payload_bier_imp_del
typedef struct __attribute__ ((__packed__)) {
  u32 bi_index; 
} vapi_payload_bier_imp_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_imp_del payload;
} vapi_msg_bier_imp_del;
#endif

#ifndef defined_vapi_payload_bier_table_details
#define defined_vapi_payload_bier_table_details
typedef struct __attribute__ ((__packed__)) {
  u32 bt_label;
  vapi_type_bier_table_id bt_tbl_id; 
} vapi_payload_bier_table_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_table_details payload;
} vapi_msg_bier_table_details;
#endif

#ifndef defined_vapi_payload_bier_route_add_del_reply
#define defined_vapi_payload_bier_route_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bier_route_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_route_add_del_reply payload;
} vapi_msg_bier_route_add_del_reply;
#endif

#ifndef defined_vapi_payload_bier_imp_del_reply
#define defined_vapi_payload_bier_imp_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bier_imp_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_imp_del_reply payload;
} vapi_msg_bier_imp_del_reply;
#endif

#ifndef defined_vapi_payload_bier_route_dump
#define defined_vapi_payload_bier_route_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_bier_table_id br_tbl_id; 
} vapi_payload_bier_route_dump;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_route_dump payload;
} vapi_msg_bier_route_dump;
#endif

#ifndef defined_vapi_payload_bier_table_add_del
#define defined_vapi_payload_bier_table_add_del
typedef struct __attribute__ ((__packed__)) {
  vapi_type_bier_table_id bt_tbl_id;
  u32 bt_label;
  u8 bt_is_add; 
} vapi_payload_bier_table_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_table_add_del payload;
} vapi_msg_bier_table_add_del;
#endif

#ifndef defined_vapi_payload_bier_route_add_del
#define defined_vapi_payload_bier_route_add_del
typedef struct __attribute__ ((__packed__)) {
  u32 br_bp;
  u8 br_is_add;
  u8 br_is_replace;
  vapi_type_bier_table_id br_tbl_id;
  u8 br_n_paths;
  vapi_type_fib_path br_paths[0]; 
} vapi_payload_bier_route_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_route_add_del payload;
} vapi_msg_bier_route_add_del;
#endif

#ifndef defined_vapi_payload_bier_disp_entry_dump
#define defined_vapi_payload_bier_disp_entry_dump
typedef struct __attribute__ ((__packed__)) {
  u32 bde_tbl_id; 
} vapi_payload_bier_disp_entry_dump;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_disp_entry_dump payload;
} vapi_msg_bier_disp_entry_dump;
#endif

#ifndef defined_vapi_payload_bier_disp_entry_add_del_reply
#define defined_vapi_payload_bier_disp_entry_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bier_disp_entry_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_disp_entry_add_del_reply payload;
} vapi_msg_bier_disp_entry_add_del_reply;
#endif

#ifndef defined_vapi_payload_bier_imp_add
#define defined_vapi_payload_bier_imp_add
typedef struct __attribute__ ((__packed__)) {
  vapi_type_bier_table_id bi_tbl_id;
  u16 bi_src;
  u8 bi_n_bytes;
  u8 bi_bytes[0]; 
} vapi_payload_bier_imp_add;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_imp_add payload;
} vapi_msg_bier_imp_add;
#endif

#ifndef defined_vapi_payload_bier_disp_entry_details
#define defined_vapi_payload_bier_disp_entry_details
typedef struct __attribute__ ((__packed__)) {
  u16 bde_bp;
  u32 bde_tbl_id;
  u8 bde_is_add;
  u8 bde_payload_proto;
  u8 bde_n_paths;
  vapi_type_fib_path bde_paths[0]; 
} vapi_payload_bier_disp_entry_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_disp_entry_details payload;
} vapi_msg_bier_disp_entry_details;
#endif

#ifndef defined_vapi_payload_bier_disp_table_add_del
#define defined_vapi_payload_bier_disp_table_add_del
typedef struct __attribute__ ((__packed__)) {
  u32 bdt_tbl_id;
  u8 bdt_is_add; 
} vapi_payload_bier_disp_table_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_disp_table_add_del payload;
} vapi_msg_bier_disp_table_add_del;
#endif

#ifndef defined_vapi_payload_bier_route_details
#define defined_vapi_payload_bier_route_details
typedef struct __attribute__ ((__packed__)) {
  u16 br_bp;
  vapi_type_bier_table_id br_tbl_id;
  u32 br_n_paths;
  vapi_type_fib_path br_paths[0]; 
} vapi_payload_bier_route_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_route_details payload;
} vapi_msg_bier_route_details;
#endif

#ifndef defined_vapi_payload_bier_imp_details
#define defined_vapi_payload_bier_imp_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_bier_table_id bi_tbl_id;
  u16 bi_src;
  u8 bi_n_bytes;
  u8 bi_bytes[0]; 
} vapi_payload_bier_imp_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bier_imp_details payload;
} vapi_msg_bier_imp_details;
#endif

#ifndef defined_vapi_payload_bier_imp_add_reply
#define defined_vapi_payload_bier_imp_add_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 bi_index; 
} vapi_payload_bier_imp_add_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_imp_add_reply payload;
} vapi_msg_bier_imp_add_reply;
#endif

#ifndef defined_vapi_payload_bier_table_dump
#define defined_vapi_payload_bier_table_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_bier_table_dump;
#endif

#ifndef defined_vapi_payload_bier_disp_table_dump
#define defined_vapi_payload_bier_disp_table_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_bier_disp_table_dump;
#endif

#ifndef defined_vapi_payload_bier_disp_table_add_del_reply
#define defined_vapi_payload_bier_disp_table_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bier_disp_table_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bier_disp_table_add_del_reply payload;
} vapi_msg_bier_disp_table_add_del_reply;
#endif


#ifndef defined_inline_vapi_type_fib_mpls_label
#define defined_inline_vapi_type_fib_mpls_label
static inline void vapi_type_fib_mpls_label_hton(vapi_type_fib_mpls_label *msg)
{
  msg->label = htobe32(msg->label);
}

static inline void vapi_type_fib_mpls_label_ntoh(vapi_type_fib_mpls_label *msg)
{
  msg->label = be32toh(msg->label);
}
#endif

#ifndef defined_inline_vapi_type_fib_path
#define defined_inline_vapi_type_fib_path
static inline void vapi_type_fib_path_hton(vapi_type_fib_path *msg)
{
  msg->sw_if_index = htobe32(msg->sw_if_index);
  msg->table_id = htobe32(msg->table_id);
  msg->next_hop_id = htobe32(msg->next_hop_id);
  msg->rpf_id = htobe32(msg->rpf_id);
  msg->via_label = htobe32(msg->via_label);
  do { unsigned i; for (i = 0; i < 16; ++i) { vapi_type_fib_mpls_label_hton(&msg->label_stack[i]); } } while(0);
}

static inline void vapi_type_fib_path_ntoh(vapi_type_fib_path *msg)
{
  msg->sw_if_index = be32toh(msg->sw_if_index);
  msg->table_id = be32toh(msg->table_id);
  msg->next_hop_id = be32toh(msg->next_hop_id);
  msg->rpf_id = be32toh(msg->rpf_id);
  msg->via_label = be32toh(msg->via_label);
  do { unsigned i; for (i = 0; i < 16; ++i) { vapi_type_fib_mpls_label_ntoh(&msg->label_stack[i]); } } while(0);
}
#endif

#ifndef defined_inline_vapi_type_bier_table_id
#define defined_inline_vapi_type_bier_table_id
static inline void vapi_type_bier_table_id_hton(vapi_type_bier_table_id *msg)
{

}

static inline void vapi_type_bier_table_id_ntoh(vapi_type_bier_table_id *msg)
{

}
#endif

static inline uword vapi_calc_bier_imp_dump_msg_size(vapi_msg_bier_imp_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_imp_dump_hton(vapi_msg_bier_imp_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_bier_imp_dump_ntoh(vapi_msg_bier_imp_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_bier_disp_table_details_payload_hton(vapi_payload_bier_disp_table_details *payload)
{
  payload->bdt_tbl_id = htobe32(payload->bdt_tbl_id);
}

static inline void vapi_msg_bier_disp_table_details_payload_ntoh(vapi_payload_bier_disp_table_details *payload)
{
  payload->bdt_tbl_id = be32toh(payload->bdt_tbl_id);
}

static inline uword vapi_calc_bier_disp_table_details_msg_size(vapi_msg_bier_disp_table_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_disp_table_details_hton(vapi_msg_bier_disp_table_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_disp_table_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_table_details_ntoh(vapi_msg_bier_disp_table_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_disp_table_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_add_del_payload_hton(vapi_payload_bier_disp_entry_add_del *payload)
{
  payload->bde_bp = htobe16(payload->bde_bp);
  payload->bde_tbl_id = htobe32(payload->bde_tbl_id);
  do { unsigned i; for (i = 0; i < payload->bde_n_paths; ++i) { vapi_type_fib_path_hton(&payload->bde_paths[i]); } } while(0);
}

static inline void vapi_msg_bier_disp_entry_add_del_payload_ntoh(vapi_payload_bier_disp_entry_add_del *payload)
{
  payload->bde_bp = be16toh(payload->bde_bp);
  payload->bde_tbl_id = be32toh(payload->bde_tbl_id);
  do { unsigned i; for (i = 0; i < payload->bde_n_paths; ++i) { vapi_type_fib_path_ntoh(&payload->bde_paths[i]); } } while(0);
}

static inline uword vapi_calc_bier_disp_entry_add_del_msg_size(vapi_msg_bier_disp_entry_add_del *msg)
{
  return sizeof(*msg)+ msg->payload.bde_n_paths * sizeof(msg->payload.bde_paths[0]);
}

static inline void vapi_msg_bier_disp_entry_add_del_hton(vapi_msg_bier_disp_entry_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_disp_entry_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_add_del_ntoh(vapi_msg_bier_disp_entry_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_disp_entry_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_table_add_del_reply_payload_hton(vapi_payload_bier_table_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bier_table_add_del_reply_payload_ntoh(vapi_payload_bier_table_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bier_table_add_del_reply_msg_size(vapi_msg_bier_table_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_table_add_del_reply_hton(vapi_msg_bier_table_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_table_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_table_add_del_reply_ntoh(vapi_msg_bier_table_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_table_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_imp_del_payload_hton(vapi_payload_bier_imp_del *payload)
{
  payload->bi_index = htobe32(payload->bi_index);
}

static inline void vapi_msg_bier_imp_del_payload_ntoh(vapi_payload_bier_imp_del *payload)
{
  payload->bi_index = be32toh(payload->bi_index);
}

static inline uword vapi_calc_bier_imp_del_msg_size(vapi_msg_bier_imp_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_imp_del_hton(vapi_msg_bier_imp_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_imp_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_imp_del_ntoh(vapi_msg_bier_imp_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_imp_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_table_details_payload_hton(vapi_payload_bier_table_details *payload)
{
  payload->bt_label = htobe32(payload->bt_label);
}

static inline void vapi_msg_bier_table_details_payload_ntoh(vapi_payload_bier_table_details *payload)
{
  payload->bt_label = be32toh(payload->bt_label);
}

static inline uword vapi_calc_bier_table_details_msg_size(vapi_msg_bier_table_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_table_details_hton(vapi_msg_bier_table_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_table_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_table_details_ntoh(vapi_msg_bier_table_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_table_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_route_add_del_reply_payload_hton(vapi_payload_bier_route_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bier_route_add_del_reply_payload_ntoh(vapi_payload_bier_route_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bier_route_add_del_reply_msg_size(vapi_msg_bier_route_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_route_add_del_reply_hton(vapi_msg_bier_route_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_route_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_route_add_del_reply_ntoh(vapi_msg_bier_route_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_route_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_imp_del_reply_payload_hton(vapi_payload_bier_imp_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bier_imp_del_reply_payload_ntoh(vapi_payload_bier_imp_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bier_imp_del_reply_msg_size(vapi_msg_bier_imp_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_imp_del_reply_hton(vapi_msg_bier_imp_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_imp_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_imp_del_reply_ntoh(vapi_msg_bier_imp_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_imp_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_route_dump_payload_hton(vapi_payload_bier_route_dump *payload)
{

}

static inline void vapi_msg_bier_route_dump_payload_ntoh(vapi_payload_bier_route_dump *payload)
{

}

static inline uword vapi_calc_bier_route_dump_msg_size(vapi_msg_bier_route_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_route_dump_hton(vapi_msg_bier_route_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_route_dump_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_route_dump_ntoh(vapi_msg_bier_route_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_route_dump_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_table_add_del_payload_hton(vapi_payload_bier_table_add_del *payload)
{
  payload->bt_label = htobe32(payload->bt_label);
}

static inline void vapi_msg_bier_table_add_del_payload_ntoh(vapi_payload_bier_table_add_del *payload)
{
  payload->bt_label = be32toh(payload->bt_label);
}

static inline uword vapi_calc_bier_table_add_del_msg_size(vapi_msg_bier_table_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_table_add_del_hton(vapi_msg_bier_table_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_table_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_table_add_del_ntoh(vapi_msg_bier_table_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_table_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_route_add_del_payload_hton(vapi_payload_bier_route_add_del *payload)
{
  payload->br_bp = htobe32(payload->br_bp);
  do { unsigned i; for (i = 0; i < payload->br_n_paths; ++i) { vapi_type_fib_path_hton(&payload->br_paths[i]); } } while(0);
}

static inline void vapi_msg_bier_route_add_del_payload_ntoh(vapi_payload_bier_route_add_del *payload)
{
  payload->br_bp = be32toh(payload->br_bp);
  do { unsigned i; for (i = 0; i < payload->br_n_paths; ++i) { vapi_type_fib_path_ntoh(&payload->br_paths[i]); } } while(0);
}

static inline uword vapi_calc_bier_route_add_del_msg_size(vapi_msg_bier_route_add_del *msg)
{
  return sizeof(*msg)+ msg->payload.br_n_paths * sizeof(msg->payload.br_paths[0]);
}

static inline void vapi_msg_bier_route_add_del_hton(vapi_msg_bier_route_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_route_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_route_add_del_ntoh(vapi_msg_bier_route_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_route_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_dump_payload_hton(vapi_payload_bier_disp_entry_dump *payload)
{
  payload->bde_tbl_id = htobe32(payload->bde_tbl_id);
}

static inline void vapi_msg_bier_disp_entry_dump_payload_ntoh(vapi_payload_bier_disp_entry_dump *payload)
{
  payload->bde_tbl_id = be32toh(payload->bde_tbl_id);
}

static inline uword vapi_calc_bier_disp_entry_dump_msg_size(vapi_msg_bier_disp_entry_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_disp_entry_dump_hton(vapi_msg_bier_disp_entry_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_disp_entry_dump_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_dump_ntoh(vapi_msg_bier_disp_entry_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_disp_entry_dump_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_add_del_reply_payload_hton(vapi_payload_bier_disp_entry_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bier_disp_entry_add_del_reply_payload_ntoh(vapi_payload_bier_disp_entry_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bier_disp_entry_add_del_reply_msg_size(vapi_msg_bier_disp_entry_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_disp_entry_add_del_reply_hton(vapi_msg_bier_disp_entry_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_disp_entry_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_add_del_reply_ntoh(vapi_msg_bier_disp_entry_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_disp_entry_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_imp_add_payload_hton(vapi_payload_bier_imp_add *payload)
{
  payload->bi_src = htobe16(payload->bi_src);
}

static inline void vapi_msg_bier_imp_add_payload_ntoh(vapi_payload_bier_imp_add *payload)
{
  payload->bi_src = be16toh(payload->bi_src);
}

static inline uword vapi_calc_bier_imp_add_msg_size(vapi_msg_bier_imp_add *msg)
{
  return sizeof(*msg)+ msg->payload.bi_n_bytes * sizeof(msg->payload.bi_bytes[0]);
}

static inline void vapi_msg_bier_imp_add_hton(vapi_msg_bier_imp_add *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_add'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_imp_add_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_imp_add_ntoh(vapi_msg_bier_imp_add *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_add'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_imp_add_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_details_payload_hton(vapi_payload_bier_disp_entry_details *payload)
{
  payload->bde_bp = htobe16(payload->bde_bp);
  payload->bde_tbl_id = htobe32(payload->bde_tbl_id);
  do { unsigned i; for (i = 0; i < payload->bde_n_paths; ++i) { vapi_type_fib_path_hton(&payload->bde_paths[i]); } } while(0);
}

static inline void vapi_msg_bier_disp_entry_details_payload_ntoh(vapi_payload_bier_disp_entry_details *payload)
{
  payload->bde_bp = be16toh(payload->bde_bp);
  payload->bde_tbl_id = be32toh(payload->bde_tbl_id);
  do { unsigned i; for (i = 0; i < payload->bde_n_paths; ++i) { vapi_type_fib_path_ntoh(&payload->bde_paths[i]); } } while(0);
}

static inline uword vapi_calc_bier_disp_entry_details_msg_size(vapi_msg_bier_disp_entry_details *msg)
{
  return sizeof(*msg)+ msg->payload.bde_n_paths * sizeof(msg->payload.bde_paths[0]);
}

static inline void vapi_msg_bier_disp_entry_details_hton(vapi_msg_bier_disp_entry_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_disp_entry_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_entry_details_ntoh(vapi_msg_bier_disp_entry_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_entry_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_disp_entry_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_disp_table_add_del_payload_hton(vapi_payload_bier_disp_table_add_del *payload)
{
  payload->bdt_tbl_id = htobe32(payload->bdt_tbl_id);
}

static inline void vapi_msg_bier_disp_table_add_del_payload_ntoh(vapi_payload_bier_disp_table_add_del *payload)
{
  payload->bdt_tbl_id = be32toh(payload->bdt_tbl_id);
}

static inline uword vapi_calc_bier_disp_table_add_del_msg_size(vapi_msg_bier_disp_table_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_disp_table_add_del_hton(vapi_msg_bier_disp_table_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_disp_table_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_table_add_del_ntoh(vapi_msg_bier_disp_table_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_disp_table_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_route_details_payload_hton(vapi_payload_bier_route_details *payload)
{
  payload->br_bp = htobe16(payload->br_bp);
  payload->br_n_paths = htobe32(payload->br_n_paths);
  do { unsigned i; for (i = 0; i < be32toh(payload->br_n_paths); ++i) { vapi_type_fib_path_hton(&payload->br_paths[i]); } } while(0);
}

static inline void vapi_msg_bier_route_details_payload_ntoh(vapi_payload_bier_route_details *payload)
{
  payload->br_bp = be16toh(payload->br_bp);
  payload->br_n_paths = be32toh(payload->br_n_paths);
  do { unsigned i; for (i = 0; i < payload->br_n_paths; ++i) { vapi_type_fib_path_ntoh(&payload->br_paths[i]); } } while(0);
}

static inline uword vapi_calc_bier_route_details_msg_size(vapi_msg_bier_route_details *msg)
{
  return sizeof(*msg)+ msg->payload.br_n_paths * sizeof(msg->payload.br_paths[0]);
}

static inline void vapi_msg_bier_route_details_hton(vapi_msg_bier_route_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_details'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_route_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_route_details_ntoh(vapi_msg_bier_route_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_route_details'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_route_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_imp_details_payload_hton(vapi_payload_bier_imp_details *payload)
{
  payload->bi_src = htobe16(payload->bi_src);
}

static inline void vapi_msg_bier_imp_details_payload_ntoh(vapi_payload_bier_imp_details *payload)
{
  payload->bi_src = be16toh(payload->bi_src);
}

static inline uword vapi_calc_bier_imp_details_msg_size(vapi_msg_bier_imp_details *msg)
{
  return sizeof(*msg)+ msg->payload.bi_n_bytes * sizeof(msg->payload.bi_bytes[0]);
}

static inline void vapi_msg_bier_imp_details_hton(vapi_msg_bier_imp_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_details'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bier_imp_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_imp_details_ntoh(vapi_msg_bier_imp_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_details'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bier_imp_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bier_imp_add_reply_payload_hton(vapi_payload_bier_imp_add_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->bi_index = htobe32(payload->bi_index);
}

static inline void vapi_msg_bier_imp_add_reply_payload_ntoh(vapi_payload_bier_imp_add_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->bi_index = be32toh(payload->bi_index);
}

static inline uword vapi_calc_bier_imp_add_reply_msg_size(vapi_msg_bier_imp_add_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_imp_add_reply_hton(vapi_msg_bier_imp_add_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_add_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_imp_add_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_imp_add_reply_ntoh(vapi_msg_bier_imp_add_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_imp_add_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_imp_add_reply_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_bier_table_dump_msg_size(vapi_msg_bier_table_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_table_dump_hton(vapi_msg_bier_table_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_bier_table_dump_ntoh(vapi_msg_bier_table_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_table_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline uword vapi_calc_bier_disp_table_dump_msg_size(vapi_msg_bier_disp_table_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_disp_table_dump_hton(vapi_msg_bier_disp_table_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_bier_disp_table_dump_ntoh(vapi_msg_bier_disp_table_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_bier_disp_table_add_del_reply_payload_hton(vapi_payload_bier_disp_table_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bier_disp_table_add_del_reply_payload_ntoh(vapi_payload_bier_disp_table_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bier_disp_table_add_del_reply_msg_size(vapi_msg_bier_disp_table_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bier_disp_table_add_del_reply_hton(vapi_msg_bier_disp_table_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bier_disp_table_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bier_disp_table_add_del_reply_ntoh(vapi_msg_bier_disp_table_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bier_disp_table_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bier_disp_table_add_del_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_bier_imp_dump* vapi_alloc_bier_imp_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_imp_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_imp_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_imp_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_imp_dump);

  return msg;
}

static inline vapi_error_e vapi_bier_imp_dump(struct vapi_ctx_s *ctx,
  vapi_msg_bier_imp_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_imp_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_imp_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_imp_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_disp_entry_add_del* vapi_alloc_bier_disp_entry_add_del(struct vapi_ctx_s *ctx, size_t bde_paths_array_size)
{
  vapi_msg_bier_disp_entry_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_disp_entry_add_del) + sizeof(msg->payload.bde_paths[0]) * bde_paths_array_size;
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_disp_entry_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_disp_entry_add_del);
  msg->payload.bde_n_paths = bde_paths_array_size;
  return msg;
}

static inline vapi_error_e vapi_bier_disp_entry_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_bier_disp_entry_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_disp_entry_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_disp_entry_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_disp_entry_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_imp_del* vapi_alloc_bier_imp_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_imp_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_imp_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_imp_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_imp_del);

  return msg;
}

static inline vapi_error_e vapi_bier_imp_del(struct vapi_ctx_s *ctx,
  vapi_msg_bier_imp_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_imp_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_imp_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_imp_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_route_dump* vapi_alloc_bier_route_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_route_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_route_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_route_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_route_dump);

  return msg;
}

static inline vapi_error_e vapi_bier_route_dump(struct vapi_ctx_s *ctx,
  vapi_msg_bier_route_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_route_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_route_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_route_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_table_add_del* vapi_alloc_bier_table_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_table_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_table_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_table_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_table_add_del);

  return msg;
}

static inline vapi_error_e vapi_bier_table_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_bier_table_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_table_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_table_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_table_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_route_add_del* vapi_alloc_bier_route_add_del(struct vapi_ctx_s *ctx, size_t br_paths_array_size)
{
  vapi_msg_bier_route_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_route_add_del) + sizeof(msg->payload.br_paths[0]) * br_paths_array_size;
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_route_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_route_add_del);
  msg->payload.br_n_paths = br_paths_array_size;
  return msg;
}

static inline vapi_error_e vapi_bier_route_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_bier_route_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_route_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_route_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_route_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_disp_entry_dump* vapi_alloc_bier_disp_entry_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_disp_entry_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_disp_entry_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_disp_entry_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_disp_entry_dump);

  return msg;
}

static inline vapi_error_e vapi_bier_disp_entry_dump(struct vapi_ctx_s *ctx,
  vapi_msg_bier_disp_entry_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_disp_entry_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_disp_entry_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_disp_entry_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_imp_add* vapi_alloc_bier_imp_add(struct vapi_ctx_s *ctx, size_t bi_bytes_array_size)
{
  vapi_msg_bier_imp_add *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_imp_add) + sizeof(msg->payload.bi_bytes[0]) * bi_bytes_array_size;
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_imp_add*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_imp_add);
  msg->payload.bi_n_bytes = bi_bytes_array_size;
  return msg;
}

static inline vapi_error_e vapi_bier_imp_add(struct vapi_ctx_s *ctx,
  vapi_msg_bier_imp_add *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_imp_add_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_imp_add_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_imp_add_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_disp_table_add_del* vapi_alloc_bier_disp_table_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_disp_table_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_disp_table_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_disp_table_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_disp_table_add_del);

  return msg;
}

static inline vapi_error_e vapi_bier_disp_table_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_bier_disp_table_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_disp_table_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_disp_table_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_disp_table_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_table_dump* vapi_alloc_bier_table_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_table_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_table_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_table_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_table_dump);

  return msg;
}

static inline vapi_error_e vapi_bier_table_dump(struct vapi_ctx_s *ctx,
  vapi_msg_bier_table_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_table_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_table_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_table_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bier_disp_table_dump* vapi_alloc_bier_disp_table_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_bier_disp_table_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_bier_disp_table_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bier_disp_table_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bier_disp_table_dump);

  return msg;
}

static inline vapi_error_e vapi_bier_disp_table_dump(struct vapi_ctx_s *ctx,
  vapi_msg_bier_disp_table_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bier_disp_table_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bier_disp_table_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bier_disp_table_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_bier_imp_dump()
{
  static const char name[] = "bier_imp_dump";
  static const char name_with_crc[] = "bier_imp_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_bier_imp_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_bier_imp_dump),
    (generic_swap_fn_t)vapi_msg_bier_imp_dump_hton,
    (generic_swap_fn_t)vapi_msg_bier_imp_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_imp_dump = vapi_register_msg(&__vapi_metadata_bier_imp_dump);
  VAPI_DBG("Assigned msg id %d to bier_imp_dump", vapi_msg_id_bier_imp_dump);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_table_details()
{
  static const char name[] = "bier_disp_table_details";
  static const char name_with_crc[] = "bier_disp_table_details_d27942c0";
  static vapi_message_desc_t __vapi_metadata_bier_disp_table_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_disp_table_details, payload),
    sizeof(vapi_msg_bier_disp_table_details),
    (generic_swap_fn_t)vapi_msg_bier_disp_table_details_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_table_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_table_details = vapi_register_msg(&__vapi_metadata_bier_disp_table_details);
  VAPI_DBG("Assigned msg id %d to bier_disp_table_details", vapi_msg_id_bier_disp_table_details);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_entry_add_del()
{
  static const char name[] = "bier_disp_entry_add_del";
  static const char name_with_crc[] = "bier_disp_entry_add_del_4260a077";
  static vapi_message_desc_t __vapi_metadata_bier_disp_entry_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_disp_entry_add_del, payload),
    sizeof(vapi_msg_bier_disp_entry_add_del),
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_add_del_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_entry_add_del = vapi_register_msg(&__vapi_metadata_bier_disp_entry_add_del);
  VAPI_DBG("Assigned msg id %d to bier_disp_entry_add_del", vapi_msg_id_bier_disp_entry_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_bier_table_add_del_reply()
{
  static const char name[] = "bier_table_add_del_reply";
  static const char name_with_crc[] = "bier_table_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_bier_table_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_table_add_del_reply, payload),
    sizeof(vapi_msg_bier_table_add_del_reply),
    (generic_swap_fn_t)vapi_msg_bier_table_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_bier_table_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_table_add_del_reply = vapi_register_msg(&__vapi_metadata_bier_table_add_del_reply);
  VAPI_DBG("Assigned msg id %d to bier_table_add_del_reply", vapi_msg_id_bier_table_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bier_imp_del()
{
  static const char name[] = "bier_imp_del";
  static const char name_with_crc[] = "bier_imp_del_7d45edf6";
  static vapi_message_desc_t __vapi_metadata_bier_imp_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_imp_del, payload),
    sizeof(vapi_msg_bier_imp_del),
    (generic_swap_fn_t)vapi_msg_bier_imp_del_hton,
    (generic_swap_fn_t)vapi_msg_bier_imp_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_imp_del = vapi_register_msg(&__vapi_metadata_bier_imp_del);
  VAPI_DBG("Assigned msg id %d to bier_imp_del", vapi_msg_id_bier_imp_del);
}

static void __attribute__((constructor)) __vapi_constructor_bier_table_details()
{
  static const char name[] = "bier_table_details";
  static const char name_with_crc[] = "bier_table_details_b7a41e40";
  static vapi_message_desc_t __vapi_metadata_bier_table_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_table_details, payload),
    sizeof(vapi_msg_bier_table_details),
    (generic_swap_fn_t)vapi_msg_bier_table_details_hton,
    (generic_swap_fn_t)vapi_msg_bier_table_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_table_details = vapi_register_msg(&__vapi_metadata_bier_table_details);
  VAPI_DBG("Assigned msg id %d to bier_table_details", vapi_msg_id_bier_table_details);
}

static void __attribute__((constructor)) __vapi_constructor_bier_route_add_del_reply()
{
  static const char name[] = "bier_route_add_del_reply";
  static const char name_with_crc[] = "bier_route_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_bier_route_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_route_add_del_reply, payload),
    sizeof(vapi_msg_bier_route_add_del_reply),
    (generic_swap_fn_t)vapi_msg_bier_route_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_bier_route_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_route_add_del_reply = vapi_register_msg(&__vapi_metadata_bier_route_add_del_reply);
  VAPI_DBG("Assigned msg id %d to bier_route_add_del_reply", vapi_msg_id_bier_route_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bier_imp_del_reply()
{
  static const char name[] = "bier_imp_del_reply";
  static const char name_with_crc[] = "bier_imp_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_bier_imp_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_imp_del_reply, payload),
    sizeof(vapi_msg_bier_imp_del_reply),
    (generic_swap_fn_t)vapi_msg_bier_imp_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_bier_imp_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_imp_del_reply = vapi_register_msg(&__vapi_metadata_bier_imp_del_reply);
  VAPI_DBG("Assigned msg id %d to bier_imp_del_reply", vapi_msg_id_bier_imp_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bier_route_dump()
{
  static const char name[] = "bier_route_dump";
  static const char name_with_crc[] = "bier_route_dump_43af6370";
  static vapi_message_desc_t __vapi_metadata_bier_route_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_route_dump, payload),
    sizeof(vapi_msg_bier_route_dump),
    (generic_swap_fn_t)vapi_msg_bier_route_dump_hton,
    (generic_swap_fn_t)vapi_msg_bier_route_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_route_dump = vapi_register_msg(&__vapi_metadata_bier_route_dump);
  VAPI_DBG("Assigned msg id %d to bier_route_dump", vapi_msg_id_bier_route_dump);
}

static void __attribute__((constructor)) __vapi_constructor_bier_table_add_del()
{
  static const char name[] = "bier_table_add_del";
  static const char name_with_crc[] = "bier_table_add_del_4f7963b6";
  static vapi_message_desc_t __vapi_metadata_bier_table_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_table_add_del, payload),
    sizeof(vapi_msg_bier_table_add_del),
    (generic_swap_fn_t)vapi_msg_bier_table_add_del_hton,
    (generic_swap_fn_t)vapi_msg_bier_table_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_table_add_del = vapi_register_msg(&__vapi_metadata_bier_table_add_del);
  VAPI_DBG("Assigned msg id %d to bier_table_add_del", vapi_msg_id_bier_table_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_bier_route_add_del()
{
  static const char name[] = "bier_route_add_del";
  static const char name_with_crc[] = "bier_route_add_del_0b83f5d2";
  static vapi_message_desc_t __vapi_metadata_bier_route_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_route_add_del, payload),
    sizeof(vapi_msg_bier_route_add_del),
    (generic_swap_fn_t)vapi_msg_bier_route_add_del_hton,
    (generic_swap_fn_t)vapi_msg_bier_route_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_route_add_del = vapi_register_msg(&__vapi_metadata_bier_route_add_del);
  VAPI_DBG("Assigned msg id %d to bier_route_add_del", vapi_msg_id_bier_route_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_entry_dump()
{
  static const char name[] = "bier_disp_entry_dump";
  static const char name_with_crc[] = "bier_disp_entry_dump_b5fa54ad";
  static vapi_message_desc_t __vapi_metadata_bier_disp_entry_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_disp_entry_dump, payload),
    sizeof(vapi_msg_bier_disp_entry_dump),
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_dump_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_entry_dump = vapi_register_msg(&__vapi_metadata_bier_disp_entry_dump);
  VAPI_DBG("Assigned msg id %d to bier_disp_entry_dump", vapi_msg_id_bier_disp_entry_dump);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_entry_add_del_reply()
{
  static const char name[] = "bier_disp_entry_add_del_reply";
  static const char name_with_crc[] = "bier_disp_entry_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_bier_disp_entry_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_disp_entry_add_del_reply, payload),
    sizeof(vapi_msg_bier_disp_entry_add_del_reply),
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_entry_add_del_reply = vapi_register_msg(&__vapi_metadata_bier_disp_entry_add_del_reply);
  VAPI_DBG("Assigned msg id %d to bier_disp_entry_add_del_reply", vapi_msg_id_bier_disp_entry_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bier_imp_add()
{
  static const char name[] = "bier_imp_add";
  static const char name_with_crc[] = "bier_imp_add_5d62e9ce";
  static vapi_message_desc_t __vapi_metadata_bier_imp_add = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_imp_add, payload),
    sizeof(vapi_msg_bier_imp_add),
    (generic_swap_fn_t)vapi_msg_bier_imp_add_hton,
    (generic_swap_fn_t)vapi_msg_bier_imp_add_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_imp_add = vapi_register_msg(&__vapi_metadata_bier_imp_add);
  VAPI_DBG("Assigned msg id %d to bier_imp_add", vapi_msg_id_bier_imp_add);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_entry_details()
{
  static const char name[] = "bier_disp_entry_details";
  static const char name_with_crc[] = "bier_disp_entry_details_b9b10a59";
  static vapi_message_desc_t __vapi_metadata_bier_disp_entry_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_disp_entry_details, payload),
    sizeof(vapi_msg_bier_disp_entry_details),
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_details_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_entry_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_entry_details = vapi_register_msg(&__vapi_metadata_bier_disp_entry_details);
  VAPI_DBG("Assigned msg id %d to bier_disp_entry_details", vapi_msg_id_bier_disp_entry_details);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_table_add_del()
{
  static const char name[] = "bier_disp_table_add_del";
  static const char name_with_crc[] = "bier_disp_table_add_del_7671b2cb";
  static vapi_message_desc_t __vapi_metadata_bier_disp_table_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_disp_table_add_del, payload),
    sizeof(vapi_msg_bier_disp_table_add_del),
    (generic_swap_fn_t)vapi_msg_bier_disp_table_add_del_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_table_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_table_add_del = vapi_register_msg(&__vapi_metadata_bier_disp_table_add_del);
  VAPI_DBG("Assigned msg id %d to bier_disp_table_add_del", vapi_msg_id_bier_disp_table_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_bier_route_details()
{
  static const char name[] = "bier_route_details";
  static const char name_with_crc[] = "bier_route_details_798a2f3d";
  static vapi_message_desc_t __vapi_metadata_bier_route_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_route_details, payload),
    sizeof(vapi_msg_bier_route_details),
    (generic_swap_fn_t)vapi_msg_bier_route_details_hton,
    (generic_swap_fn_t)vapi_msg_bier_route_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_route_details = vapi_register_msg(&__vapi_metadata_bier_route_details);
  VAPI_DBG("Assigned msg id %d to bier_route_details", vapi_msg_id_bier_route_details);
}

static void __attribute__((constructor)) __vapi_constructor_bier_imp_details()
{
  static const char name[] = "bier_imp_details";
  static const char name_with_crc[] = "bier_imp_details_5d62e9ce";
  static vapi_message_desc_t __vapi_metadata_bier_imp_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bier_imp_details, payload),
    sizeof(vapi_msg_bier_imp_details),
    (generic_swap_fn_t)vapi_msg_bier_imp_details_hton,
    (generic_swap_fn_t)vapi_msg_bier_imp_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_imp_details = vapi_register_msg(&__vapi_metadata_bier_imp_details);
  VAPI_DBG("Assigned msg id %d to bier_imp_details", vapi_msg_id_bier_imp_details);
}

static void __attribute__((constructor)) __vapi_constructor_bier_imp_add_reply()
{
  static const char name[] = "bier_imp_add_reply";
  static const char name_with_crc[] = "bier_imp_add_reply_d49c5793";
  static vapi_message_desc_t __vapi_metadata_bier_imp_add_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_imp_add_reply, payload),
    sizeof(vapi_msg_bier_imp_add_reply),
    (generic_swap_fn_t)vapi_msg_bier_imp_add_reply_hton,
    (generic_swap_fn_t)vapi_msg_bier_imp_add_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_imp_add_reply = vapi_register_msg(&__vapi_metadata_bier_imp_add_reply);
  VAPI_DBG("Assigned msg id %d to bier_imp_add_reply", vapi_msg_id_bier_imp_add_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bier_table_dump()
{
  static const char name[] = "bier_table_dump";
  static const char name_with_crc[] = "bier_table_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_bier_table_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_bier_table_dump),
    (generic_swap_fn_t)vapi_msg_bier_table_dump_hton,
    (generic_swap_fn_t)vapi_msg_bier_table_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_table_dump = vapi_register_msg(&__vapi_metadata_bier_table_dump);
  VAPI_DBG("Assigned msg id %d to bier_table_dump", vapi_msg_id_bier_table_dump);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_table_dump()
{
  static const char name[] = "bier_disp_table_dump";
  static const char name_with_crc[] = "bier_disp_table_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_bier_disp_table_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_bier_disp_table_dump),
    (generic_swap_fn_t)vapi_msg_bier_disp_table_dump_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_table_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_table_dump = vapi_register_msg(&__vapi_metadata_bier_disp_table_dump);
  VAPI_DBG("Assigned msg id %d to bier_disp_table_dump", vapi_msg_id_bier_disp_table_dump);
}

static void __attribute__((constructor)) __vapi_constructor_bier_disp_table_add_del_reply()
{
  static const char name[] = "bier_disp_table_add_del_reply";
  static const char name_with_crc[] = "bier_disp_table_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_bier_disp_table_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bier_disp_table_add_del_reply, payload),
    sizeof(vapi_msg_bier_disp_table_add_del_reply),
    (generic_swap_fn_t)vapi_msg_bier_disp_table_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_bier_disp_table_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_bier_disp_table_add_del_reply = vapi_register_msg(&__vapi_metadata_bier_disp_table_add_del_reply);
  VAPI_DBG("Assigned msg id %d to bier_disp_table_add_del_reply", vapi_msg_id_bier_disp_table_add_del_reply);
}


static inline void vapi_set_vapi_msg_bier_disp_table_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_disp_table_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_disp_table_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_table_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_table_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_table_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_table_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_table_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_table_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_route_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_route_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_route_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_imp_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_imp_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_imp_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_disp_entry_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_disp_entry_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_disp_entry_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_disp_entry_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_disp_entry_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_disp_entry_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_route_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_route_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_route_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_imp_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_imp_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_imp_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_imp_add_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_imp_add_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_imp_add_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bier_disp_table_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bier_disp_table_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bier_disp_table_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
