#ifndef __included_gbp_api_json
#define __included_gbp_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_dump;
extern vapi_msg_id_t vapi_msg_id_gbp_contract_details;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_dump;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_gbp_contract_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_gbp_recirc_add_del;
extern vapi_msg_id_t vapi_msg_id_gbp_subnet_add_del;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_details;
extern vapi_msg_id_t vapi_msg_id_gbp_recirc_dump;
extern vapi_msg_id_t vapi_msg_id_gbp_subnet_dump;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_details;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_add_del;
extern vapi_msg_id_t vapi_msg_id_gbp_recirc_details;
extern vapi_msg_id_t vapi_msg_id_gbp_contract_dump;
extern vapi_msg_id_t vapi_msg_id_gbp_subnet_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_gbp_contract_add_del;
extern vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_add_del;
extern vapi_msg_id_t vapi_msg_id_gbp_subnet_details;
extern vapi_msg_id_t vapi_msg_id_gbp_recirc_add_del_reply;

#define DEFINE_VAPI_MSG_IDS_GBP_API_JSON\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_dump;\
  vapi_msg_id_t vapi_msg_id_gbp_contract_details;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_dump;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_gbp_contract_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_gbp_recirc_add_del;\
  vapi_msg_id_t vapi_msg_id_gbp_subnet_add_del;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_details;\
  vapi_msg_id_t vapi_msg_id_gbp_recirc_dump;\
  vapi_msg_id_t vapi_msg_id_gbp_subnet_dump;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_details;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_add_del;\
  vapi_msg_id_t vapi_msg_id_gbp_recirc_details;\
  vapi_msg_id_t vapi_msg_id_gbp_contract_dump;\
  vapi_msg_id_t vapi_msg_id_gbp_subnet_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_gbp_contract_add_del;\
  vapi_msg_id_t vapi_msg_id_gbp_endpoint_group_add_del;\
  vapi_msg_id_t vapi_msg_id_gbp_subnet_details;\
  vapi_msg_id_t vapi_msg_id_gbp_recirc_add_del_reply;


#ifndef defined_vapi_type_gbp_endpoint
#define defined_vapi_type_gbp_endpoint
typedef struct __attribute__((__packed__)) {
  u32 sw_if_index;
  u32 epg_id;
  u8 is_ip6;
  u8 address[16];
  u8 mac[6];
} vapi_type_gbp_endpoint;
#endif

#ifndef defined_vapi_type_gbp_endpoint_group
#define defined_vapi_type_gbp_endpoint_group
typedef struct __attribute__((__packed__)) {
  u32 epg_id;
  u32 bd_id;
  u32 ip4_table_id;
  u32 ip6_table_id;
  u32 uplink_sw_if_index;
} vapi_type_gbp_endpoint_group;
#endif

#ifndef defined_vapi_type_gbp_recirc
#define defined_vapi_type_gbp_recirc
typedef struct __attribute__((__packed__)) {
  u32 epg_id;
  u32 sw_if_index;
  u8 is_ext;
} vapi_type_gbp_recirc;
#endif

#ifndef defined_vapi_type_gbp_subnet
#define defined_vapi_type_gbp_subnet
typedef struct __attribute__((__packed__)) {
  u32 table_id;
  u32 sw_if_index;
  u32 epg_id;
  u8 is_ip6;
  u8 is_internal;
  u8 address_length;
  u8 address[16];
} vapi_type_gbp_subnet;
#endif

#ifndef defined_vapi_type_gbp_contract
#define defined_vapi_type_gbp_contract
typedef struct __attribute__((__packed__)) {
  u32 src_epg;
  u32 dst_epg;
  u32 acl_index;
} vapi_type_gbp_contract;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_dump
#define defined_vapi_payload_gbp_endpoint_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_gbp_endpoint_dump;
#endif

#ifndef defined_vapi_payload_gbp_contract_details
#define defined_vapi_payload_gbp_contract_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_gbp_contract contract; 
} vapi_payload_gbp_contract_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_contract_details payload;
} vapi_msg_gbp_contract_details;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_group_dump
#define defined_vapi_payload_gbp_endpoint_group_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_gbp_endpoint_group_dump;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_group_add_del_reply
#define defined_vapi_payload_gbp_endpoint_group_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_gbp_endpoint_group_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_endpoint_group_add_del_reply payload;
} vapi_msg_gbp_endpoint_group_add_del_reply;
#endif

#ifndef defined_vapi_payload_gbp_contract_add_del_reply
#define defined_vapi_payload_gbp_contract_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_gbp_contract_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_contract_add_del_reply payload;
} vapi_msg_gbp_contract_add_del_reply;
#endif

#ifndef defined_vapi_payload_gbp_recirc_add_del
#define defined_vapi_payload_gbp_recirc_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_gbp_recirc recirc; 
} vapi_payload_gbp_recirc_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_gbp_recirc_add_del payload;
} vapi_msg_gbp_recirc_add_del;
#endif

#ifndef defined_vapi_payload_gbp_subnet_add_del
#define defined_vapi_payload_gbp_subnet_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_gbp_subnet subnet; 
} vapi_payload_gbp_subnet_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_gbp_subnet_add_del payload;
} vapi_msg_gbp_subnet_add_del;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_details
#define defined_vapi_payload_gbp_endpoint_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_gbp_endpoint endpoint; 
} vapi_payload_gbp_endpoint_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_endpoint_details payload;
} vapi_msg_gbp_endpoint_details;
#endif

#ifndef defined_vapi_payload_gbp_recirc_dump
#define defined_vapi_payload_gbp_recirc_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_gbp_recirc_dump;
#endif

#ifndef defined_vapi_payload_gbp_subnet_dump
#define defined_vapi_payload_gbp_subnet_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_gbp_subnet_dump;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_group_details
#define defined_vapi_payload_gbp_endpoint_group_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_gbp_endpoint_group epg; 
} vapi_payload_gbp_endpoint_group_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_endpoint_group_details payload;
} vapi_msg_gbp_endpoint_group_details;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_add_del
#define defined_vapi_payload_gbp_endpoint_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_gbp_endpoint endpoint; 
} vapi_payload_gbp_endpoint_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_gbp_endpoint_add_del payload;
} vapi_msg_gbp_endpoint_add_del;
#endif

#ifndef defined_vapi_payload_gbp_recirc_details
#define defined_vapi_payload_gbp_recirc_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_gbp_recirc recirc; 
} vapi_payload_gbp_recirc_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_recirc_details payload;
} vapi_msg_gbp_recirc_details;
#endif

#ifndef defined_vapi_payload_gbp_contract_dump
#define defined_vapi_payload_gbp_contract_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_gbp_contract_dump;
#endif

#ifndef defined_vapi_payload_gbp_subnet_add_del_reply
#define defined_vapi_payload_gbp_subnet_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_gbp_subnet_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_subnet_add_del_reply payload;
} vapi_msg_gbp_subnet_add_del_reply;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_add_del_reply
#define defined_vapi_payload_gbp_endpoint_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_gbp_endpoint_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_endpoint_add_del_reply payload;
} vapi_msg_gbp_endpoint_add_del_reply;
#endif

#ifndef defined_vapi_payload_gbp_contract_add_del
#define defined_vapi_payload_gbp_contract_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_gbp_contract contract; 
} vapi_payload_gbp_contract_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_gbp_contract_add_del payload;
} vapi_msg_gbp_contract_add_del;
#endif

#ifndef defined_vapi_payload_gbp_endpoint_group_add_del
#define defined_vapi_payload_gbp_endpoint_group_add_del
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  vapi_type_gbp_endpoint_group epg; 
} vapi_payload_gbp_endpoint_group_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_gbp_endpoint_group_add_del payload;
} vapi_msg_gbp_endpoint_group_add_del;
#endif

#ifndef defined_vapi_payload_gbp_subnet_details
#define defined_vapi_payload_gbp_subnet_details
typedef struct __attribute__ ((__packed__)) {
  vapi_type_gbp_subnet subnet; 
} vapi_payload_gbp_subnet_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_subnet_details payload;
} vapi_msg_gbp_subnet_details;
#endif

#ifndef defined_vapi_payload_gbp_recirc_add_del_reply
#define defined_vapi_payload_gbp_recirc_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_gbp_recirc_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_gbp_recirc_add_del_reply payload;
} vapi_msg_gbp_recirc_add_del_reply;
#endif


#ifndef defined_inline_vapi_type_gbp_endpoint
#define defined_inline_vapi_type_gbp_endpoint
static inline void vapi_type_gbp_endpoint_hton(vapi_type_gbp_endpoint *msg)
{
  msg->sw_if_index = htobe32(msg->sw_if_index);
  msg->epg_id = htobe32(msg->epg_id);
}

static inline void vapi_type_gbp_endpoint_ntoh(vapi_type_gbp_endpoint *msg)
{
  msg->sw_if_index = be32toh(msg->sw_if_index);
  msg->epg_id = be32toh(msg->epg_id);
}
#endif

#ifndef defined_inline_vapi_type_gbp_endpoint_group
#define defined_inline_vapi_type_gbp_endpoint_group
static inline void vapi_type_gbp_endpoint_group_hton(vapi_type_gbp_endpoint_group *msg)
{
  msg->epg_id = htobe32(msg->epg_id);
  msg->bd_id = htobe32(msg->bd_id);
  msg->ip4_table_id = htobe32(msg->ip4_table_id);
  msg->ip6_table_id = htobe32(msg->ip6_table_id);
  msg->uplink_sw_if_index = htobe32(msg->uplink_sw_if_index);
}

static inline void vapi_type_gbp_endpoint_group_ntoh(vapi_type_gbp_endpoint_group *msg)
{
  msg->epg_id = be32toh(msg->epg_id);
  msg->bd_id = be32toh(msg->bd_id);
  msg->ip4_table_id = be32toh(msg->ip4_table_id);
  msg->ip6_table_id = be32toh(msg->ip6_table_id);
  msg->uplink_sw_if_index = be32toh(msg->uplink_sw_if_index);
}
#endif

#ifndef defined_inline_vapi_type_gbp_recirc
#define defined_inline_vapi_type_gbp_recirc
static inline void vapi_type_gbp_recirc_hton(vapi_type_gbp_recirc *msg)
{
  msg->epg_id = htobe32(msg->epg_id);
  msg->sw_if_index = htobe32(msg->sw_if_index);
}

static inline void vapi_type_gbp_recirc_ntoh(vapi_type_gbp_recirc *msg)
{
  msg->epg_id = be32toh(msg->epg_id);
  msg->sw_if_index = be32toh(msg->sw_if_index);
}
#endif

#ifndef defined_inline_vapi_type_gbp_subnet
#define defined_inline_vapi_type_gbp_subnet
static inline void vapi_type_gbp_subnet_hton(vapi_type_gbp_subnet *msg)
{
  msg->table_id = htobe32(msg->table_id);
  msg->sw_if_index = htobe32(msg->sw_if_index);
  msg->epg_id = htobe32(msg->epg_id);
}

static inline void vapi_type_gbp_subnet_ntoh(vapi_type_gbp_subnet *msg)
{
  msg->table_id = be32toh(msg->table_id);
  msg->sw_if_index = be32toh(msg->sw_if_index);
  msg->epg_id = be32toh(msg->epg_id);
}
#endif

#ifndef defined_inline_vapi_type_gbp_contract
#define defined_inline_vapi_type_gbp_contract
static inline void vapi_type_gbp_contract_hton(vapi_type_gbp_contract *msg)
{
  msg->src_epg = htobe32(msg->src_epg);
  msg->dst_epg = htobe32(msg->dst_epg);
  msg->acl_index = htobe32(msg->acl_index);
}

static inline void vapi_type_gbp_contract_ntoh(vapi_type_gbp_contract *msg)
{
  msg->src_epg = be32toh(msg->src_epg);
  msg->dst_epg = be32toh(msg->dst_epg);
  msg->acl_index = be32toh(msg->acl_index);
}
#endif

static inline uword vapi_calc_gbp_endpoint_dump_msg_size(vapi_msg_gbp_endpoint_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_dump_hton(vapi_msg_gbp_endpoint_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_gbp_endpoint_dump_ntoh(vapi_msg_gbp_endpoint_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_gbp_contract_details_payload_hton(vapi_payload_gbp_contract_details *payload)
{
  vapi_type_gbp_contract_hton(&payload->contract);
}

static inline void vapi_msg_gbp_contract_details_payload_ntoh(vapi_payload_gbp_contract_details *payload)
{
  vapi_type_gbp_contract_ntoh(&payload->contract);
}

static inline uword vapi_calc_gbp_contract_details_msg_size(vapi_msg_gbp_contract_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_contract_details_hton(vapi_msg_gbp_contract_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_contract_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_contract_details_ntoh(vapi_msg_gbp_contract_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_contract_details_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_gbp_endpoint_group_dump_msg_size(vapi_msg_gbp_endpoint_group_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_group_dump_hton(vapi_msg_gbp_endpoint_group_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_gbp_endpoint_group_dump_ntoh(vapi_msg_gbp_endpoint_group_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_gbp_endpoint_group_add_del_reply_payload_hton(vapi_payload_gbp_endpoint_group_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_reply_payload_ntoh(vapi_payload_gbp_endpoint_group_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_gbp_endpoint_group_add_del_reply_msg_size(vapi_msg_gbp_endpoint_group_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_reply_hton(vapi_msg_gbp_endpoint_group_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_endpoint_group_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_reply_ntoh(vapi_msg_gbp_endpoint_group_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_endpoint_group_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_contract_add_del_reply_payload_hton(vapi_payload_gbp_contract_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_gbp_contract_add_del_reply_payload_ntoh(vapi_payload_gbp_contract_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_gbp_contract_add_del_reply_msg_size(vapi_msg_gbp_contract_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_contract_add_del_reply_hton(vapi_msg_gbp_contract_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_contract_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_contract_add_del_reply_ntoh(vapi_msg_gbp_contract_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_contract_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_recirc_add_del_payload_hton(vapi_payload_gbp_recirc_add_del *payload)
{
  vapi_type_gbp_recirc_hton(&payload->recirc);
}

static inline void vapi_msg_gbp_recirc_add_del_payload_ntoh(vapi_payload_gbp_recirc_add_del *payload)
{
  vapi_type_gbp_recirc_ntoh(&payload->recirc);
}

static inline uword vapi_calc_gbp_recirc_add_del_msg_size(vapi_msg_gbp_recirc_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_recirc_add_del_hton(vapi_msg_gbp_recirc_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_gbp_recirc_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_recirc_add_del_ntoh(vapi_msg_gbp_recirc_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_gbp_recirc_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_subnet_add_del_payload_hton(vapi_payload_gbp_subnet_add_del *payload)
{
  vapi_type_gbp_subnet_hton(&payload->subnet);
}

static inline void vapi_msg_gbp_subnet_add_del_payload_ntoh(vapi_payload_gbp_subnet_add_del *payload)
{
  vapi_type_gbp_subnet_ntoh(&payload->subnet);
}

static inline uword vapi_calc_gbp_subnet_add_del_msg_size(vapi_msg_gbp_subnet_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_subnet_add_del_hton(vapi_msg_gbp_subnet_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_gbp_subnet_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_subnet_add_del_ntoh(vapi_msg_gbp_subnet_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_gbp_subnet_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_details_payload_hton(vapi_payload_gbp_endpoint_details *payload)
{
  vapi_type_gbp_endpoint_hton(&payload->endpoint);
}

static inline void vapi_msg_gbp_endpoint_details_payload_ntoh(vapi_payload_gbp_endpoint_details *payload)
{
  vapi_type_gbp_endpoint_ntoh(&payload->endpoint);
}

static inline uword vapi_calc_gbp_endpoint_details_msg_size(vapi_msg_gbp_endpoint_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_details_hton(vapi_msg_gbp_endpoint_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_endpoint_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_details_ntoh(vapi_msg_gbp_endpoint_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_endpoint_details_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_gbp_recirc_dump_msg_size(vapi_msg_gbp_recirc_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_recirc_dump_hton(vapi_msg_gbp_recirc_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_gbp_recirc_dump_ntoh(vapi_msg_gbp_recirc_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline uword vapi_calc_gbp_subnet_dump_msg_size(vapi_msg_gbp_subnet_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_subnet_dump_hton(vapi_msg_gbp_subnet_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_gbp_subnet_dump_ntoh(vapi_msg_gbp_subnet_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_gbp_endpoint_group_details_payload_hton(vapi_payload_gbp_endpoint_group_details *payload)
{
  vapi_type_gbp_endpoint_group_hton(&payload->epg);
}

static inline void vapi_msg_gbp_endpoint_group_details_payload_ntoh(vapi_payload_gbp_endpoint_group_details *payload)
{
  vapi_type_gbp_endpoint_group_ntoh(&payload->epg);
}

static inline uword vapi_calc_gbp_endpoint_group_details_msg_size(vapi_msg_gbp_endpoint_group_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_group_details_hton(vapi_msg_gbp_endpoint_group_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_endpoint_group_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_group_details_ntoh(vapi_msg_gbp_endpoint_group_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_endpoint_group_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_add_del_payload_hton(vapi_payload_gbp_endpoint_add_del *payload)
{
  vapi_type_gbp_endpoint_hton(&payload->endpoint);
}

static inline void vapi_msg_gbp_endpoint_add_del_payload_ntoh(vapi_payload_gbp_endpoint_add_del *payload)
{
  vapi_type_gbp_endpoint_ntoh(&payload->endpoint);
}

static inline uword vapi_calc_gbp_endpoint_add_del_msg_size(vapi_msg_gbp_endpoint_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_add_del_hton(vapi_msg_gbp_endpoint_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_gbp_endpoint_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_add_del_ntoh(vapi_msg_gbp_endpoint_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_gbp_endpoint_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_recirc_details_payload_hton(vapi_payload_gbp_recirc_details *payload)
{
  vapi_type_gbp_recirc_hton(&payload->recirc);
}

static inline void vapi_msg_gbp_recirc_details_payload_ntoh(vapi_payload_gbp_recirc_details *payload)
{
  vapi_type_gbp_recirc_ntoh(&payload->recirc);
}

static inline uword vapi_calc_gbp_recirc_details_msg_size(vapi_msg_gbp_recirc_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_recirc_details_hton(vapi_msg_gbp_recirc_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_recirc_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_recirc_details_ntoh(vapi_msg_gbp_recirc_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_recirc_details_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_gbp_contract_dump_msg_size(vapi_msg_gbp_contract_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_contract_dump_hton(vapi_msg_gbp_contract_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_gbp_contract_dump_ntoh(vapi_msg_gbp_contract_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_gbp_subnet_add_del_reply_payload_hton(vapi_payload_gbp_subnet_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_gbp_subnet_add_del_reply_payload_ntoh(vapi_payload_gbp_subnet_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_gbp_subnet_add_del_reply_msg_size(vapi_msg_gbp_subnet_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_subnet_add_del_reply_hton(vapi_msg_gbp_subnet_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_subnet_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_subnet_add_del_reply_ntoh(vapi_msg_gbp_subnet_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_subnet_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_add_del_reply_payload_hton(vapi_payload_gbp_endpoint_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_gbp_endpoint_add_del_reply_payload_ntoh(vapi_payload_gbp_endpoint_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_gbp_endpoint_add_del_reply_msg_size(vapi_msg_gbp_endpoint_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_add_del_reply_hton(vapi_msg_gbp_endpoint_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_endpoint_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_add_del_reply_ntoh(vapi_msg_gbp_endpoint_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_endpoint_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_contract_add_del_payload_hton(vapi_payload_gbp_contract_add_del *payload)
{
  vapi_type_gbp_contract_hton(&payload->contract);
}

static inline void vapi_msg_gbp_contract_add_del_payload_ntoh(vapi_payload_gbp_contract_add_del *payload)
{
  vapi_type_gbp_contract_ntoh(&payload->contract);
}

static inline uword vapi_calc_gbp_contract_add_del_msg_size(vapi_msg_gbp_contract_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_contract_add_del_hton(vapi_msg_gbp_contract_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_gbp_contract_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_contract_add_del_ntoh(vapi_msg_gbp_contract_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_contract_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_gbp_contract_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_payload_hton(vapi_payload_gbp_endpoint_group_add_del *payload)
{
  vapi_type_gbp_endpoint_group_hton(&payload->epg);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_payload_ntoh(vapi_payload_gbp_endpoint_group_add_del *payload)
{
  vapi_type_gbp_endpoint_group_ntoh(&payload->epg);
}

static inline uword vapi_calc_gbp_endpoint_group_add_del_msg_size(vapi_msg_gbp_endpoint_group_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_hton(vapi_msg_gbp_endpoint_group_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_gbp_endpoint_group_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_endpoint_group_add_del_ntoh(vapi_msg_gbp_endpoint_group_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_endpoint_group_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_gbp_endpoint_group_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_subnet_details_payload_hton(vapi_payload_gbp_subnet_details *payload)
{
  vapi_type_gbp_subnet_hton(&payload->subnet);
}

static inline void vapi_msg_gbp_subnet_details_payload_ntoh(vapi_payload_gbp_subnet_details *payload)
{
  vapi_type_gbp_subnet_ntoh(&payload->subnet);
}

static inline uword vapi_calc_gbp_subnet_details_msg_size(vapi_msg_gbp_subnet_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_subnet_details_hton(vapi_msg_gbp_subnet_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_subnet_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_subnet_details_ntoh(vapi_msg_gbp_subnet_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_subnet_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_subnet_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_gbp_recirc_add_del_reply_payload_hton(vapi_payload_gbp_recirc_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_gbp_recirc_add_del_reply_payload_ntoh(vapi_payload_gbp_recirc_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_gbp_recirc_add_del_reply_msg_size(vapi_msg_gbp_recirc_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_gbp_recirc_add_del_reply_hton(vapi_msg_gbp_recirc_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_gbp_recirc_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_gbp_recirc_add_del_reply_ntoh(vapi_msg_gbp_recirc_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_gbp_recirc_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_gbp_recirc_add_del_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_gbp_endpoint_dump* vapi_alloc_gbp_endpoint_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_endpoint_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_endpoint_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_endpoint_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_endpoint_dump);

  return msg;
}

static inline vapi_error_e vapi_gbp_endpoint_dump(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_endpoint_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_endpoint_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_endpoint_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_endpoint_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_endpoint_group_dump* vapi_alloc_gbp_endpoint_group_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_endpoint_group_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_endpoint_group_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_endpoint_group_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_endpoint_group_dump);

  return msg;
}

static inline vapi_error_e vapi_gbp_endpoint_group_dump(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_endpoint_group_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_endpoint_group_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_endpoint_group_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_endpoint_group_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_recirc_add_del* vapi_alloc_gbp_recirc_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_recirc_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_recirc_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_recirc_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_recirc_add_del);

  return msg;
}

static inline vapi_error_e vapi_gbp_recirc_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_recirc_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_recirc_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_recirc_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_recirc_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_subnet_add_del* vapi_alloc_gbp_subnet_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_subnet_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_subnet_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_subnet_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_subnet_add_del);

  return msg;
}

static inline vapi_error_e vapi_gbp_subnet_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_subnet_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_subnet_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_subnet_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_subnet_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_recirc_dump* vapi_alloc_gbp_recirc_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_recirc_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_recirc_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_recirc_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_recirc_dump);

  return msg;
}

static inline vapi_error_e vapi_gbp_recirc_dump(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_recirc_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_recirc_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_recirc_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_recirc_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_subnet_dump* vapi_alloc_gbp_subnet_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_subnet_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_subnet_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_subnet_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_subnet_dump);

  return msg;
}

static inline vapi_error_e vapi_gbp_subnet_dump(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_subnet_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_subnet_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_subnet_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_subnet_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_endpoint_add_del* vapi_alloc_gbp_endpoint_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_endpoint_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_endpoint_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_endpoint_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_endpoint_add_del);

  return msg;
}

static inline vapi_error_e vapi_gbp_endpoint_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_endpoint_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_endpoint_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_endpoint_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_endpoint_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_contract_dump* vapi_alloc_gbp_contract_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_contract_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_contract_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_contract_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_contract_dump);

  return msg;
}

static inline vapi_error_e vapi_gbp_contract_dump(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_contract_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_contract_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_contract_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_contract_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_contract_add_del* vapi_alloc_gbp_contract_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_contract_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_contract_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_contract_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_contract_add_del);

  return msg;
}

static inline vapi_error_e vapi_gbp_contract_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_contract_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_contract_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_contract_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_contract_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_gbp_endpoint_group_add_del* vapi_alloc_gbp_endpoint_group_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_gbp_endpoint_group_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_gbp_endpoint_group_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_gbp_endpoint_group_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_gbp_endpoint_group_add_del);

  return msg;
}

static inline vapi_error_e vapi_gbp_endpoint_group_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_gbp_endpoint_group_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_gbp_endpoint_group_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_gbp_endpoint_group_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_gbp_endpoint_group_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_dump()
{
  static const char name[] = "gbp_endpoint_dump";
  static const char name_with_crc[] = "gbp_endpoint_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_gbp_endpoint_dump),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_dump_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_dump = vapi_register_msg(&__vapi_metadata_gbp_endpoint_dump);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_dump", vapi_msg_id_gbp_endpoint_dump);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_contract_details()
{
  static const char name[] = "gbp_contract_details";
  static const char name_with_crc[] = "gbp_contract_details_9baf26e3";
  static vapi_message_desc_t __vapi_metadata_gbp_contract_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_contract_details, payload),
    sizeof(vapi_msg_gbp_contract_details),
    (generic_swap_fn_t)vapi_msg_gbp_contract_details_hton,
    (generic_swap_fn_t)vapi_msg_gbp_contract_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_contract_details = vapi_register_msg(&__vapi_metadata_gbp_contract_details);
  VAPI_DBG("Assigned msg id %d to gbp_contract_details", vapi_msg_id_gbp_contract_details);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_group_dump()
{
  static const char name[] = "gbp_endpoint_group_dump";
  static const char name_with_crc[] = "gbp_endpoint_group_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_group_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_gbp_endpoint_group_dump),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_dump_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_group_dump = vapi_register_msg(&__vapi_metadata_gbp_endpoint_group_dump);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_group_dump", vapi_msg_id_gbp_endpoint_group_dump);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_group_add_del_reply()
{
  static const char name[] = "gbp_endpoint_group_add_del_reply";
  static const char name_with_crc[] = "gbp_endpoint_group_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_group_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_endpoint_group_add_del_reply, payload),
    sizeof(vapi_msg_gbp_endpoint_group_add_del_reply),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_group_add_del_reply = vapi_register_msg(&__vapi_metadata_gbp_endpoint_group_add_del_reply);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_group_add_del_reply", vapi_msg_id_gbp_endpoint_group_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_contract_add_del_reply()
{
  static const char name[] = "gbp_contract_add_del_reply";
  static const char name_with_crc[] = "gbp_contract_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_gbp_contract_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_contract_add_del_reply, payload),
    sizeof(vapi_msg_gbp_contract_add_del_reply),
    (generic_swap_fn_t)vapi_msg_gbp_contract_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_gbp_contract_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_contract_add_del_reply = vapi_register_msg(&__vapi_metadata_gbp_contract_add_del_reply);
  VAPI_DBG("Assigned msg id %d to gbp_contract_add_del_reply", vapi_msg_id_gbp_contract_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_recirc_add_del()
{
  static const char name[] = "gbp_recirc_add_del";
  static const char name_with_crc[] = "gbp_recirc_add_del_9e5719be";
  static vapi_message_desc_t __vapi_metadata_gbp_recirc_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_gbp_recirc_add_del, payload),
    sizeof(vapi_msg_gbp_recirc_add_del),
    (generic_swap_fn_t)vapi_msg_gbp_recirc_add_del_hton,
    (generic_swap_fn_t)vapi_msg_gbp_recirc_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_recirc_add_del = vapi_register_msg(&__vapi_metadata_gbp_recirc_add_del);
  VAPI_DBG("Assigned msg id %d to gbp_recirc_add_del", vapi_msg_id_gbp_recirc_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_subnet_add_del()
{
  static const char name[] = "gbp_subnet_add_del";
  static const char name_with_crc[] = "gbp_subnet_add_del_3426a234";
  static vapi_message_desc_t __vapi_metadata_gbp_subnet_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_gbp_subnet_add_del, payload),
    sizeof(vapi_msg_gbp_subnet_add_del),
    (generic_swap_fn_t)vapi_msg_gbp_subnet_add_del_hton,
    (generic_swap_fn_t)vapi_msg_gbp_subnet_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_subnet_add_del = vapi_register_msg(&__vapi_metadata_gbp_subnet_add_del);
  VAPI_DBG("Assigned msg id %d to gbp_subnet_add_del", vapi_msg_id_gbp_subnet_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_details()
{
  static const char name[] = "gbp_endpoint_details";
  static const char name_with_crc[] = "gbp_endpoint_details_8dc36854";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_endpoint_details, payload),
    sizeof(vapi_msg_gbp_endpoint_details),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_details_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_details = vapi_register_msg(&__vapi_metadata_gbp_endpoint_details);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_details", vapi_msg_id_gbp_endpoint_details);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_recirc_dump()
{
  static const char name[] = "gbp_recirc_dump";
  static const char name_with_crc[] = "gbp_recirc_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_gbp_recirc_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_gbp_recirc_dump),
    (generic_swap_fn_t)vapi_msg_gbp_recirc_dump_hton,
    (generic_swap_fn_t)vapi_msg_gbp_recirc_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_recirc_dump = vapi_register_msg(&__vapi_metadata_gbp_recirc_dump);
  VAPI_DBG("Assigned msg id %d to gbp_recirc_dump", vapi_msg_id_gbp_recirc_dump);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_subnet_dump()
{
  static const char name[] = "gbp_subnet_dump";
  static const char name_with_crc[] = "gbp_subnet_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_gbp_subnet_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_gbp_subnet_dump),
    (generic_swap_fn_t)vapi_msg_gbp_subnet_dump_hton,
    (generic_swap_fn_t)vapi_msg_gbp_subnet_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_subnet_dump = vapi_register_msg(&__vapi_metadata_gbp_subnet_dump);
  VAPI_DBG("Assigned msg id %d to gbp_subnet_dump", vapi_msg_id_gbp_subnet_dump);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_group_details()
{
  static const char name[] = "gbp_endpoint_group_details";
  static const char name_with_crc[] = "gbp_endpoint_group_details_bb5fb721";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_group_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_endpoint_group_details, payload),
    sizeof(vapi_msg_gbp_endpoint_group_details),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_details_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_group_details = vapi_register_msg(&__vapi_metadata_gbp_endpoint_group_details);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_group_details", vapi_msg_id_gbp_endpoint_group_details);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_add_del()
{
  static const char name[] = "gbp_endpoint_add_del";
  static const char name_with_crc[] = "gbp_endpoint_add_del_a4e66442";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_gbp_endpoint_add_del, payload),
    sizeof(vapi_msg_gbp_endpoint_add_del),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_add_del_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_add_del = vapi_register_msg(&__vapi_metadata_gbp_endpoint_add_del);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_add_del", vapi_msg_id_gbp_endpoint_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_recirc_details()
{
  static const char name[] = "gbp_recirc_details";
  static const char name_with_crc[] = "gbp_recirc_details_140307d5";
  static vapi_message_desc_t __vapi_metadata_gbp_recirc_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_recirc_details, payload),
    sizeof(vapi_msg_gbp_recirc_details),
    (generic_swap_fn_t)vapi_msg_gbp_recirc_details_hton,
    (generic_swap_fn_t)vapi_msg_gbp_recirc_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_recirc_details = vapi_register_msg(&__vapi_metadata_gbp_recirc_details);
  VAPI_DBG("Assigned msg id %d to gbp_recirc_details", vapi_msg_id_gbp_recirc_details);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_contract_dump()
{
  static const char name[] = "gbp_contract_dump";
  static const char name_with_crc[] = "gbp_contract_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_gbp_contract_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_gbp_contract_dump),
    (generic_swap_fn_t)vapi_msg_gbp_contract_dump_hton,
    (generic_swap_fn_t)vapi_msg_gbp_contract_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_contract_dump = vapi_register_msg(&__vapi_metadata_gbp_contract_dump);
  VAPI_DBG("Assigned msg id %d to gbp_contract_dump", vapi_msg_id_gbp_contract_dump);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_subnet_add_del_reply()
{
  static const char name[] = "gbp_subnet_add_del_reply";
  static const char name_with_crc[] = "gbp_subnet_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_gbp_subnet_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_subnet_add_del_reply, payload),
    sizeof(vapi_msg_gbp_subnet_add_del_reply),
    (generic_swap_fn_t)vapi_msg_gbp_subnet_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_gbp_subnet_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_subnet_add_del_reply = vapi_register_msg(&__vapi_metadata_gbp_subnet_add_del_reply);
  VAPI_DBG("Assigned msg id %d to gbp_subnet_add_del_reply", vapi_msg_id_gbp_subnet_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_add_del_reply()
{
  static const char name[] = "gbp_endpoint_add_del_reply";
  static const char name_with_crc[] = "gbp_endpoint_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_endpoint_add_del_reply, payload),
    sizeof(vapi_msg_gbp_endpoint_add_del_reply),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_add_del_reply = vapi_register_msg(&__vapi_metadata_gbp_endpoint_add_del_reply);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_add_del_reply", vapi_msg_id_gbp_endpoint_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_contract_add_del()
{
  static const char name[] = "gbp_contract_add_del";
  static const char name_with_crc[] = "gbp_contract_add_del_b28a2af5";
  static vapi_message_desc_t __vapi_metadata_gbp_contract_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_gbp_contract_add_del, payload),
    sizeof(vapi_msg_gbp_contract_add_del),
    (generic_swap_fn_t)vapi_msg_gbp_contract_add_del_hton,
    (generic_swap_fn_t)vapi_msg_gbp_contract_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_contract_add_del = vapi_register_msg(&__vapi_metadata_gbp_contract_add_del);
  VAPI_DBG("Assigned msg id %d to gbp_contract_add_del", vapi_msg_id_gbp_contract_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_endpoint_group_add_del()
{
  static const char name[] = "gbp_endpoint_group_add_del";
  static const char name_with_crc[] = "gbp_endpoint_group_add_del_4fa2277c";
  static vapi_message_desc_t __vapi_metadata_gbp_endpoint_group_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_gbp_endpoint_group_add_del, payload),
    sizeof(vapi_msg_gbp_endpoint_group_add_del),
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_add_del_hton,
    (generic_swap_fn_t)vapi_msg_gbp_endpoint_group_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_endpoint_group_add_del = vapi_register_msg(&__vapi_metadata_gbp_endpoint_group_add_del);
  VAPI_DBG("Assigned msg id %d to gbp_endpoint_group_add_del", vapi_msg_id_gbp_endpoint_group_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_subnet_details()
{
  static const char name[] = "gbp_subnet_details";
  static const char name_with_crc[] = "gbp_subnet_details_be72bc5f";
  static vapi_message_desc_t __vapi_metadata_gbp_subnet_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_subnet_details, payload),
    sizeof(vapi_msg_gbp_subnet_details),
    (generic_swap_fn_t)vapi_msg_gbp_subnet_details_hton,
    (generic_swap_fn_t)vapi_msg_gbp_subnet_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_subnet_details = vapi_register_msg(&__vapi_metadata_gbp_subnet_details);
  VAPI_DBG("Assigned msg id %d to gbp_subnet_details", vapi_msg_id_gbp_subnet_details);
}

static void __attribute__((constructor)) __vapi_constructor_gbp_recirc_add_del_reply()
{
  static const char name[] = "gbp_recirc_add_del_reply";
  static const char name_with_crc[] = "gbp_recirc_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_gbp_recirc_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_gbp_recirc_add_del_reply, payload),
    sizeof(vapi_msg_gbp_recirc_add_del_reply),
    (generic_swap_fn_t)vapi_msg_gbp_recirc_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_gbp_recirc_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_gbp_recirc_add_del_reply = vapi_register_msg(&__vapi_metadata_gbp_recirc_add_del_reply);
  VAPI_DBG("Assigned msg id %d to gbp_recirc_add_del_reply", vapi_msg_id_gbp_recirc_add_del_reply);
}


static inline void vapi_set_vapi_msg_gbp_contract_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_contract_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_contract_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_endpoint_group_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_endpoint_group_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_endpoint_group_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_contract_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_contract_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_contract_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_endpoint_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_endpoint_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_endpoint_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_endpoint_group_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_endpoint_group_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_endpoint_group_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_recirc_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_recirc_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_recirc_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_subnet_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_subnet_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_subnet_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_endpoint_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_endpoint_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_endpoint_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_subnet_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_subnet_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_subnet_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_gbp_recirc_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_gbp_recirc_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_gbp_recirc_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
