#ifndef __included_mactime_api_json
#define __included_mactime_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_mactime_add_del_range_reply;
extern vapi_msg_id_t vapi_msg_id_mactime_add_del_range;
extern vapi_msg_id_t vapi_msg_id_mactime_enable_disable_reply;
extern vapi_msg_id_t vapi_msg_id_mactime_enable_disable;

#define DEFINE_VAPI_MSG_IDS_MACTIME_API_JSON\
  vapi_msg_id_t vapi_msg_id_mactime_add_del_range_reply;\
  vapi_msg_id_t vapi_msg_id_mactime_add_del_range;\
  vapi_msg_id_t vapi_msg_id_mactime_enable_disable_reply;\
  vapi_msg_id_t vapi_msg_id_mactime_enable_disable;


#ifndef defined_vapi_type_time_range
#define defined_vapi_type_time_range
typedef struct __attribute__((__packed__)) {
  f64 start;
  f64 end;
} vapi_type_time_range;
#endif

#ifndef defined_vapi_payload_mactime_add_del_range_reply
#define defined_vapi_payload_mactime_add_del_range_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_mactime_add_del_range_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_mactime_add_del_range_reply payload;
} vapi_msg_mactime_add_del_range_reply;
#endif

#ifndef defined_vapi_payload_mactime_add_del_range
#define defined_vapi_payload_mactime_add_del_range
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  u8 drop;
  u8 allow;
  u8 mac_address[6];
  u8 device_name[64];
  u32 count;
  vapi_type_time_range ranges[0]; 
} vapi_payload_mactime_add_del_range;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_mactime_add_del_range payload;
} vapi_msg_mactime_add_del_range;
#endif

#ifndef defined_vapi_payload_mactime_enable_disable_reply
#define defined_vapi_payload_mactime_enable_disable_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_mactime_enable_disable_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_mactime_enable_disable_reply payload;
} vapi_msg_mactime_enable_disable_reply;
#endif

#ifndef defined_vapi_payload_mactime_enable_disable
#define defined_vapi_payload_mactime_enable_disable
typedef struct __attribute__ ((__packed__)) {
  u8 enable_disable;
  u32 sw_if_index; 
} vapi_payload_mactime_enable_disable;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_mactime_enable_disable payload;
} vapi_msg_mactime_enable_disable;
#endif


#ifndef defined_inline_vapi_type_time_range
#define defined_inline_vapi_type_time_range
static inline void vapi_type_time_range_hton(vapi_type_time_range *msg)
{

}

static inline void vapi_type_time_range_ntoh(vapi_type_time_range *msg)
{

}
#endif

static inline void vapi_msg_mactime_add_del_range_reply_payload_hton(vapi_payload_mactime_add_del_range_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_mactime_add_del_range_reply_payload_ntoh(vapi_payload_mactime_add_del_range_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_mactime_add_del_range_reply_msg_size(vapi_msg_mactime_add_del_range_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_mactime_add_del_range_reply_hton(vapi_msg_mactime_add_del_range_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_add_del_range_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_mactime_add_del_range_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_mactime_add_del_range_reply_ntoh(vapi_msg_mactime_add_del_range_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_add_del_range_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_mactime_add_del_range_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_mactime_add_del_range_payload_hton(vapi_payload_mactime_add_del_range *payload)
{
  payload->count = htobe32(payload->count);
}

static inline void vapi_msg_mactime_add_del_range_payload_ntoh(vapi_payload_mactime_add_del_range *payload)
{
  payload->count = be32toh(payload->count);
}

static inline uword vapi_calc_mactime_add_del_range_msg_size(vapi_msg_mactime_add_del_range *msg)
{
  return sizeof(*msg)+ msg->payload.count * sizeof(msg->payload.ranges[0]);
}

static inline void vapi_msg_mactime_add_del_range_hton(vapi_msg_mactime_add_del_range *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_add_del_range'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_mactime_add_del_range_payload_hton(&msg->payload);
}

static inline void vapi_msg_mactime_add_del_range_ntoh(vapi_msg_mactime_add_del_range *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_add_del_range'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_mactime_add_del_range_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_mactime_enable_disable_reply_payload_hton(vapi_payload_mactime_enable_disable_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_mactime_enable_disable_reply_payload_ntoh(vapi_payload_mactime_enable_disable_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_mactime_enable_disable_reply_msg_size(vapi_msg_mactime_enable_disable_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_mactime_enable_disable_reply_hton(vapi_msg_mactime_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_enable_disable_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_mactime_enable_disable_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_mactime_enable_disable_reply_ntoh(vapi_msg_mactime_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_enable_disable_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_mactime_enable_disable_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_mactime_enable_disable_payload_hton(vapi_payload_mactime_enable_disable *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_mactime_enable_disable_payload_ntoh(vapi_payload_mactime_enable_disable *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_mactime_enable_disable_msg_size(vapi_msg_mactime_enable_disable *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_mactime_enable_disable_hton(vapi_msg_mactime_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_enable_disable'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_mactime_enable_disable_payload_hton(&msg->payload);
}

static inline void vapi_msg_mactime_enable_disable_ntoh(vapi_msg_mactime_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_mactime_enable_disable'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_mactime_enable_disable_payload_ntoh(&msg->payload);
}

static inline vapi_msg_mactime_add_del_range* vapi_alloc_mactime_add_del_range(struct vapi_ctx_s *ctx, size_t ranges_array_size)
{
  vapi_msg_mactime_add_del_range *msg = NULL;
  const size_t size = sizeof(vapi_msg_mactime_add_del_range) + sizeof(msg->payload.ranges[0]) * ranges_array_size;
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_mactime_add_del_range*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_mactime_add_del_range);
  msg->payload.count = ranges_array_size;
  return msg;
}

static inline vapi_error_e vapi_mactime_add_del_range(struct vapi_ctx_s *ctx,
  vapi_msg_mactime_add_del_range *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_mactime_add_del_range_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_mactime_add_del_range_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_mactime_add_del_range_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_mactime_enable_disable* vapi_alloc_mactime_enable_disable(struct vapi_ctx_s *ctx)
{
  vapi_msg_mactime_enable_disable *msg = NULL;
  const size_t size = sizeof(vapi_msg_mactime_enable_disable);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_mactime_enable_disable*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_mactime_enable_disable);

  return msg;
}

static inline vapi_error_e vapi_mactime_enable_disable(struct vapi_ctx_s *ctx,
  vapi_msg_mactime_enable_disable *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_mactime_enable_disable_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_mactime_enable_disable_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_mactime_enable_disable_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_mactime_add_del_range_reply()
{
  static const char name[] = "mactime_add_del_range_reply";
  static const char name_with_crc[] = "mactime_add_del_range_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_mactime_add_del_range_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_mactime_add_del_range_reply, payload),
    sizeof(vapi_msg_mactime_add_del_range_reply),
    (generic_swap_fn_t)vapi_msg_mactime_add_del_range_reply_hton,
    (generic_swap_fn_t)vapi_msg_mactime_add_del_range_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_mactime_add_del_range_reply = vapi_register_msg(&__vapi_metadata_mactime_add_del_range_reply);
  VAPI_DBG("Assigned msg id %d to mactime_add_del_range_reply", vapi_msg_id_mactime_add_del_range_reply);
}

static void __attribute__((constructor)) __vapi_constructor_mactime_add_del_range()
{
  static const char name[] = "mactime_add_del_range";
  static const char name_with_crc[] = "mactime_add_del_range_2b1821d5";
  static vapi_message_desc_t __vapi_metadata_mactime_add_del_range = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_mactime_add_del_range, payload),
    sizeof(vapi_msg_mactime_add_del_range),
    (generic_swap_fn_t)vapi_msg_mactime_add_del_range_hton,
    (generic_swap_fn_t)vapi_msg_mactime_add_del_range_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_mactime_add_del_range = vapi_register_msg(&__vapi_metadata_mactime_add_del_range);
  VAPI_DBG("Assigned msg id %d to mactime_add_del_range", vapi_msg_id_mactime_add_del_range);
}

static void __attribute__((constructor)) __vapi_constructor_mactime_enable_disable_reply()
{
  static const char name[] = "mactime_enable_disable_reply";
  static const char name_with_crc[] = "mactime_enable_disable_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_mactime_enable_disable_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_mactime_enable_disable_reply, payload),
    sizeof(vapi_msg_mactime_enable_disable_reply),
    (generic_swap_fn_t)vapi_msg_mactime_enable_disable_reply_hton,
    (generic_swap_fn_t)vapi_msg_mactime_enable_disable_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_mactime_enable_disable_reply = vapi_register_msg(&__vapi_metadata_mactime_enable_disable_reply);
  VAPI_DBG("Assigned msg id %d to mactime_enable_disable_reply", vapi_msg_id_mactime_enable_disable_reply);
}

static void __attribute__((constructor)) __vapi_constructor_mactime_enable_disable()
{
  static const char name[] = "mactime_enable_disable";
  static const char name_with_crc[] = "mactime_enable_disable_57298519";
  static vapi_message_desc_t __vapi_metadata_mactime_enable_disable = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_mactime_enable_disable, payload),
    sizeof(vapi_msg_mactime_enable_disable),
    (generic_swap_fn_t)vapi_msg_mactime_enable_disable_hton,
    (generic_swap_fn_t)vapi_msg_mactime_enable_disable_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_mactime_enable_disable = vapi_register_msg(&__vapi_metadata_mactime_enable_disable);
  VAPI_DBG("Assigned msg id %d to mactime_enable_disable", vapi_msg_id_mactime_enable_disable);
}


static inline void vapi_set_vapi_msg_mactime_add_del_range_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_mactime_add_del_range_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_mactime_add_del_range_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_mactime_enable_disable_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_mactime_enable_disable_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_mactime_enable_disable_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
