#ifndef __included_oam_api_json
#define __included_oam_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_want_oam_events_reply;
extern vapi_msg_id_t vapi_msg_id_oam_add_del;
extern vapi_msg_id_t vapi_msg_id_oam_event;
extern vapi_msg_id_t vapi_msg_id_want_oam_events;
extern vapi_msg_id_t vapi_msg_id_oam_add_del_reply;

#define DEFINE_VAPI_MSG_IDS_OAM_API_JSON\
  vapi_msg_id_t vapi_msg_id_want_oam_events_reply;\
  vapi_msg_id_t vapi_msg_id_oam_add_del;\
  vapi_msg_id_t vapi_msg_id_oam_event;\
  vapi_msg_id_t vapi_msg_id_want_oam_events;\
  vapi_msg_id_t vapi_msg_id_oam_add_del_reply;


#ifndef defined_vapi_payload_want_oam_events_reply
#define defined_vapi_payload_want_oam_events_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_want_oam_events_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_want_oam_events_reply payload;
} vapi_msg_want_oam_events_reply;
#endif

#ifndef defined_vapi_payload_oam_add_del
#define defined_vapi_payload_oam_add_del
typedef struct __attribute__ ((__packed__)) {
  u32 vrf_id;
  u8 src_address[4];
  u8 dst_address[4];
  u8 is_add; 
} vapi_payload_oam_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_oam_add_del payload;
} vapi_msg_oam_add_del;
#endif

#ifndef defined_vapi_payload_oam_event
#define defined_vapi_payload_oam_event
typedef struct __attribute__ ((__packed__)) {
  u16 _vl_msg_id;
  u8 dst_address[4];
  u8 state; 
} vapi_payload_oam_event;

typedef struct __attribute__ ((__packed__)) {

  vapi_payload_oam_event payload;
} vapi_msg_oam_event;
#endif

#ifndef defined_vapi_payload_want_oam_events
#define defined_vapi_payload_want_oam_events
typedef struct __attribute__ ((__packed__)) {
  u32 enable_disable;
  u32 pid; 
} vapi_payload_want_oam_events;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_want_oam_events payload;
} vapi_msg_want_oam_events;
#endif

#ifndef defined_vapi_payload_oam_add_del_reply
#define defined_vapi_payload_oam_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_oam_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_oam_add_del_reply payload;
} vapi_msg_oam_add_del_reply;
#endif


static inline void vapi_msg_want_oam_events_reply_payload_hton(vapi_payload_want_oam_events_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_want_oam_events_reply_payload_ntoh(vapi_payload_want_oam_events_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_want_oam_events_reply_msg_size(vapi_msg_want_oam_events_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_want_oam_events_reply_hton(vapi_msg_want_oam_events_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_oam_events_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_want_oam_events_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_want_oam_events_reply_ntoh(vapi_msg_want_oam_events_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_oam_events_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_want_oam_events_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_oam_add_del_payload_hton(vapi_payload_oam_add_del *payload)
{
  payload->vrf_id = htobe32(payload->vrf_id);
}

static inline void vapi_msg_oam_add_del_payload_ntoh(vapi_payload_oam_add_del *payload)
{
  payload->vrf_id = be32toh(payload->vrf_id);
}

static inline uword vapi_calc_oam_add_del_msg_size(vapi_msg_oam_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_oam_add_del_hton(vapi_msg_oam_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_oam_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_oam_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_oam_add_del_ntoh(vapi_msg_oam_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_oam_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_oam_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_oam_event_payload_hton(vapi_payload_oam_event *payload)
{
  payload->_vl_msg_id = htobe16(payload->_vl_msg_id);
}

static inline void vapi_msg_oam_event_payload_ntoh(vapi_payload_oam_event *payload)
{
  payload->_vl_msg_id = be16toh(payload->_vl_msg_id);
}

static inline uword vapi_calc_oam_event_msg_size(vapi_msg_oam_event *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_oam_event_hton(vapi_msg_oam_event *msg)
{
  VAPI_DBG("Swapping `vapi_msg_oam_event'@%p to big endian", msg);

  vapi_msg_oam_event_payload_hton(&msg->payload);
}

static inline void vapi_msg_oam_event_ntoh(vapi_msg_oam_event *msg)
{
  VAPI_DBG("Swapping `vapi_msg_oam_event'@%p to host byte order", msg);

  vapi_msg_oam_event_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_want_oam_events_payload_hton(vapi_payload_want_oam_events *payload)
{
  payload->enable_disable = htobe32(payload->enable_disable);
  payload->pid = htobe32(payload->pid);
}

static inline void vapi_msg_want_oam_events_payload_ntoh(vapi_payload_want_oam_events *payload)
{
  payload->enable_disable = be32toh(payload->enable_disable);
  payload->pid = be32toh(payload->pid);
}

static inline uword vapi_calc_want_oam_events_msg_size(vapi_msg_want_oam_events *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_want_oam_events_hton(vapi_msg_want_oam_events *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_oam_events'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_want_oam_events_payload_hton(&msg->payload);
}

static inline void vapi_msg_want_oam_events_ntoh(vapi_msg_want_oam_events *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_oam_events'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_want_oam_events_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_oam_add_del_reply_payload_hton(vapi_payload_oam_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_oam_add_del_reply_payload_ntoh(vapi_payload_oam_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_oam_add_del_reply_msg_size(vapi_msg_oam_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_oam_add_del_reply_hton(vapi_msg_oam_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_oam_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_oam_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_oam_add_del_reply_ntoh(vapi_msg_oam_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_oam_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_oam_add_del_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_oam_add_del* vapi_alloc_oam_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_oam_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_oam_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_oam_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_oam_add_del);

  return msg;
}

static inline vapi_error_e vapi_oam_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_oam_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_oam_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_oam_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_oam_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_want_oam_events* vapi_alloc_want_oam_events(struct vapi_ctx_s *ctx)
{
  vapi_msg_want_oam_events *msg = NULL;
  const size_t size = sizeof(vapi_msg_want_oam_events);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_want_oam_events*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_want_oam_events);

  return msg;
}

static inline vapi_error_e vapi_want_oam_events(struct vapi_ctx_s *ctx,
  vapi_msg_want_oam_events *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_want_oam_events_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_want_oam_events_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_want_oam_events_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_want_oam_events_reply()
{
  static const char name[] = "want_oam_events_reply";
  static const char name_with_crc[] = "want_oam_events_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_want_oam_events_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_want_oam_events_reply, payload),
    sizeof(vapi_msg_want_oam_events_reply),
    (generic_swap_fn_t)vapi_msg_want_oam_events_reply_hton,
    (generic_swap_fn_t)vapi_msg_want_oam_events_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_want_oam_events_reply = vapi_register_msg(&__vapi_metadata_want_oam_events_reply);
  VAPI_DBG("Assigned msg id %d to want_oam_events_reply", vapi_msg_id_want_oam_events_reply);
}

static void __attribute__((constructor)) __vapi_constructor_oam_add_del()
{
  static const char name[] = "oam_add_del";
  static const char name_with_crc[] = "oam_add_del_3d7fcf96";
  static vapi_message_desc_t __vapi_metadata_oam_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_oam_add_del, payload),
    sizeof(vapi_msg_oam_add_del),
    (generic_swap_fn_t)vapi_msg_oam_add_del_hton,
    (generic_swap_fn_t)vapi_msg_oam_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_oam_add_del = vapi_register_msg(&__vapi_metadata_oam_add_del);
  VAPI_DBG("Assigned msg id %d to oam_add_del", vapi_msg_id_oam_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_oam_event()
{
  static const char name[] = "oam_event";
  static const char name_with_crc[] = "oam_event_a450141f";
  static vapi_message_desc_t __vapi_metadata_oam_event = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    false,
    0,
    offsetof(vapi_msg_oam_event, payload),
    sizeof(vapi_msg_oam_event),
    (generic_swap_fn_t)vapi_msg_oam_event_hton,
    (generic_swap_fn_t)vapi_msg_oam_event_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_oam_event = vapi_register_msg(&__vapi_metadata_oam_event);
  VAPI_DBG("Assigned msg id %d to oam_event", vapi_msg_id_oam_event);
}

static void __attribute__((constructor)) __vapi_constructor_want_oam_events()
{
  static const char name[] = "want_oam_events";
  static const char name_with_crc[] = "want_oam_events_476f5a08";
  static vapi_message_desc_t __vapi_metadata_want_oam_events = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_want_oam_events, payload),
    sizeof(vapi_msg_want_oam_events),
    (generic_swap_fn_t)vapi_msg_want_oam_events_hton,
    (generic_swap_fn_t)vapi_msg_want_oam_events_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_want_oam_events = vapi_register_msg(&__vapi_metadata_want_oam_events);
  VAPI_DBG("Assigned msg id %d to want_oam_events", vapi_msg_id_want_oam_events);
}

static void __attribute__((constructor)) __vapi_constructor_oam_add_del_reply()
{
  static const char name[] = "oam_add_del_reply";
  static const char name_with_crc[] = "oam_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_oam_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_oam_add_del_reply, payload),
    sizeof(vapi_msg_oam_add_del_reply),
    (generic_swap_fn_t)vapi_msg_oam_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_oam_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_oam_add_del_reply = vapi_register_msg(&__vapi_metadata_oam_add_del_reply);
  VAPI_DBG("Assigned msg id %d to oam_add_del_reply", vapi_msg_id_oam_add_del_reply);
}


static inline void vapi_set_vapi_msg_want_oam_events_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_want_oam_events_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_want_oam_events_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_oam_event_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_oam_event *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_oam_event, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_oam_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_oam_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_oam_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
