#ifndef __included_p2p_ethernet_api_json
#define __included_p2p_ethernet_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_p2p_ethernet_add;
extern vapi_msg_id_t vapi_msg_id_p2p_ethernet_del_reply;
extern vapi_msg_id_t vapi_msg_id_p2p_ethernet_del;
extern vapi_msg_id_t vapi_msg_id_p2p_ethernet_add_reply;

#define DEFINE_VAPI_MSG_IDS_P2P_ETHERNET_API_JSON\
  vapi_msg_id_t vapi_msg_id_p2p_ethernet_add;\
  vapi_msg_id_t vapi_msg_id_p2p_ethernet_del_reply;\
  vapi_msg_id_t vapi_msg_id_p2p_ethernet_del;\
  vapi_msg_id_t vapi_msg_id_p2p_ethernet_add_reply;


#ifndef defined_vapi_payload_p2p_ethernet_add
#define defined_vapi_payload_p2p_ethernet_add
typedef struct __attribute__ ((__packed__)) {
  u32 parent_if_index;
  u32 subif_id;
  u8 remote_mac[6]; 
} vapi_payload_p2p_ethernet_add;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_p2p_ethernet_add payload;
} vapi_msg_p2p_ethernet_add;
#endif

#ifndef defined_vapi_payload_p2p_ethernet_del_reply
#define defined_vapi_payload_p2p_ethernet_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_p2p_ethernet_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_p2p_ethernet_del_reply payload;
} vapi_msg_p2p_ethernet_del_reply;
#endif

#ifndef defined_vapi_payload_p2p_ethernet_del
#define defined_vapi_payload_p2p_ethernet_del
typedef struct __attribute__ ((__packed__)) {
  u32 parent_if_index;
  u8 remote_mac[6]; 
} vapi_payload_p2p_ethernet_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_p2p_ethernet_del payload;
} vapi_msg_p2p_ethernet_del;
#endif

#ifndef defined_vapi_payload_p2p_ethernet_add_reply
#define defined_vapi_payload_p2p_ethernet_add_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 sw_if_index; 
} vapi_payload_p2p_ethernet_add_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_p2p_ethernet_add_reply payload;
} vapi_msg_p2p_ethernet_add_reply;
#endif


static inline void vapi_msg_p2p_ethernet_add_payload_hton(vapi_payload_p2p_ethernet_add *payload)
{
  payload->parent_if_index = htobe32(payload->parent_if_index);
  payload->subif_id = htobe32(payload->subif_id);
}

static inline void vapi_msg_p2p_ethernet_add_payload_ntoh(vapi_payload_p2p_ethernet_add *payload)
{
  payload->parent_if_index = be32toh(payload->parent_if_index);
  payload->subif_id = be32toh(payload->subif_id);
}

static inline uword vapi_calc_p2p_ethernet_add_msg_size(vapi_msg_p2p_ethernet_add *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_p2p_ethernet_add_hton(vapi_msg_p2p_ethernet_add *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_add'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_p2p_ethernet_add_payload_hton(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_add_ntoh(vapi_msg_p2p_ethernet_add *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_add'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_p2p_ethernet_add_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_del_reply_payload_hton(vapi_payload_p2p_ethernet_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_p2p_ethernet_del_reply_payload_ntoh(vapi_payload_p2p_ethernet_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_p2p_ethernet_del_reply_msg_size(vapi_msg_p2p_ethernet_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_p2p_ethernet_del_reply_hton(vapi_msg_p2p_ethernet_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_p2p_ethernet_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_del_reply_ntoh(vapi_msg_p2p_ethernet_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_p2p_ethernet_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_del_payload_hton(vapi_payload_p2p_ethernet_del *payload)
{
  payload->parent_if_index = htobe32(payload->parent_if_index);
}

static inline void vapi_msg_p2p_ethernet_del_payload_ntoh(vapi_payload_p2p_ethernet_del *payload)
{
  payload->parent_if_index = be32toh(payload->parent_if_index);
}

static inline uword vapi_calc_p2p_ethernet_del_msg_size(vapi_msg_p2p_ethernet_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_p2p_ethernet_del_hton(vapi_msg_p2p_ethernet_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_p2p_ethernet_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_del_ntoh(vapi_msg_p2p_ethernet_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_p2p_ethernet_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_add_reply_payload_hton(vapi_payload_p2p_ethernet_add_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_p2p_ethernet_add_reply_payload_ntoh(vapi_payload_p2p_ethernet_add_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_p2p_ethernet_add_reply_msg_size(vapi_msg_p2p_ethernet_add_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_p2p_ethernet_add_reply_hton(vapi_msg_p2p_ethernet_add_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_add_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_p2p_ethernet_add_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_p2p_ethernet_add_reply_ntoh(vapi_msg_p2p_ethernet_add_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_p2p_ethernet_add_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_p2p_ethernet_add_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_p2p_ethernet_add* vapi_alloc_p2p_ethernet_add(struct vapi_ctx_s *ctx)
{
  vapi_msg_p2p_ethernet_add *msg = NULL;
  const size_t size = sizeof(vapi_msg_p2p_ethernet_add);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_p2p_ethernet_add*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_p2p_ethernet_add);

  return msg;
}

static inline vapi_error_e vapi_p2p_ethernet_add(struct vapi_ctx_s *ctx,
  vapi_msg_p2p_ethernet_add *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_p2p_ethernet_add_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_p2p_ethernet_add_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_p2p_ethernet_add_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_p2p_ethernet_del* vapi_alloc_p2p_ethernet_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_p2p_ethernet_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_p2p_ethernet_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_p2p_ethernet_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_p2p_ethernet_del);

  return msg;
}

static inline vapi_error_e vapi_p2p_ethernet_del(struct vapi_ctx_s *ctx,
  vapi_msg_p2p_ethernet_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_p2p_ethernet_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_p2p_ethernet_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_p2p_ethernet_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_p2p_ethernet_add()
{
  static const char name[] = "p2p_ethernet_add";
  static const char name_with_crc[] = "p2p_ethernet_add_7f4abf1a";
  static vapi_message_desc_t __vapi_metadata_p2p_ethernet_add = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_p2p_ethernet_add, payload),
    sizeof(vapi_msg_p2p_ethernet_add),
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_add_hton,
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_add_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_p2p_ethernet_add = vapi_register_msg(&__vapi_metadata_p2p_ethernet_add);
  VAPI_DBG("Assigned msg id %d to p2p_ethernet_add", vapi_msg_id_p2p_ethernet_add);
}

static void __attribute__((constructor)) __vapi_constructor_p2p_ethernet_del_reply()
{
  static const char name[] = "p2p_ethernet_del_reply";
  static const char name_with_crc[] = "p2p_ethernet_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_p2p_ethernet_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_p2p_ethernet_del_reply, payload),
    sizeof(vapi_msg_p2p_ethernet_del_reply),
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_p2p_ethernet_del_reply = vapi_register_msg(&__vapi_metadata_p2p_ethernet_del_reply);
  VAPI_DBG("Assigned msg id %d to p2p_ethernet_del_reply", vapi_msg_id_p2p_ethernet_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_p2p_ethernet_del()
{
  static const char name[] = "p2p_ethernet_del";
  static const char name_with_crc[] = "p2p_ethernet_del_1efa374a";
  static vapi_message_desc_t __vapi_metadata_p2p_ethernet_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_p2p_ethernet_del, payload),
    sizeof(vapi_msg_p2p_ethernet_del),
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_del_hton,
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_p2p_ethernet_del = vapi_register_msg(&__vapi_metadata_p2p_ethernet_del);
  VAPI_DBG("Assigned msg id %d to p2p_ethernet_del", vapi_msg_id_p2p_ethernet_del);
}

static void __attribute__((constructor)) __vapi_constructor_p2p_ethernet_add_reply()
{
  static const char name[] = "p2p_ethernet_add_reply";
  static const char name_with_crc[] = "p2p_ethernet_add_reply_fda5941f";
  static vapi_message_desc_t __vapi_metadata_p2p_ethernet_add_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_p2p_ethernet_add_reply, payload),
    sizeof(vapi_msg_p2p_ethernet_add_reply),
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_add_reply_hton,
    (generic_swap_fn_t)vapi_msg_p2p_ethernet_add_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_p2p_ethernet_add_reply = vapi_register_msg(&__vapi_metadata_p2p_ethernet_add_reply);
  VAPI_DBG("Assigned msg id %d to p2p_ethernet_add_reply", vapi_msg_id_p2p_ethernet_add_reply);
}


static inline void vapi_set_vapi_msg_p2p_ethernet_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_p2p_ethernet_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_p2p_ethernet_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_p2p_ethernet_add_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_p2p_ethernet_add_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_p2p_ethernet_add_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
