#ifndef __included_punt_api_json
#define __included_punt_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_punt_socket_register;
extern vapi_msg_id_t vapi_msg_id_punt_socket_deregister;
extern vapi_msg_id_t vapi_msg_id_punt_socket_register_reply;
extern vapi_msg_id_t vapi_msg_id_punt;
extern vapi_msg_id_t vapi_msg_id_punt_socket_deregister_reply;
extern vapi_msg_id_t vapi_msg_id_punt_reply;

#define DEFINE_VAPI_MSG_IDS_PUNT_API_JSON\
  vapi_msg_id_t vapi_msg_id_punt_socket_register;\
  vapi_msg_id_t vapi_msg_id_punt_socket_deregister;\
  vapi_msg_id_t vapi_msg_id_punt_socket_register_reply;\
  vapi_msg_id_t vapi_msg_id_punt;\
  vapi_msg_id_t vapi_msg_id_punt_socket_deregister_reply;\
  vapi_msg_id_t vapi_msg_id_punt_reply;


#ifndef defined_vapi_payload_punt_socket_register
#define defined_vapi_payload_punt_socket_register
typedef struct __attribute__ ((__packed__)) {
  u32 header_version;
  u8 is_ip4;
  u8 l4_protocol;
  u16 l4_port;
  u8 pathname[108]; 
} vapi_payload_punt_socket_register;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_punt_socket_register payload;
} vapi_msg_punt_socket_register;
#endif

#ifndef defined_vapi_payload_punt_socket_deregister
#define defined_vapi_payload_punt_socket_deregister
typedef struct __attribute__ ((__packed__)) {
  u8 is_ip4;
  u8 l4_protocol;
  u16 l4_port; 
} vapi_payload_punt_socket_deregister;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_punt_socket_deregister payload;
} vapi_msg_punt_socket_deregister;
#endif

#ifndef defined_vapi_payload_punt_socket_register_reply
#define defined_vapi_payload_punt_socket_register_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u8 pathname[64]; 
} vapi_payload_punt_socket_register_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_punt_socket_register_reply payload;
} vapi_msg_punt_socket_register_reply;
#endif

#ifndef defined_vapi_payload_punt
#define defined_vapi_payload_punt
typedef struct __attribute__ ((__packed__)) {
  u8 is_add;
  u8 ipv;
  u8 l4_protocol;
  u16 l4_port; 
} vapi_payload_punt;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_punt payload;
} vapi_msg_punt;
#endif

#ifndef defined_vapi_payload_punt_socket_deregister_reply
#define defined_vapi_payload_punt_socket_deregister_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_punt_socket_deregister_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_punt_socket_deregister_reply payload;
} vapi_msg_punt_socket_deregister_reply;
#endif

#ifndef defined_vapi_payload_punt_reply
#define defined_vapi_payload_punt_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_punt_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_punt_reply payload;
} vapi_msg_punt_reply;
#endif


static inline void vapi_msg_punt_socket_register_payload_hton(vapi_payload_punt_socket_register *payload)
{
  payload->header_version = htobe32(payload->header_version);
  payload->l4_port = htobe16(payload->l4_port);
}

static inline void vapi_msg_punt_socket_register_payload_ntoh(vapi_payload_punt_socket_register *payload)
{
  payload->header_version = be32toh(payload->header_version);
  payload->l4_port = be16toh(payload->l4_port);
}

static inline uword vapi_calc_punt_socket_register_msg_size(vapi_msg_punt_socket_register *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_punt_socket_register_hton(vapi_msg_punt_socket_register *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_register'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_punt_socket_register_payload_hton(&msg->payload);
}

static inline void vapi_msg_punt_socket_register_ntoh(vapi_msg_punt_socket_register *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_register'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_punt_socket_register_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_punt_socket_deregister_payload_hton(vapi_payload_punt_socket_deregister *payload)
{
  payload->l4_port = htobe16(payload->l4_port);
}

static inline void vapi_msg_punt_socket_deregister_payload_ntoh(vapi_payload_punt_socket_deregister *payload)
{
  payload->l4_port = be16toh(payload->l4_port);
}

static inline uword vapi_calc_punt_socket_deregister_msg_size(vapi_msg_punt_socket_deregister *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_punt_socket_deregister_hton(vapi_msg_punt_socket_deregister *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_deregister'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_punt_socket_deregister_payload_hton(&msg->payload);
}

static inline void vapi_msg_punt_socket_deregister_ntoh(vapi_msg_punt_socket_deregister *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_deregister'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_punt_socket_deregister_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_punt_socket_register_reply_payload_hton(vapi_payload_punt_socket_register_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_punt_socket_register_reply_payload_ntoh(vapi_payload_punt_socket_register_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_punt_socket_register_reply_msg_size(vapi_msg_punt_socket_register_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_punt_socket_register_reply_hton(vapi_msg_punt_socket_register_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_register_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_punt_socket_register_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_punt_socket_register_reply_ntoh(vapi_msg_punt_socket_register_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_register_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_punt_socket_register_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_punt_payload_hton(vapi_payload_punt *payload)
{
  payload->l4_port = htobe16(payload->l4_port);
}

static inline void vapi_msg_punt_payload_ntoh(vapi_payload_punt *payload)
{
  payload->l4_port = be16toh(payload->l4_port);
}

static inline uword vapi_calc_punt_msg_size(vapi_msg_punt *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_punt_hton(vapi_msg_punt *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_punt_payload_hton(&msg->payload);
}

static inline void vapi_msg_punt_ntoh(vapi_msg_punt *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_punt_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_punt_socket_deregister_reply_payload_hton(vapi_payload_punt_socket_deregister_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_punt_socket_deregister_reply_payload_ntoh(vapi_payload_punt_socket_deregister_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_punt_socket_deregister_reply_msg_size(vapi_msg_punt_socket_deregister_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_punt_socket_deregister_reply_hton(vapi_msg_punt_socket_deregister_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_deregister_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_punt_socket_deregister_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_punt_socket_deregister_reply_ntoh(vapi_msg_punt_socket_deregister_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_socket_deregister_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_punt_socket_deregister_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_punt_reply_payload_hton(vapi_payload_punt_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_punt_reply_payload_ntoh(vapi_payload_punt_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_punt_reply_msg_size(vapi_msg_punt_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_punt_reply_hton(vapi_msg_punt_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_punt_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_punt_reply_ntoh(vapi_msg_punt_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_punt_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_punt_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_punt_socket_register* vapi_alloc_punt_socket_register(struct vapi_ctx_s *ctx)
{
  vapi_msg_punt_socket_register *msg = NULL;
  const size_t size = sizeof(vapi_msg_punt_socket_register);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_punt_socket_register*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_punt_socket_register);

  return msg;
}

static inline vapi_error_e vapi_punt_socket_register(struct vapi_ctx_s *ctx,
  vapi_msg_punt_socket_register *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_punt_socket_register_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_punt_socket_register_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_punt_socket_register_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_punt_socket_deregister* vapi_alloc_punt_socket_deregister(struct vapi_ctx_s *ctx)
{
  vapi_msg_punt_socket_deregister *msg = NULL;
  const size_t size = sizeof(vapi_msg_punt_socket_deregister);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_punt_socket_deregister*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_punt_socket_deregister);

  return msg;
}

static inline vapi_error_e vapi_punt_socket_deregister(struct vapi_ctx_s *ctx,
  vapi_msg_punt_socket_deregister *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_punt_socket_deregister_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_punt_socket_deregister_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_punt_socket_deregister_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_punt* vapi_alloc_punt(struct vapi_ctx_s *ctx)
{
  vapi_msg_punt *msg = NULL;
  const size_t size = sizeof(vapi_msg_punt);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_punt*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_punt);

  return msg;
}

static inline vapi_error_e vapi_punt(struct vapi_ctx_s *ctx,
  vapi_msg_punt *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_punt_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_punt_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_punt_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_punt_socket_register()
{
  static const char name[] = "punt_socket_register";
  static const char name_with_crc[] = "punt_socket_register_c163b363";
  static vapi_message_desc_t __vapi_metadata_punt_socket_register = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_punt_socket_register, payload),
    sizeof(vapi_msg_punt_socket_register),
    (generic_swap_fn_t)vapi_msg_punt_socket_register_hton,
    (generic_swap_fn_t)vapi_msg_punt_socket_register_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_punt_socket_register = vapi_register_msg(&__vapi_metadata_punt_socket_register);
  VAPI_DBG("Assigned msg id %d to punt_socket_register", vapi_msg_id_punt_socket_register);
}

static void __attribute__((constructor)) __vapi_constructor_punt_socket_deregister()
{
  static const char name[] = "punt_socket_deregister";
  static const char name_with_crc[] = "punt_socket_deregister_9846a4cc";
  static vapi_message_desc_t __vapi_metadata_punt_socket_deregister = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_punt_socket_deregister, payload),
    sizeof(vapi_msg_punt_socket_deregister),
    (generic_swap_fn_t)vapi_msg_punt_socket_deregister_hton,
    (generic_swap_fn_t)vapi_msg_punt_socket_deregister_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_punt_socket_deregister = vapi_register_msg(&__vapi_metadata_punt_socket_deregister);
  VAPI_DBG("Assigned msg id %d to punt_socket_deregister", vapi_msg_id_punt_socket_deregister);
}

static void __attribute__((constructor)) __vapi_constructor_punt_socket_register_reply()
{
  static const char name[] = "punt_socket_register_reply";
  static const char name_with_crc[] = "punt_socket_register_reply_42dc0ee6";
  static vapi_message_desc_t __vapi_metadata_punt_socket_register_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_punt_socket_register_reply, payload),
    sizeof(vapi_msg_punt_socket_register_reply),
    (generic_swap_fn_t)vapi_msg_punt_socket_register_reply_hton,
    (generic_swap_fn_t)vapi_msg_punt_socket_register_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_punt_socket_register_reply = vapi_register_msg(&__vapi_metadata_punt_socket_register_reply);
  VAPI_DBG("Assigned msg id %d to punt_socket_register_reply", vapi_msg_id_punt_socket_register_reply);
}

static void __attribute__((constructor)) __vapi_constructor_punt()
{
  static const char name[] = "punt";
  static const char name_with_crc[] = "punt_37760008";
  static vapi_message_desc_t __vapi_metadata_punt = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_punt, payload),
    sizeof(vapi_msg_punt),
    (generic_swap_fn_t)vapi_msg_punt_hton,
    (generic_swap_fn_t)vapi_msg_punt_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_punt = vapi_register_msg(&__vapi_metadata_punt);
  VAPI_DBG("Assigned msg id %d to punt", vapi_msg_id_punt);
}

static void __attribute__((constructor)) __vapi_constructor_punt_socket_deregister_reply()
{
  static const char name[] = "punt_socket_deregister_reply";
  static const char name_with_crc[] = "punt_socket_deregister_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_punt_socket_deregister_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_punt_socket_deregister_reply, payload),
    sizeof(vapi_msg_punt_socket_deregister_reply),
    (generic_swap_fn_t)vapi_msg_punt_socket_deregister_reply_hton,
    (generic_swap_fn_t)vapi_msg_punt_socket_deregister_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_punt_socket_deregister_reply = vapi_register_msg(&__vapi_metadata_punt_socket_deregister_reply);
  VAPI_DBG("Assigned msg id %d to punt_socket_deregister_reply", vapi_msg_id_punt_socket_deregister_reply);
}

static void __attribute__((constructor)) __vapi_constructor_punt_reply()
{
  static const char name[] = "punt_reply";
  static const char name_with_crc[] = "punt_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_punt_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_punt_reply, payload),
    sizeof(vapi_msg_punt_reply),
    (generic_swap_fn_t)vapi_msg_punt_reply_hton,
    (generic_swap_fn_t)vapi_msg_punt_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_punt_reply = vapi_register_msg(&__vapi_metadata_punt_reply);
  VAPI_DBG("Assigned msg id %d to punt_reply", vapi_msg_id_punt_reply);
}


static inline void vapi_set_vapi_msg_punt_socket_register_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_punt_socket_register_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_punt_socket_register_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_punt_socket_deregister_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_punt_socket_deregister_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_punt_socket_deregister_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_punt_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_punt_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_punt_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
