#ifndef __included_qos_api_json
#define __included_qos_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_qos_record_enable_disable;
extern vapi_msg_id_t vapi_msg_id_qos_mark_enable_disable;
extern vapi_msg_id_t vapi_msg_id_qos_egress_map_delete_reply;
extern vapi_msg_id_t vapi_msg_id_qos_record_enable_disable_reply;
extern vapi_msg_id_t vapi_msg_id_qos_egress_map_update_reply;
extern vapi_msg_id_t vapi_msg_id_qos_egress_map_update;
extern vapi_msg_id_t vapi_msg_id_qos_egress_map_delete;
extern vapi_msg_id_t vapi_msg_id_qos_mark_enable_disable_reply;

#define DEFINE_VAPI_MSG_IDS_QOS_API_JSON\
  vapi_msg_id_t vapi_msg_id_qos_record_enable_disable;\
  vapi_msg_id_t vapi_msg_id_qos_mark_enable_disable;\
  vapi_msg_id_t vapi_msg_id_qos_egress_map_delete_reply;\
  vapi_msg_id_t vapi_msg_id_qos_record_enable_disable_reply;\
  vapi_msg_id_t vapi_msg_id_qos_egress_map_update_reply;\
  vapi_msg_id_t vapi_msg_id_qos_egress_map_update;\
  vapi_msg_id_t vapi_msg_id_qos_egress_map_delete;\
  vapi_msg_id_t vapi_msg_id_qos_mark_enable_disable_reply;


#ifndef defined_vapi_type_qos_egress_map_row
#define defined_vapi_type_qos_egress_map_row
typedef struct __attribute__((__packed__)) {
  u8 outputs[256];
} vapi_type_qos_egress_map_row;
#endif

#ifndef defined_vapi_payload_qos_record_enable_disable
#define defined_vapi_payload_qos_record_enable_disable
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 input_source;
  u8 enable; 
} vapi_payload_qos_record_enable_disable;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_qos_record_enable_disable payload;
} vapi_msg_qos_record_enable_disable;
#endif

#ifndef defined_vapi_payload_qos_mark_enable_disable
#define defined_vapi_payload_qos_mark_enable_disable
typedef struct __attribute__ ((__packed__)) {
  u32 map_id;
  u32 sw_if_index;
  u8 output_source;
  u8 enable; 
} vapi_payload_qos_mark_enable_disable;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_qos_mark_enable_disable payload;
} vapi_msg_qos_mark_enable_disable;
#endif

#ifndef defined_vapi_payload_qos_egress_map_delete_reply
#define defined_vapi_payload_qos_egress_map_delete_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_qos_egress_map_delete_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_qos_egress_map_delete_reply payload;
} vapi_msg_qos_egress_map_delete_reply;
#endif

#ifndef defined_vapi_payload_qos_record_enable_disable_reply
#define defined_vapi_payload_qos_record_enable_disable_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_qos_record_enable_disable_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_qos_record_enable_disable_reply payload;
} vapi_msg_qos_record_enable_disable_reply;
#endif

#ifndef defined_vapi_payload_qos_egress_map_update_reply
#define defined_vapi_payload_qos_egress_map_update_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_qos_egress_map_update_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_qos_egress_map_update_reply payload;
} vapi_msg_qos_egress_map_update_reply;
#endif

#ifndef defined_vapi_payload_qos_egress_map_update
#define defined_vapi_payload_qos_egress_map_update
typedef struct __attribute__ ((__packed__)) {
  u32 map_id;
  vapi_type_qos_egress_map_row rows[4]; 
} vapi_payload_qos_egress_map_update;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_qos_egress_map_update payload;
} vapi_msg_qos_egress_map_update;
#endif

#ifndef defined_vapi_payload_qos_egress_map_delete
#define defined_vapi_payload_qos_egress_map_delete
typedef struct __attribute__ ((__packed__)) {
  u32 map_id; 
} vapi_payload_qos_egress_map_delete;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_qos_egress_map_delete payload;
} vapi_msg_qos_egress_map_delete;
#endif

#ifndef defined_vapi_payload_qos_mark_enable_disable_reply
#define defined_vapi_payload_qos_mark_enable_disable_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_qos_mark_enable_disable_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_qos_mark_enable_disable_reply payload;
} vapi_msg_qos_mark_enable_disable_reply;
#endif


#ifndef defined_inline_vapi_type_qos_egress_map_row
#define defined_inline_vapi_type_qos_egress_map_row
static inline void vapi_type_qos_egress_map_row_hton(vapi_type_qos_egress_map_row *msg)
{

}

static inline void vapi_type_qos_egress_map_row_ntoh(vapi_type_qos_egress_map_row *msg)
{

}
#endif

static inline void vapi_msg_qos_record_enable_disable_payload_hton(vapi_payload_qos_record_enable_disable *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_qos_record_enable_disable_payload_ntoh(vapi_payload_qos_record_enable_disable *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_qos_record_enable_disable_msg_size(vapi_msg_qos_record_enable_disable *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_record_enable_disable_hton(vapi_msg_qos_record_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_record_enable_disable'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_qos_record_enable_disable_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_record_enable_disable_ntoh(vapi_msg_qos_record_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_record_enable_disable'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_qos_record_enable_disable_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_mark_enable_disable_payload_hton(vapi_payload_qos_mark_enable_disable *payload)
{
  payload->map_id = htobe32(payload->map_id);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_qos_mark_enable_disable_payload_ntoh(vapi_payload_qos_mark_enable_disable *payload)
{
  payload->map_id = be32toh(payload->map_id);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_qos_mark_enable_disable_msg_size(vapi_msg_qos_mark_enable_disable *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_mark_enable_disable_hton(vapi_msg_qos_mark_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_mark_enable_disable'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_qos_mark_enable_disable_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_mark_enable_disable_ntoh(vapi_msg_qos_mark_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_mark_enable_disable'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_qos_mark_enable_disable_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_delete_reply_payload_hton(vapi_payload_qos_egress_map_delete_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_qos_egress_map_delete_reply_payload_ntoh(vapi_payload_qos_egress_map_delete_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_qos_egress_map_delete_reply_msg_size(vapi_msg_qos_egress_map_delete_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_egress_map_delete_reply_hton(vapi_msg_qos_egress_map_delete_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_delete_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_qos_egress_map_delete_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_delete_reply_ntoh(vapi_msg_qos_egress_map_delete_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_delete_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_qos_egress_map_delete_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_record_enable_disable_reply_payload_hton(vapi_payload_qos_record_enable_disable_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_qos_record_enable_disable_reply_payload_ntoh(vapi_payload_qos_record_enable_disable_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_qos_record_enable_disable_reply_msg_size(vapi_msg_qos_record_enable_disable_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_record_enable_disable_reply_hton(vapi_msg_qos_record_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_record_enable_disable_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_qos_record_enable_disable_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_record_enable_disable_reply_ntoh(vapi_msg_qos_record_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_record_enable_disable_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_qos_record_enable_disable_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_update_reply_payload_hton(vapi_payload_qos_egress_map_update_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_qos_egress_map_update_reply_payload_ntoh(vapi_payload_qos_egress_map_update_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_qos_egress_map_update_reply_msg_size(vapi_msg_qos_egress_map_update_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_egress_map_update_reply_hton(vapi_msg_qos_egress_map_update_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_update_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_qos_egress_map_update_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_update_reply_ntoh(vapi_msg_qos_egress_map_update_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_update_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_qos_egress_map_update_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_update_payload_hton(vapi_payload_qos_egress_map_update *payload)
{
  payload->map_id = htobe32(payload->map_id);
}

static inline void vapi_msg_qos_egress_map_update_payload_ntoh(vapi_payload_qos_egress_map_update *payload)
{
  payload->map_id = be32toh(payload->map_id);
}

static inline uword vapi_calc_qos_egress_map_update_msg_size(vapi_msg_qos_egress_map_update *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_egress_map_update_hton(vapi_msg_qos_egress_map_update *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_update'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_qos_egress_map_update_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_update_ntoh(vapi_msg_qos_egress_map_update *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_update'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_qos_egress_map_update_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_delete_payload_hton(vapi_payload_qos_egress_map_delete *payload)
{
  payload->map_id = htobe32(payload->map_id);
}

static inline void vapi_msg_qos_egress_map_delete_payload_ntoh(vapi_payload_qos_egress_map_delete *payload)
{
  payload->map_id = be32toh(payload->map_id);
}

static inline uword vapi_calc_qos_egress_map_delete_msg_size(vapi_msg_qos_egress_map_delete *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_egress_map_delete_hton(vapi_msg_qos_egress_map_delete *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_delete'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_qos_egress_map_delete_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_egress_map_delete_ntoh(vapi_msg_qos_egress_map_delete *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_egress_map_delete'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_qos_egress_map_delete_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_qos_mark_enable_disable_reply_payload_hton(vapi_payload_qos_mark_enable_disable_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_qos_mark_enable_disable_reply_payload_ntoh(vapi_payload_qos_mark_enable_disable_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_qos_mark_enable_disable_reply_msg_size(vapi_msg_qos_mark_enable_disable_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_qos_mark_enable_disable_reply_hton(vapi_msg_qos_mark_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_mark_enable_disable_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_qos_mark_enable_disable_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_qos_mark_enable_disable_reply_ntoh(vapi_msg_qos_mark_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_qos_mark_enable_disable_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_qos_mark_enable_disable_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_qos_record_enable_disable* vapi_alloc_qos_record_enable_disable(struct vapi_ctx_s *ctx)
{
  vapi_msg_qos_record_enable_disable *msg = NULL;
  const size_t size = sizeof(vapi_msg_qos_record_enable_disable);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_qos_record_enable_disable*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_qos_record_enable_disable);

  return msg;
}

static inline vapi_error_e vapi_qos_record_enable_disable(struct vapi_ctx_s *ctx,
  vapi_msg_qos_record_enable_disable *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_qos_record_enable_disable_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_qos_record_enable_disable_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_qos_record_enable_disable_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_qos_mark_enable_disable* vapi_alloc_qos_mark_enable_disable(struct vapi_ctx_s *ctx)
{
  vapi_msg_qos_mark_enable_disable *msg = NULL;
  const size_t size = sizeof(vapi_msg_qos_mark_enable_disable);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_qos_mark_enable_disable*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_qos_mark_enable_disable);

  return msg;
}

static inline vapi_error_e vapi_qos_mark_enable_disable(struct vapi_ctx_s *ctx,
  vapi_msg_qos_mark_enable_disable *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_qos_mark_enable_disable_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_qos_mark_enable_disable_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_qos_mark_enable_disable_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_qos_egress_map_update* vapi_alloc_qos_egress_map_update(struct vapi_ctx_s *ctx)
{
  vapi_msg_qos_egress_map_update *msg = NULL;
  const size_t size = sizeof(vapi_msg_qos_egress_map_update);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_qos_egress_map_update*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_qos_egress_map_update);

  return msg;
}

static inline vapi_error_e vapi_qos_egress_map_update(struct vapi_ctx_s *ctx,
  vapi_msg_qos_egress_map_update *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_qos_egress_map_update_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_qos_egress_map_update_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_qos_egress_map_update_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_qos_egress_map_delete* vapi_alloc_qos_egress_map_delete(struct vapi_ctx_s *ctx)
{
  vapi_msg_qos_egress_map_delete *msg = NULL;
  const size_t size = sizeof(vapi_msg_qos_egress_map_delete);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_qos_egress_map_delete*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_qos_egress_map_delete);

  return msg;
}

static inline vapi_error_e vapi_qos_egress_map_delete(struct vapi_ctx_s *ctx,
  vapi_msg_qos_egress_map_delete *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_qos_egress_map_delete_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_qos_egress_map_delete_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_qos_egress_map_delete_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_qos_record_enable_disable()
{
  static const char name[] = "qos_record_enable_disable";
  static const char name_with_crc[] = "qos_record_enable_disable_3e6384d6";
  static vapi_message_desc_t __vapi_metadata_qos_record_enable_disable = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_qos_record_enable_disable, payload),
    sizeof(vapi_msg_qos_record_enable_disable),
    (generic_swap_fn_t)vapi_msg_qos_record_enable_disable_hton,
    (generic_swap_fn_t)vapi_msg_qos_record_enable_disable_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_record_enable_disable = vapi_register_msg(&__vapi_metadata_qos_record_enable_disable);
  VAPI_DBG("Assigned msg id %d to qos_record_enable_disable", vapi_msg_id_qos_record_enable_disable);
}

static void __attribute__((constructor)) __vapi_constructor_qos_mark_enable_disable()
{
  static const char name[] = "qos_mark_enable_disable";
  static const char name_with_crc[] = "qos_mark_enable_disable_a32842dc";
  static vapi_message_desc_t __vapi_metadata_qos_mark_enable_disable = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_qos_mark_enable_disable, payload),
    sizeof(vapi_msg_qos_mark_enable_disable),
    (generic_swap_fn_t)vapi_msg_qos_mark_enable_disable_hton,
    (generic_swap_fn_t)vapi_msg_qos_mark_enable_disable_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_mark_enable_disable = vapi_register_msg(&__vapi_metadata_qos_mark_enable_disable);
  VAPI_DBG("Assigned msg id %d to qos_mark_enable_disable", vapi_msg_id_qos_mark_enable_disable);
}

static void __attribute__((constructor)) __vapi_constructor_qos_egress_map_delete_reply()
{
  static const char name[] = "qos_egress_map_delete_reply";
  static const char name_with_crc[] = "qos_egress_map_delete_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_qos_egress_map_delete_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_qos_egress_map_delete_reply, payload),
    sizeof(vapi_msg_qos_egress_map_delete_reply),
    (generic_swap_fn_t)vapi_msg_qos_egress_map_delete_reply_hton,
    (generic_swap_fn_t)vapi_msg_qos_egress_map_delete_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_egress_map_delete_reply = vapi_register_msg(&__vapi_metadata_qos_egress_map_delete_reply);
  VAPI_DBG("Assigned msg id %d to qos_egress_map_delete_reply", vapi_msg_id_qos_egress_map_delete_reply);
}

static void __attribute__((constructor)) __vapi_constructor_qos_record_enable_disable_reply()
{
  static const char name[] = "qos_record_enable_disable_reply";
  static const char name_with_crc[] = "qos_record_enable_disable_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_qos_record_enable_disable_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_qos_record_enable_disable_reply, payload),
    sizeof(vapi_msg_qos_record_enable_disable_reply),
    (generic_swap_fn_t)vapi_msg_qos_record_enable_disable_reply_hton,
    (generic_swap_fn_t)vapi_msg_qos_record_enable_disable_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_record_enable_disable_reply = vapi_register_msg(&__vapi_metadata_qos_record_enable_disable_reply);
  VAPI_DBG("Assigned msg id %d to qos_record_enable_disable_reply", vapi_msg_id_qos_record_enable_disable_reply);
}

static void __attribute__((constructor)) __vapi_constructor_qos_egress_map_update_reply()
{
  static const char name[] = "qos_egress_map_update_reply";
  static const char name_with_crc[] = "qos_egress_map_update_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_qos_egress_map_update_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_qos_egress_map_update_reply, payload),
    sizeof(vapi_msg_qos_egress_map_update_reply),
    (generic_swap_fn_t)vapi_msg_qos_egress_map_update_reply_hton,
    (generic_swap_fn_t)vapi_msg_qos_egress_map_update_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_egress_map_update_reply = vapi_register_msg(&__vapi_metadata_qos_egress_map_update_reply);
  VAPI_DBG("Assigned msg id %d to qos_egress_map_update_reply", vapi_msg_id_qos_egress_map_update_reply);
}

static void __attribute__((constructor)) __vapi_constructor_qos_egress_map_update()
{
  static const char name[] = "qos_egress_map_update";
  static const char name_with_crc[] = "qos_egress_map_update_5d5c3cad";
  static vapi_message_desc_t __vapi_metadata_qos_egress_map_update = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_qos_egress_map_update, payload),
    sizeof(vapi_msg_qos_egress_map_update),
    (generic_swap_fn_t)vapi_msg_qos_egress_map_update_hton,
    (generic_swap_fn_t)vapi_msg_qos_egress_map_update_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_egress_map_update = vapi_register_msg(&__vapi_metadata_qos_egress_map_update);
  VAPI_DBG("Assigned msg id %d to qos_egress_map_update", vapi_msg_id_qos_egress_map_update);
}

static void __attribute__((constructor)) __vapi_constructor_qos_egress_map_delete()
{
  static const char name[] = "qos_egress_map_delete";
  static const char name_with_crc[] = "qos_egress_map_delete_daab68c1";
  static vapi_message_desc_t __vapi_metadata_qos_egress_map_delete = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_qos_egress_map_delete, payload),
    sizeof(vapi_msg_qos_egress_map_delete),
    (generic_swap_fn_t)vapi_msg_qos_egress_map_delete_hton,
    (generic_swap_fn_t)vapi_msg_qos_egress_map_delete_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_egress_map_delete = vapi_register_msg(&__vapi_metadata_qos_egress_map_delete);
  VAPI_DBG("Assigned msg id %d to qos_egress_map_delete", vapi_msg_id_qos_egress_map_delete);
}

static void __attribute__((constructor)) __vapi_constructor_qos_mark_enable_disable_reply()
{
  static const char name[] = "qos_mark_enable_disable_reply";
  static const char name_with_crc[] = "qos_mark_enable_disable_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_qos_mark_enable_disable_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_qos_mark_enable_disable_reply, payload),
    sizeof(vapi_msg_qos_mark_enable_disable_reply),
    (generic_swap_fn_t)vapi_msg_qos_mark_enable_disable_reply_hton,
    (generic_swap_fn_t)vapi_msg_qos_mark_enable_disable_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_qos_mark_enable_disable_reply = vapi_register_msg(&__vapi_metadata_qos_mark_enable_disable_reply);
  VAPI_DBG("Assigned msg id %d to qos_mark_enable_disable_reply", vapi_msg_id_qos_mark_enable_disable_reply);
}


static inline void vapi_set_vapi_msg_qos_egress_map_delete_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_qos_egress_map_delete_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_qos_egress_map_delete_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_qos_record_enable_disable_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_qos_record_enable_disable_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_qos_record_enable_disable_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_qos_egress_map_update_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_qos_egress_map_update_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_qos_egress_map_update_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_qos_mark_enable_disable_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_qos_mark_enable_disable_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_qos_mark_enable_disable_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
