#ifndef __included_tap_api_json
#define __included_tap_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_tap_connect_reply;
extern vapi_msg_id_t vapi_msg_id_tap_modify_reply;
extern vapi_msg_id_t vapi_msg_id_sw_interface_tap_dump;
extern vapi_msg_id_t vapi_msg_id_tap_connect;
extern vapi_msg_id_t vapi_msg_id_tap_modify;
extern vapi_msg_id_t vapi_msg_id_tap_delete;
extern vapi_msg_id_t vapi_msg_id_tap_delete_reply;
extern vapi_msg_id_t vapi_msg_id_sw_interface_tap_details;

#define DEFINE_VAPI_MSG_IDS_TAP_API_JSON\
  vapi_msg_id_t vapi_msg_id_tap_connect_reply;\
  vapi_msg_id_t vapi_msg_id_tap_modify_reply;\
  vapi_msg_id_t vapi_msg_id_sw_interface_tap_dump;\
  vapi_msg_id_t vapi_msg_id_tap_connect;\
  vapi_msg_id_t vapi_msg_id_tap_modify;\
  vapi_msg_id_t vapi_msg_id_tap_delete;\
  vapi_msg_id_t vapi_msg_id_tap_delete_reply;\
  vapi_msg_id_t vapi_msg_id_sw_interface_tap_details;


#ifndef defined_vapi_payload_tap_connect_reply
#define defined_vapi_payload_tap_connect_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 sw_if_index; 
} vapi_payload_tap_connect_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_tap_connect_reply payload;
} vapi_msg_tap_connect_reply;
#endif

#ifndef defined_vapi_payload_tap_modify_reply
#define defined_vapi_payload_tap_modify_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 sw_if_index; 
} vapi_payload_tap_modify_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_tap_modify_reply payload;
} vapi_msg_tap_modify_reply;
#endif

#ifndef defined_vapi_payload_sw_interface_tap_dump
#define defined_vapi_payload_sw_interface_tap_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_sw_interface_tap_dump;
#endif

#ifndef defined_vapi_payload_tap_connect
#define defined_vapi_payload_tap_connect
typedef struct __attribute__ ((__packed__)) {
  u8 use_random_mac;
  u8 tap_name[64];
  u8 mac_address[6];
  u8 renumber;
  u32 custom_dev_instance;
  u8 ip4_address_set;
  u8 ip4_address[4];
  u8 ip4_mask_width;
  u8 ip6_address_set;
  u8 ip6_address[16];
  u8 ip6_mask_width;
  u8 tag[64]; 
} vapi_payload_tap_connect;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_tap_connect payload;
} vapi_msg_tap_connect;
#endif

#ifndef defined_vapi_payload_tap_modify
#define defined_vapi_payload_tap_modify
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 use_random_mac;
  u8 tap_name[64];
  u8 mac_address[6];
  u8 renumber;
  u32 custom_dev_instance; 
} vapi_payload_tap_modify;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_tap_modify payload;
} vapi_msg_tap_modify;
#endif

#ifndef defined_vapi_payload_tap_delete
#define defined_vapi_payload_tap_delete
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index; 
} vapi_payload_tap_delete;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_tap_delete payload;
} vapi_msg_tap_delete;
#endif

#ifndef defined_vapi_payload_tap_delete_reply
#define defined_vapi_payload_tap_delete_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_tap_delete_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_tap_delete_reply payload;
} vapi_msg_tap_delete_reply;
#endif

#ifndef defined_vapi_payload_sw_interface_tap_details
#define defined_vapi_payload_sw_interface_tap_details
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 dev_name[64]; 
} vapi_payload_sw_interface_tap_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_sw_interface_tap_details payload;
} vapi_msg_sw_interface_tap_details;
#endif


static inline void vapi_msg_tap_connect_reply_payload_hton(vapi_payload_tap_connect_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_tap_connect_reply_payload_ntoh(vapi_payload_tap_connect_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_tap_connect_reply_msg_size(vapi_msg_tap_connect_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_tap_connect_reply_hton(vapi_msg_tap_connect_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_connect_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_tap_connect_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_tap_connect_reply_ntoh(vapi_msg_tap_connect_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_connect_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_tap_connect_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_tap_modify_reply_payload_hton(vapi_payload_tap_modify_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_tap_modify_reply_payload_ntoh(vapi_payload_tap_modify_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_tap_modify_reply_msg_size(vapi_msg_tap_modify_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_tap_modify_reply_hton(vapi_msg_tap_modify_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_modify_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_tap_modify_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_tap_modify_reply_ntoh(vapi_msg_tap_modify_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_modify_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_tap_modify_reply_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_sw_interface_tap_dump_msg_size(vapi_msg_sw_interface_tap_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sw_interface_tap_dump_hton(vapi_msg_sw_interface_tap_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sw_interface_tap_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_sw_interface_tap_dump_ntoh(vapi_msg_sw_interface_tap_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sw_interface_tap_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_tap_connect_payload_hton(vapi_payload_tap_connect *payload)
{
  payload->custom_dev_instance = htobe32(payload->custom_dev_instance);
}

static inline void vapi_msg_tap_connect_payload_ntoh(vapi_payload_tap_connect *payload)
{
  payload->custom_dev_instance = be32toh(payload->custom_dev_instance);
}

static inline uword vapi_calc_tap_connect_msg_size(vapi_msg_tap_connect *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_tap_connect_hton(vapi_msg_tap_connect *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_connect'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_tap_connect_payload_hton(&msg->payload);
}

static inline void vapi_msg_tap_connect_ntoh(vapi_msg_tap_connect *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_connect'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_tap_connect_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_tap_modify_payload_hton(vapi_payload_tap_modify *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
  payload->custom_dev_instance = htobe32(payload->custom_dev_instance);
}

static inline void vapi_msg_tap_modify_payload_ntoh(vapi_payload_tap_modify *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
  payload->custom_dev_instance = be32toh(payload->custom_dev_instance);
}

static inline uword vapi_calc_tap_modify_msg_size(vapi_msg_tap_modify *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_tap_modify_hton(vapi_msg_tap_modify *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_modify'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_tap_modify_payload_hton(&msg->payload);
}

static inline void vapi_msg_tap_modify_ntoh(vapi_msg_tap_modify *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_modify'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_tap_modify_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_tap_delete_payload_hton(vapi_payload_tap_delete *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_tap_delete_payload_ntoh(vapi_payload_tap_delete *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_tap_delete_msg_size(vapi_msg_tap_delete *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_tap_delete_hton(vapi_msg_tap_delete *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_delete'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_tap_delete_payload_hton(&msg->payload);
}

static inline void vapi_msg_tap_delete_ntoh(vapi_msg_tap_delete *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_delete'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_tap_delete_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_tap_delete_reply_payload_hton(vapi_payload_tap_delete_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_tap_delete_reply_payload_ntoh(vapi_payload_tap_delete_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_tap_delete_reply_msg_size(vapi_msg_tap_delete_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_tap_delete_reply_hton(vapi_msg_tap_delete_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_delete_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_tap_delete_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_tap_delete_reply_ntoh(vapi_msg_tap_delete_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_tap_delete_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_tap_delete_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sw_interface_tap_details_payload_hton(vapi_payload_sw_interface_tap_details *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_sw_interface_tap_details_payload_ntoh(vapi_payload_sw_interface_tap_details *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_sw_interface_tap_details_msg_size(vapi_msg_sw_interface_tap_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sw_interface_tap_details_hton(vapi_msg_sw_interface_tap_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sw_interface_tap_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_sw_interface_tap_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_sw_interface_tap_details_ntoh(vapi_msg_sw_interface_tap_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sw_interface_tap_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_sw_interface_tap_details_payload_ntoh(&msg->payload);
}

static inline vapi_msg_sw_interface_tap_dump* vapi_alloc_sw_interface_tap_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_sw_interface_tap_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_sw_interface_tap_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_sw_interface_tap_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_sw_interface_tap_dump);

  return msg;
}

static inline vapi_error_e vapi_sw_interface_tap_dump(struct vapi_ctx_s *ctx,
  vapi_msg_sw_interface_tap_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_sw_interface_tap_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_sw_interface_tap_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_sw_interface_tap_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_tap_connect* vapi_alloc_tap_connect(struct vapi_ctx_s *ctx)
{
  vapi_msg_tap_connect *msg = NULL;
  const size_t size = sizeof(vapi_msg_tap_connect);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_tap_connect*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_tap_connect);

  return msg;
}

static inline vapi_error_e vapi_tap_connect(struct vapi_ctx_s *ctx,
  vapi_msg_tap_connect *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_tap_connect_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_tap_connect_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_tap_connect_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_tap_modify* vapi_alloc_tap_modify(struct vapi_ctx_s *ctx)
{
  vapi_msg_tap_modify *msg = NULL;
  const size_t size = sizeof(vapi_msg_tap_modify);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_tap_modify*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_tap_modify);

  return msg;
}

static inline vapi_error_e vapi_tap_modify(struct vapi_ctx_s *ctx,
  vapi_msg_tap_modify *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_tap_modify_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_tap_modify_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_tap_modify_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_tap_delete* vapi_alloc_tap_delete(struct vapi_ctx_s *ctx)
{
  vapi_msg_tap_delete *msg = NULL;
  const size_t size = sizeof(vapi_msg_tap_delete);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_tap_delete*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_tap_delete);

  return msg;
}

static inline vapi_error_e vapi_tap_delete(struct vapi_ctx_s *ctx,
  vapi_msg_tap_delete *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_tap_delete_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_tap_delete_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_tap_delete_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_tap_connect_reply()
{
  static const char name[] = "tap_connect_reply";
  static const char name_with_crc[] = "tap_connect_reply_fda5941f";
  static vapi_message_desc_t __vapi_metadata_tap_connect_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_tap_connect_reply, payload),
    sizeof(vapi_msg_tap_connect_reply),
    (generic_swap_fn_t)vapi_msg_tap_connect_reply_hton,
    (generic_swap_fn_t)vapi_msg_tap_connect_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_tap_connect_reply = vapi_register_msg(&__vapi_metadata_tap_connect_reply);
  VAPI_DBG("Assigned msg id %d to tap_connect_reply", vapi_msg_id_tap_connect_reply);
}

static void __attribute__((constructor)) __vapi_constructor_tap_modify_reply()
{
  static const char name[] = "tap_modify_reply";
  static const char name_with_crc[] = "tap_modify_reply_fda5941f";
  static vapi_message_desc_t __vapi_metadata_tap_modify_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_tap_modify_reply, payload),
    sizeof(vapi_msg_tap_modify_reply),
    (generic_swap_fn_t)vapi_msg_tap_modify_reply_hton,
    (generic_swap_fn_t)vapi_msg_tap_modify_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_tap_modify_reply = vapi_register_msg(&__vapi_metadata_tap_modify_reply);
  VAPI_DBG("Assigned msg id %d to tap_modify_reply", vapi_msg_id_tap_modify_reply);
}

static void __attribute__((constructor)) __vapi_constructor_sw_interface_tap_dump()
{
  static const char name[] = "sw_interface_tap_dump";
  static const char name_with_crc[] = "sw_interface_tap_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_sw_interface_tap_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_sw_interface_tap_dump),
    (generic_swap_fn_t)vapi_msg_sw_interface_tap_dump_hton,
    (generic_swap_fn_t)vapi_msg_sw_interface_tap_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_sw_interface_tap_dump = vapi_register_msg(&__vapi_metadata_sw_interface_tap_dump);
  VAPI_DBG("Assigned msg id %d to sw_interface_tap_dump", vapi_msg_id_sw_interface_tap_dump);
}

static void __attribute__((constructor)) __vapi_constructor_tap_connect()
{
  static const char name[] = "tap_connect";
  static const char name_with_crc[] = "tap_connect_9b9c396f";
  static vapi_message_desc_t __vapi_metadata_tap_connect = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_tap_connect, payload),
    sizeof(vapi_msg_tap_connect),
    (generic_swap_fn_t)vapi_msg_tap_connect_hton,
    (generic_swap_fn_t)vapi_msg_tap_connect_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_tap_connect = vapi_register_msg(&__vapi_metadata_tap_connect);
  VAPI_DBG("Assigned msg id %d to tap_connect", vapi_msg_id_tap_connect);
}

static void __attribute__((constructor)) __vapi_constructor_tap_modify()
{
  static const char name[] = "tap_modify";
  static const char name_with_crc[] = "tap_modify_8047ae5c";
  static vapi_message_desc_t __vapi_metadata_tap_modify = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_tap_modify, payload),
    sizeof(vapi_msg_tap_modify),
    (generic_swap_fn_t)vapi_msg_tap_modify_hton,
    (generic_swap_fn_t)vapi_msg_tap_modify_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_tap_modify = vapi_register_msg(&__vapi_metadata_tap_modify);
  VAPI_DBG("Assigned msg id %d to tap_modify", vapi_msg_id_tap_modify);
}

static void __attribute__((constructor)) __vapi_constructor_tap_delete()
{
  static const char name[] = "tap_delete";
  static const char name_with_crc[] = "tap_delete_529cb13f";
  static vapi_message_desc_t __vapi_metadata_tap_delete = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_tap_delete, payload),
    sizeof(vapi_msg_tap_delete),
    (generic_swap_fn_t)vapi_msg_tap_delete_hton,
    (generic_swap_fn_t)vapi_msg_tap_delete_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_tap_delete = vapi_register_msg(&__vapi_metadata_tap_delete);
  VAPI_DBG("Assigned msg id %d to tap_delete", vapi_msg_id_tap_delete);
}

static void __attribute__((constructor)) __vapi_constructor_tap_delete_reply()
{
  static const char name[] = "tap_delete_reply";
  static const char name_with_crc[] = "tap_delete_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_tap_delete_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_tap_delete_reply, payload),
    sizeof(vapi_msg_tap_delete_reply),
    (generic_swap_fn_t)vapi_msg_tap_delete_reply_hton,
    (generic_swap_fn_t)vapi_msg_tap_delete_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_tap_delete_reply = vapi_register_msg(&__vapi_metadata_tap_delete_reply);
  VAPI_DBG("Assigned msg id %d to tap_delete_reply", vapi_msg_id_tap_delete_reply);
}

static void __attribute__((constructor)) __vapi_constructor_sw_interface_tap_details()
{
  static const char name[] = "sw_interface_tap_details";
  static const char name_with_crc[] = "sw_interface_tap_details_76229a57";
  static vapi_message_desc_t __vapi_metadata_sw_interface_tap_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_sw_interface_tap_details, payload),
    sizeof(vapi_msg_sw_interface_tap_details),
    (generic_swap_fn_t)vapi_msg_sw_interface_tap_details_hton,
    (generic_swap_fn_t)vapi_msg_sw_interface_tap_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_sw_interface_tap_details = vapi_register_msg(&__vapi_metadata_sw_interface_tap_details);
  VAPI_DBG("Assigned msg id %d to sw_interface_tap_details", vapi_msg_id_sw_interface_tap_details);
}


static inline void vapi_set_vapi_msg_tap_connect_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_tap_connect_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_tap_connect_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_tap_modify_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_tap_modify_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_tap_modify_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_tap_delete_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_tap_delete_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_tap_delete_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_sw_interface_tap_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_sw_interface_tap_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_sw_interface_tap_details, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
