#ifndef __included_udp_api_json
#define __included_udp_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_udp_encap_dump;
extern vapi_msg_id_t vapi_msg_id_udp_encap_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_udp_encap_add_del;
extern vapi_msg_id_t vapi_msg_id_udp_encap_details;

#define DEFINE_VAPI_MSG_IDS_UDP_API_JSON\
  vapi_msg_id_t vapi_msg_id_udp_encap_dump;\
  vapi_msg_id_t vapi_msg_id_udp_encap_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_udp_encap_add_del;\
  vapi_msg_id_t vapi_msg_id_udp_encap_details;


#ifndef defined_vapi_payload_udp_encap_dump
#define defined_vapi_payload_udp_encap_dump
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_udp_encap_dump;
#endif

#ifndef defined_vapi_payload_udp_encap_add_del_reply
#define defined_vapi_payload_udp_encap_add_del_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_udp_encap_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_udp_encap_add_del_reply payload;
} vapi_msg_udp_encap_add_del_reply;
#endif

#ifndef defined_vapi_payload_udp_encap_add_del
#define defined_vapi_payload_udp_encap_add_del
typedef struct __attribute__ ((__packed__)) {
  u32 id;
  u32 table_id;
  u8 is_ip6;
  u8 is_add;
  u16 src_port;
  u16 dst_port;
  u8 src_ip[16];
  u8 dst_ip[16]; 
} vapi_payload_udp_encap_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_udp_encap_add_del payload;
} vapi_msg_udp_encap_add_del;
#endif

#ifndef defined_vapi_payload_udp_encap_details
#define defined_vapi_payload_udp_encap_details
typedef struct __attribute__ ((__packed__)) {
  u32 id;
  u32 table_id;
  u8 is_ip6;
  u16 src_port;
  u16 dst_port;
  u8 src_ip[16];
  u8 dst_ip[16]; 
} vapi_payload_udp_encap_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_udp_encap_details payload;
} vapi_msg_udp_encap_details;
#endif


static inline uword vapi_calc_udp_encap_dump_msg_size(vapi_msg_udp_encap_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_udp_encap_dump_hton(vapi_msg_udp_encap_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_udp_encap_dump_ntoh(vapi_msg_udp_encap_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_udp_encap_add_del_reply_payload_hton(vapi_payload_udp_encap_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_udp_encap_add_del_reply_payload_ntoh(vapi_payload_udp_encap_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_udp_encap_add_del_reply_msg_size(vapi_msg_udp_encap_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_udp_encap_add_del_reply_hton(vapi_msg_udp_encap_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_udp_encap_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_udp_encap_add_del_reply_ntoh(vapi_msg_udp_encap_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_udp_encap_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_udp_encap_add_del_payload_hton(vapi_payload_udp_encap_add_del *payload)
{
  payload->id = htobe32(payload->id);
  payload->table_id = htobe32(payload->table_id);
  payload->src_port = htobe16(payload->src_port);
  payload->dst_port = htobe16(payload->dst_port);
}

static inline void vapi_msg_udp_encap_add_del_payload_ntoh(vapi_payload_udp_encap_add_del *payload)
{
  payload->id = be32toh(payload->id);
  payload->table_id = be32toh(payload->table_id);
  payload->src_port = be16toh(payload->src_port);
  payload->dst_port = be16toh(payload->dst_port);
}

static inline uword vapi_calc_udp_encap_add_del_msg_size(vapi_msg_udp_encap_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_udp_encap_add_del_hton(vapi_msg_udp_encap_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_udp_encap_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_udp_encap_add_del_ntoh(vapi_msg_udp_encap_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_udp_encap_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_udp_encap_details_payload_hton(vapi_payload_udp_encap_details *payload)
{
  payload->id = htobe32(payload->id);
  payload->table_id = htobe32(payload->table_id);
  payload->src_port = htobe16(payload->src_port);
  payload->dst_port = htobe16(payload->dst_port);
}

static inline void vapi_msg_udp_encap_details_payload_ntoh(vapi_payload_udp_encap_details *payload)
{
  payload->id = be32toh(payload->id);
  payload->table_id = be32toh(payload->table_id);
  payload->src_port = be16toh(payload->src_port);
  payload->dst_port = be16toh(payload->dst_port);
}

static inline uword vapi_calc_udp_encap_details_msg_size(vapi_msg_udp_encap_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_udp_encap_details_hton(vapi_msg_udp_encap_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_udp_encap_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_udp_encap_details_ntoh(vapi_msg_udp_encap_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_encap_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_udp_encap_details_payload_ntoh(&msg->payload);
}

static inline vapi_msg_udp_encap_dump* vapi_alloc_udp_encap_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_udp_encap_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_udp_encap_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_udp_encap_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_udp_encap_dump);

  return msg;
}

static inline vapi_error_e vapi_udp_encap_dump(struct vapi_ctx_s *ctx,
  vapi_msg_udp_encap_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_udp_encap_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_udp_encap_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_udp_encap_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_udp_encap_add_del* vapi_alloc_udp_encap_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_udp_encap_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_udp_encap_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_udp_encap_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_udp_encap_add_del);

  return msg;
}

static inline vapi_error_e vapi_udp_encap_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_udp_encap_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_udp_encap_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_udp_encap_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_udp_encap_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_udp_encap_dump()
{
  static const char name[] = "udp_encap_dump";
  static const char name_with_crc[] = "udp_encap_dump_51077d14";
  static vapi_message_desc_t __vapi_metadata_udp_encap_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_udp_encap_dump),
    (generic_swap_fn_t)vapi_msg_udp_encap_dump_hton,
    (generic_swap_fn_t)vapi_msg_udp_encap_dump_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_udp_encap_dump = vapi_register_msg(&__vapi_metadata_udp_encap_dump);
  VAPI_DBG("Assigned msg id %d to udp_encap_dump", vapi_msg_id_udp_encap_dump);
}

static void __attribute__((constructor)) __vapi_constructor_udp_encap_add_del_reply()
{
  static const char name[] = "udp_encap_add_del_reply";
  static const char name_with_crc[] = "udp_encap_add_del_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_udp_encap_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_udp_encap_add_del_reply, payload),
    sizeof(vapi_msg_udp_encap_add_del_reply),
    (generic_swap_fn_t)vapi_msg_udp_encap_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_udp_encap_add_del_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_udp_encap_add_del_reply = vapi_register_msg(&__vapi_metadata_udp_encap_add_del_reply);
  VAPI_DBG("Assigned msg id %d to udp_encap_add_del_reply", vapi_msg_id_udp_encap_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_udp_encap_add_del()
{
  static const char name[] = "udp_encap_add_del";
  static const char name_with_crc[] = "udp_encap_add_del_0a37c11f";
  static vapi_message_desc_t __vapi_metadata_udp_encap_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_udp_encap_add_del, payload),
    sizeof(vapi_msg_udp_encap_add_del),
    (generic_swap_fn_t)vapi_msg_udp_encap_add_del_hton,
    (generic_swap_fn_t)vapi_msg_udp_encap_add_del_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_udp_encap_add_del = vapi_register_msg(&__vapi_metadata_udp_encap_add_del);
  VAPI_DBG("Assigned msg id %d to udp_encap_add_del", vapi_msg_id_udp_encap_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_udp_encap_details()
{
  static const char name[] = "udp_encap_details";
  static const char name_with_crc[] = "udp_encap_details_185bbd52";
  static vapi_message_desc_t __vapi_metadata_udp_encap_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_udp_encap_details, payload),
    sizeof(vapi_msg_udp_encap_details),
    (generic_swap_fn_t)vapi_msg_udp_encap_details_hton,
    (generic_swap_fn_t)vapi_msg_udp_encap_details_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_udp_encap_details = vapi_register_msg(&__vapi_metadata_udp_encap_details);
  VAPI_DBG("Assigned msg id %d to udp_encap_details", vapi_msg_id_udp_encap_details);
}


static inline void vapi_set_vapi_msg_udp_encap_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_udp_encap_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_udp_encap_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_udp_encap_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_udp_encap_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_udp_encap_details, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
