#ifndef __included_vpe_api_json
#define __included_vpe_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif

static inline vapi_error_e vapi_send_with_control_ping (vapi_ctx_t ctx, void * msg, u32 context);

extern vapi_msg_id_t vapi_msg_id_get_next_index_reply;
extern vapi_msg_id_t vapi_msg_id_get_node_index_reply;
extern vapi_msg_id_t vapi_msg_id_cli_inband;
extern vapi_msg_id_t vapi_msg_id_get_node_index;
extern vapi_msg_id_t vapi_msg_id_cli;
extern vapi_msg_id_t vapi_msg_id_add_node_next_reply;
extern vapi_msg_id_t vapi_msg_id_show_version;
extern vapi_msg_id_t vapi_msg_id_cli_inband_reply;
extern vapi_msg_id_t vapi_msg_id_get_node_graph_reply;
extern vapi_msg_id_t vapi_msg_id_get_node_graph;
extern vapi_msg_id_t vapi_msg_id_cli_reply;
extern vapi_msg_id_t vapi_msg_id_get_next_index;
extern vapi_msg_id_t vapi_msg_id_control_ping;
extern vapi_msg_id_t vapi_msg_id_add_node_next;
extern vapi_msg_id_t vapi_msg_id_control_ping_reply;
extern vapi_msg_id_t vapi_msg_id_show_version_reply;

#define DEFINE_VAPI_MSG_IDS_VPE_API_JSON\
  vapi_msg_id_t vapi_msg_id_get_next_index_reply;\
  vapi_msg_id_t vapi_msg_id_get_node_index_reply;\
  vapi_msg_id_t vapi_msg_id_cli_inband;\
  vapi_msg_id_t vapi_msg_id_get_node_index;\
  vapi_msg_id_t vapi_msg_id_cli;\
  vapi_msg_id_t vapi_msg_id_add_node_next_reply;\
  vapi_msg_id_t vapi_msg_id_show_version;\
  vapi_msg_id_t vapi_msg_id_cli_inband_reply;\
  vapi_msg_id_t vapi_msg_id_get_node_graph_reply;\
  vapi_msg_id_t vapi_msg_id_get_node_graph;\
  vapi_msg_id_t vapi_msg_id_cli_reply;\
  vapi_msg_id_t vapi_msg_id_get_next_index;\
  vapi_msg_id_t vapi_msg_id_control_ping;\
  vapi_msg_id_t vapi_msg_id_add_node_next;\
  vapi_msg_id_t vapi_msg_id_control_ping_reply;\
  vapi_msg_id_t vapi_msg_id_show_version_reply;


#ifndef defined_vapi_payload_get_next_index_reply
#define defined_vapi_payload_get_next_index_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 next_index; 
} vapi_payload_get_next_index_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_get_next_index_reply payload;
} vapi_msg_get_next_index_reply;
#endif

#ifndef defined_vapi_payload_get_node_index_reply
#define defined_vapi_payload_get_node_index_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 node_index; 
} vapi_payload_get_node_index_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_get_node_index_reply payload;
} vapi_msg_get_node_index_reply;
#endif

#ifndef defined_vapi_payload_cli_inband
#define defined_vapi_payload_cli_inband
typedef struct __attribute__ ((__packed__)) {
  u32 length;
  u8 cmd[0]; 
} vapi_payload_cli_inband;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_cli_inband payload;
} vapi_msg_cli_inband;
#endif

#ifndef defined_vapi_payload_get_node_index
#define defined_vapi_payload_get_node_index
typedef struct __attribute__ ((__packed__)) {
  u8 node_name[64]; 
} vapi_payload_get_node_index;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_get_node_index payload;
} vapi_msg_get_node_index;
#endif

#ifndef defined_vapi_payload_cli
#define defined_vapi_payload_cli
typedef struct __attribute__ ((__packed__)) {
  u64 cmd_in_shmem; 
} vapi_payload_cli;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_cli payload;
} vapi_msg_cli;
#endif

#ifndef defined_vapi_payload_add_node_next_reply
#define defined_vapi_payload_add_node_next_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 next_index; 
} vapi_payload_add_node_next_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_add_node_next_reply payload;
} vapi_msg_add_node_next_reply;
#endif

#ifndef defined_vapi_payload_show_version
#define defined_vapi_payload_show_version
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_show_version;
#endif

#ifndef defined_vapi_payload_cli_inband_reply
#define defined_vapi_payload_cli_inband_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 length;
  u8 reply[0]; 
} vapi_payload_cli_inband_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_cli_inband_reply payload;
} vapi_msg_cli_inband_reply;
#endif

#ifndef defined_vapi_payload_get_node_graph_reply
#define defined_vapi_payload_get_node_graph_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u64 reply_in_shmem; 
} vapi_payload_get_node_graph_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_get_node_graph_reply payload;
} vapi_msg_get_node_graph_reply;
#endif

#ifndef defined_vapi_payload_get_node_graph
#define defined_vapi_payload_get_node_graph
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_get_node_graph;
#endif

#ifndef defined_vapi_payload_cli_reply
#define defined_vapi_payload_cli_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u64 reply_in_shmem; 
} vapi_payload_cli_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_cli_reply payload;
} vapi_msg_cli_reply;
#endif

#ifndef defined_vapi_payload_get_next_index
#define defined_vapi_payload_get_next_index
typedef struct __attribute__ ((__packed__)) {
  u8 node_name[64];
  u8 next_name[64]; 
} vapi_payload_get_next_index;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_get_next_index payload;
} vapi_msg_get_next_index;
#endif

#ifndef defined_vapi_payload_control_ping
#define defined_vapi_payload_control_ping
typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_control_ping;
#endif

#ifndef defined_vapi_payload_add_node_next
#define defined_vapi_payload_add_node_next
typedef struct __attribute__ ((__packed__)) {
  u8 node_name[64];
  u8 next_name[64]; 
} vapi_payload_add_node_next;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_add_node_next payload;
} vapi_msg_add_node_next;
#endif

#ifndef defined_vapi_payload_control_ping_reply
#define defined_vapi_payload_control_ping_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 client_index;
  u32 vpe_pid; 
} vapi_payload_control_ping_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_control_ping_reply payload;
} vapi_msg_control_ping_reply;
#endif

#ifndef defined_vapi_payload_show_version_reply
#define defined_vapi_payload_show_version_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u8 program[32];
  u8 version[32];
  u8 build_date[32];
  u8 build_directory[256]; 
} vapi_payload_show_version_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_show_version_reply payload;
} vapi_msg_show_version_reply;
#endif


static inline void vapi_msg_get_next_index_reply_payload_hton(vapi_payload_get_next_index_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->next_index = htobe32(payload->next_index);
}

static inline void vapi_msg_get_next_index_reply_payload_ntoh(vapi_payload_get_next_index_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->next_index = be32toh(payload->next_index);
}

static inline uword vapi_calc_get_next_index_reply_msg_size(vapi_msg_get_next_index_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_next_index_reply_hton(vapi_msg_get_next_index_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_next_index_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_get_next_index_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_next_index_reply_ntoh(vapi_msg_get_next_index_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_next_index_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_get_next_index_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_get_node_index_reply_payload_hton(vapi_payload_get_node_index_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->node_index = htobe32(payload->node_index);
}

static inline void vapi_msg_get_node_index_reply_payload_ntoh(vapi_payload_get_node_index_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->node_index = be32toh(payload->node_index);
}

static inline uword vapi_calc_get_node_index_reply_msg_size(vapi_msg_get_node_index_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_node_index_reply_hton(vapi_msg_get_node_index_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_index_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_get_node_index_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_node_index_reply_ntoh(vapi_msg_get_node_index_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_index_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_get_node_index_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_cli_inband_payload_hton(vapi_payload_cli_inband *payload)
{
  payload->length = htobe32(payload->length);
}

static inline void vapi_msg_cli_inband_payload_ntoh(vapi_payload_cli_inband *payload)
{
  payload->length = be32toh(payload->length);
}

static inline uword vapi_calc_cli_inband_msg_size(vapi_msg_cli_inband *msg)
{
  return sizeof(*msg)+ msg->payload.length * sizeof(msg->payload.cmd[0]);
}

static inline void vapi_msg_cli_inband_hton(vapi_msg_cli_inband *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli_inband'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_cli_inband_payload_hton(&msg->payload);
}

static inline void vapi_msg_cli_inband_ntoh(vapi_msg_cli_inband *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli_inband'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_cli_inband_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_get_node_index_payload_hton(vapi_payload_get_node_index *payload)
{

}

static inline void vapi_msg_get_node_index_payload_ntoh(vapi_payload_get_node_index *payload)
{

}

static inline uword vapi_calc_get_node_index_msg_size(vapi_msg_get_node_index *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_node_index_hton(vapi_msg_get_node_index *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_index'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_get_node_index_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_node_index_ntoh(vapi_msg_get_node_index *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_index'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_get_node_index_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_cli_payload_hton(vapi_payload_cli *payload)
{
  payload->cmd_in_shmem = htobe64(payload->cmd_in_shmem);
}

static inline void vapi_msg_cli_payload_ntoh(vapi_payload_cli *payload)
{
  payload->cmd_in_shmem = be64toh(payload->cmd_in_shmem);
}

static inline uword vapi_calc_cli_msg_size(vapi_msg_cli *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_cli_hton(vapi_msg_cli *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_cli_payload_hton(&msg->payload);
}

static inline void vapi_msg_cli_ntoh(vapi_msg_cli *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_cli_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_add_node_next_reply_payload_hton(vapi_payload_add_node_next_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->next_index = htobe32(payload->next_index);
}

static inline void vapi_msg_add_node_next_reply_payload_ntoh(vapi_payload_add_node_next_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->next_index = be32toh(payload->next_index);
}

static inline uword vapi_calc_add_node_next_reply_msg_size(vapi_msg_add_node_next_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_add_node_next_reply_hton(vapi_msg_add_node_next_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_add_node_next_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_add_node_next_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_add_node_next_reply_ntoh(vapi_msg_add_node_next_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_add_node_next_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_add_node_next_reply_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_show_version_msg_size(vapi_msg_show_version *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_show_version_hton(vapi_msg_show_version *msg)
{
  VAPI_DBG("Swapping `vapi_msg_show_version'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_show_version_ntoh(vapi_msg_show_version *msg)
{
  VAPI_DBG("Swapping `vapi_msg_show_version'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_cli_inband_reply_payload_hton(vapi_payload_cli_inband_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->length = htobe32(payload->length);
}

static inline void vapi_msg_cli_inband_reply_payload_ntoh(vapi_payload_cli_inband_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->length = be32toh(payload->length);
}

static inline uword vapi_calc_cli_inband_reply_msg_size(vapi_msg_cli_inband_reply *msg)
{
  return sizeof(*msg)+ msg->payload.length * sizeof(msg->payload.reply[0]);
}

static inline void vapi_msg_cli_inband_reply_hton(vapi_msg_cli_inband_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli_inband_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_cli_inband_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_cli_inband_reply_ntoh(vapi_msg_cli_inband_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli_inband_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_cli_inband_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_get_node_graph_reply_payload_hton(vapi_payload_get_node_graph_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->reply_in_shmem = htobe64(payload->reply_in_shmem);
}

static inline void vapi_msg_get_node_graph_reply_payload_ntoh(vapi_payload_get_node_graph_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->reply_in_shmem = be64toh(payload->reply_in_shmem);
}

static inline uword vapi_calc_get_node_graph_reply_msg_size(vapi_msg_get_node_graph_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_node_graph_reply_hton(vapi_msg_get_node_graph_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_graph_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_get_node_graph_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_node_graph_reply_ntoh(vapi_msg_get_node_graph_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_graph_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_get_node_graph_reply_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_get_node_graph_msg_size(vapi_msg_get_node_graph *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_node_graph_hton(vapi_msg_get_node_graph *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_graph'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_get_node_graph_ntoh(vapi_msg_get_node_graph *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_node_graph'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_cli_reply_payload_hton(vapi_payload_cli_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->reply_in_shmem = htobe64(payload->reply_in_shmem);
}

static inline void vapi_msg_cli_reply_payload_ntoh(vapi_payload_cli_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->reply_in_shmem = be64toh(payload->reply_in_shmem);
}

static inline uword vapi_calc_cli_reply_msg_size(vapi_msg_cli_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_cli_reply_hton(vapi_msg_cli_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_cli_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_cli_reply_ntoh(vapi_msg_cli_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_cli_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_cli_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_get_next_index_payload_hton(vapi_payload_get_next_index *payload)
{

}

static inline void vapi_msg_get_next_index_payload_ntoh(vapi_payload_get_next_index *payload)
{

}

static inline uword vapi_calc_get_next_index_msg_size(vapi_msg_get_next_index *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_next_index_hton(vapi_msg_get_next_index *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_next_index'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_get_next_index_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_next_index_ntoh(vapi_msg_get_next_index *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_next_index'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_get_next_index_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_control_ping_msg_size(vapi_msg_control_ping *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_control_ping_hton(vapi_msg_control_ping *msg)
{
  VAPI_DBG("Swapping `vapi_msg_control_ping'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_control_ping_ntoh(vapi_msg_control_ping *msg)
{
  VAPI_DBG("Swapping `vapi_msg_control_ping'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_add_node_next_payload_hton(vapi_payload_add_node_next *payload)
{

}

static inline void vapi_msg_add_node_next_payload_ntoh(vapi_payload_add_node_next *payload)
{

}

static inline uword vapi_calc_add_node_next_msg_size(vapi_msg_add_node_next *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_add_node_next_hton(vapi_msg_add_node_next *msg)
{
  VAPI_DBG("Swapping `vapi_msg_add_node_next'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_add_node_next_payload_hton(&msg->payload);
}

static inline void vapi_msg_add_node_next_ntoh(vapi_msg_add_node_next *msg)
{
  VAPI_DBG("Swapping `vapi_msg_add_node_next'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_add_node_next_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_control_ping_reply_payload_hton(vapi_payload_control_ping_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->client_index = htobe32(payload->client_index);
  payload->vpe_pid = htobe32(payload->vpe_pid);
}

static inline void vapi_msg_control_ping_reply_payload_ntoh(vapi_payload_control_ping_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->client_index = be32toh(payload->client_index);
  payload->vpe_pid = be32toh(payload->vpe_pid);
}

static inline uword vapi_calc_control_ping_reply_msg_size(vapi_msg_control_ping_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_control_ping_reply_hton(vapi_msg_control_ping_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_control_ping_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_control_ping_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_control_ping_reply_ntoh(vapi_msg_control_ping_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_control_ping_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_control_ping_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_show_version_reply_payload_hton(vapi_payload_show_version_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_show_version_reply_payload_ntoh(vapi_payload_show_version_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_show_version_reply_msg_size(vapi_msg_show_version_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_show_version_reply_hton(vapi_msg_show_version_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_show_version_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_show_version_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_show_version_reply_ntoh(vapi_msg_show_version_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_show_version_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_show_version_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_cli_inband* vapi_alloc_cli_inband(struct vapi_ctx_s *ctx, size_t cmd_array_size)
{
  vapi_msg_cli_inband *msg = NULL;
  const size_t size = sizeof(vapi_msg_cli_inband) + sizeof(msg->payload.cmd[0]) * cmd_array_size;
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_cli_inband*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_cli_inband);
  msg->payload.length = cmd_array_size;
  return msg;
}

static inline vapi_error_e vapi_cli_inband(struct vapi_ctx_s *ctx,
  vapi_msg_cli_inband *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_cli_inband_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_cli_inband_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_cli_inband_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_get_node_index* vapi_alloc_get_node_index(struct vapi_ctx_s *ctx)
{
  vapi_msg_get_node_index *msg = NULL;
  const size_t size = sizeof(vapi_msg_get_node_index);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_get_node_index*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_get_node_index);

  return msg;
}

static inline vapi_error_e vapi_get_node_index(struct vapi_ctx_s *ctx,
  vapi_msg_get_node_index *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_get_node_index_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_get_node_index_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_get_node_index_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_cli* vapi_alloc_cli(struct vapi_ctx_s *ctx)
{
  vapi_msg_cli *msg = NULL;
  const size_t size = sizeof(vapi_msg_cli);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_cli*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_cli);

  return msg;
}

static inline vapi_error_e vapi_cli(struct vapi_ctx_s *ctx,
  vapi_msg_cli *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_cli_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_cli_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_cli_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_show_version* vapi_alloc_show_version(struct vapi_ctx_s *ctx)
{
  vapi_msg_show_version *msg = NULL;
  const size_t size = sizeof(vapi_msg_show_version);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_show_version*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_show_version);

  return msg;
}

static inline vapi_error_e vapi_show_version(struct vapi_ctx_s *ctx,
  vapi_msg_show_version *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_show_version_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_show_version_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_show_version_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_get_node_graph* vapi_alloc_get_node_graph(struct vapi_ctx_s *ctx)
{
  vapi_msg_get_node_graph *msg = NULL;
  const size_t size = sizeof(vapi_msg_get_node_graph);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_get_node_graph*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_get_node_graph);

  return msg;
}

static inline vapi_error_e vapi_get_node_graph(struct vapi_ctx_s *ctx,
  vapi_msg_get_node_graph *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_get_node_graph_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_get_node_graph_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_get_node_graph_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_get_next_index* vapi_alloc_get_next_index(struct vapi_ctx_s *ctx)
{
  vapi_msg_get_next_index *msg = NULL;
  const size_t size = sizeof(vapi_msg_get_next_index);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_get_next_index*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_get_next_index);

  return msg;
}

static inline vapi_error_e vapi_get_next_index(struct vapi_ctx_s *ctx,
  vapi_msg_get_next_index *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_get_next_index_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_get_next_index_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_get_next_index_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_control_ping* vapi_alloc_control_ping(struct vapi_ctx_s *ctx)
{
  vapi_msg_control_ping *msg = NULL;
  const size_t size = sizeof(vapi_msg_control_ping);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_control_ping*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_control_ping);

  return msg;
}

static inline vapi_error_e vapi_control_ping(struct vapi_ctx_s *ctx,
  vapi_msg_control_ping *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_control_ping_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_control_ping_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_control_ping_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_add_node_next* vapi_alloc_add_node_next(struct vapi_ctx_s *ctx)
{
  vapi_msg_add_node_next *msg = NULL;
  const size_t size = sizeof(vapi_msg_add_node_next);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_add_node_next*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_add_node_next);

  return msg;
}

static inline vapi_error_e vapi_add_node_next(struct vapi_ctx_s *ctx,
  vapi_msg_add_node_next *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_add_node_next_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_add_node_next_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_add_node_next_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_get_next_index_reply()
{
  static const char name[] = "get_next_index_reply";
  static const char name_with_crc[] = "get_next_index_reply_2ed75f32";
  static vapi_message_desc_t __vapi_metadata_get_next_index_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_get_next_index_reply, payload),
    sizeof(vapi_msg_get_next_index_reply),
    (generic_swap_fn_t)vapi_msg_get_next_index_reply_hton,
    (generic_swap_fn_t)vapi_msg_get_next_index_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_get_next_index_reply = vapi_register_msg(&__vapi_metadata_get_next_index_reply);
  VAPI_DBG("Assigned msg id %d to get_next_index_reply", vapi_msg_id_get_next_index_reply);
}

static void __attribute__((constructor)) __vapi_constructor_get_node_index_reply()
{
  static const char name[] = "get_node_index_reply";
  static const char name_with_crc[] = "get_node_index_reply_a8600b89";
  static vapi_message_desc_t __vapi_metadata_get_node_index_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_get_node_index_reply, payload),
    sizeof(vapi_msg_get_node_index_reply),
    (generic_swap_fn_t)vapi_msg_get_node_index_reply_hton,
    (generic_swap_fn_t)vapi_msg_get_node_index_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_get_node_index_reply = vapi_register_msg(&__vapi_metadata_get_node_index_reply);
  VAPI_DBG("Assigned msg id %d to get_node_index_reply", vapi_msg_id_get_node_index_reply);
}

static void __attribute__((constructor)) __vapi_constructor_cli_inband()
{
  static const char name[] = "cli_inband";
  static const char name_with_crc[] = "cli_inband_74e00a49";
  static vapi_message_desc_t __vapi_metadata_cli_inband = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_cli_inband, payload),
    sizeof(vapi_msg_cli_inband),
    (generic_swap_fn_t)vapi_msg_cli_inband_hton,
    (generic_swap_fn_t)vapi_msg_cli_inband_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_cli_inband = vapi_register_msg(&__vapi_metadata_cli_inband);
  VAPI_DBG("Assigned msg id %d to cli_inband", vapi_msg_id_cli_inband);
}

static void __attribute__((constructor)) __vapi_constructor_get_node_index()
{
  static const char name[] = "get_node_index";
  static const char name_with_crc[] = "get_node_index_6c9a495d";
  static vapi_message_desc_t __vapi_metadata_get_node_index = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_get_node_index, payload),
    sizeof(vapi_msg_get_node_index),
    (generic_swap_fn_t)vapi_msg_get_node_index_hton,
    (generic_swap_fn_t)vapi_msg_get_node_index_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_get_node_index = vapi_register_msg(&__vapi_metadata_get_node_index);
  VAPI_DBG("Assigned msg id %d to get_node_index", vapi_msg_id_get_node_index);
}

static void __attribute__((constructor)) __vapi_constructor_cli()
{
  static const char name[] = "cli";
  static const char name_with_crc[] = "cli_23bfbfff";
  static vapi_message_desc_t __vapi_metadata_cli = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_cli, payload),
    sizeof(vapi_msg_cli),
    (generic_swap_fn_t)vapi_msg_cli_hton,
    (generic_swap_fn_t)vapi_msg_cli_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_cli = vapi_register_msg(&__vapi_metadata_cli);
  VAPI_DBG("Assigned msg id %d to cli", vapi_msg_id_cli);
}

static void __attribute__((constructor)) __vapi_constructor_add_node_next_reply()
{
  static const char name[] = "add_node_next_reply";
  static const char name_with_crc[] = "add_node_next_reply_2ed75f32";
  static vapi_message_desc_t __vapi_metadata_add_node_next_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_add_node_next_reply, payload),
    sizeof(vapi_msg_add_node_next_reply),
    (generic_swap_fn_t)vapi_msg_add_node_next_reply_hton,
    (generic_swap_fn_t)vapi_msg_add_node_next_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_add_node_next_reply = vapi_register_msg(&__vapi_metadata_add_node_next_reply);
  VAPI_DBG("Assigned msg id %d to add_node_next_reply", vapi_msg_id_add_node_next_reply);
}

static void __attribute__((constructor)) __vapi_constructor_show_version()
{
  static const char name[] = "show_version";
  static const char name_with_crc[] = "show_version_51077d14";
  static vapi_message_desc_t __vapi_metadata_show_version = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_show_version),
    (generic_swap_fn_t)vapi_msg_show_version_hton,
    (generic_swap_fn_t)vapi_msg_show_version_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_show_version = vapi_register_msg(&__vapi_metadata_show_version);
  VAPI_DBG("Assigned msg id %d to show_version", vapi_msg_id_show_version);
}

static void __attribute__((constructor)) __vapi_constructor_cli_inband_reply()
{
  static const char name[] = "cli_inband_reply";
  static const char name_with_crc[] = "cli_inband_reply_1f22bbb8";
  static vapi_message_desc_t __vapi_metadata_cli_inband_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_cli_inband_reply, payload),
    sizeof(vapi_msg_cli_inband_reply),
    (generic_swap_fn_t)vapi_msg_cli_inband_reply_hton,
    (generic_swap_fn_t)vapi_msg_cli_inband_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_cli_inband_reply = vapi_register_msg(&__vapi_metadata_cli_inband_reply);
  VAPI_DBG("Assigned msg id %d to cli_inband_reply", vapi_msg_id_cli_inband_reply);
}

static void __attribute__((constructor)) __vapi_constructor_get_node_graph_reply()
{
  static const char name[] = "get_node_graph_reply";
  static const char name_with_crc[] = "get_node_graph_reply_06d68297";
  static vapi_message_desc_t __vapi_metadata_get_node_graph_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_get_node_graph_reply, payload),
    sizeof(vapi_msg_get_node_graph_reply),
    (generic_swap_fn_t)vapi_msg_get_node_graph_reply_hton,
    (generic_swap_fn_t)vapi_msg_get_node_graph_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_get_node_graph_reply = vapi_register_msg(&__vapi_metadata_get_node_graph_reply);
  VAPI_DBG("Assigned msg id %d to get_node_graph_reply", vapi_msg_id_get_node_graph_reply);
}

static void __attribute__((constructor)) __vapi_constructor_get_node_graph()
{
  static const char name[] = "get_node_graph";
  static const char name_with_crc[] = "get_node_graph_51077d14";
  static vapi_message_desc_t __vapi_metadata_get_node_graph = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_get_node_graph),
    (generic_swap_fn_t)vapi_msg_get_node_graph_hton,
    (generic_swap_fn_t)vapi_msg_get_node_graph_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_get_node_graph = vapi_register_msg(&__vapi_metadata_get_node_graph);
  VAPI_DBG("Assigned msg id %d to get_node_graph", vapi_msg_id_get_node_graph);
}

static void __attribute__((constructor)) __vapi_constructor_cli_reply()
{
  static const char name[] = "cli_reply";
  static const char name_with_crc[] = "cli_reply_06d68297";
  static vapi_message_desc_t __vapi_metadata_cli_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_cli_reply, payload),
    sizeof(vapi_msg_cli_reply),
    (generic_swap_fn_t)vapi_msg_cli_reply_hton,
    (generic_swap_fn_t)vapi_msg_cli_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_cli_reply = vapi_register_msg(&__vapi_metadata_cli_reply);
  VAPI_DBG("Assigned msg id %d to cli_reply", vapi_msg_id_cli_reply);
}

static void __attribute__((constructor)) __vapi_constructor_get_next_index()
{
  static const char name[] = "get_next_index";
  static const char name_with_crc[] = "get_next_index_9ab92f7a";
  static vapi_message_desc_t __vapi_metadata_get_next_index = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_get_next_index, payload),
    sizeof(vapi_msg_get_next_index),
    (generic_swap_fn_t)vapi_msg_get_next_index_hton,
    (generic_swap_fn_t)vapi_msg_get_next_index_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_get_next_index = vapi_register_msg(&__vapi_metadata_get_next_index);
  VAPI_DBG("Assigned msg id %d to get_next_index", vapi_msg_id_get_next_index);
}

static void __attribute__((constructor)) __vapi_constructor_control_ping()
{
  static const char name[] = "control_ping";
  static const char name_with_crc[] = "control_ping_51077d14";
  static vapi_message_desc_t __vapi_metadata_control_ping = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    VAPI_INVALID_MSG_ID,
    sizeof(vapi_msg_control_ping),
    (generic_swap_fn_t)vapi_msg_control_ping_hton,
    (generic_swap_fn_t)vapi_msg_control_ping_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_control_ping = vapi_register_msg(&__vapi_metadata_control_ping);
  VAPI_DBG("Assigned msg id %d to control_ping", vapi_msg_id_control_ping);
}

static void __attribute__((constructor)) __vapi_constructor_add_node_next()
{
  static const char name[] = "add_node_next";
  static const char name_with_crc[] = "add_node_next_9ab92f7a";
  static vapi_message_desc_t __vapi_metadata_add_node_next = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_add_node_next, payload),
    sizeof(vapi_msg_add_node_next),
    (generic_swap_fn_t)vapi_msg_add_node_next_hton,
    (generic_swap_fn_t)vapi_msg_add_node_next_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_add_node_next = vapi_register_msg(&__vapi_metadata_add_node_next);
  VAPI_DBG("Assigned msg id %d to add_node_next", vapi_msg_id_add_node_next);
}

static void __attribute__((constructor)) __vapi_constructor_control_ping_reply()
{
  static const char name[] = "control_ping_reply";
  static const char name_with_crc[] = "control_ping_reply_f6b0b8ca";
  static vapi_message_desc_t __vapi_metadata_control_ping_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_control_ping_reply, payload),
    sizeof(vapi_msg_control_ping_reply),
    (generic_swap_fn_t)vapi_msg_control_ping_reply_hton,
    (generic_swap_fn_t)vapi_msg_control_ping_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_control_ping_reply = vapi_register_msg(&__vapi_metadata_control_ping_reply);
  VAPI_DBG("Assigned msg id %d to control_ping_reply", vapi_msg_id_control_ping_reply);
}

static void __attribute__((constructor)) __vapi_constructor_show_version_reply()
{
  static const char name[] = "show_version_reply";
  static const char name_with_crc[] = "show_version_reply_8b5a13b4";
  static vapi_message_desc_t __vapi_metadata_show_version_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_show_version_reply, payload),
    sizeof(vapi_msg_show_version_reply),
    (generic_swap_fn_t)vapi_msg_show_version_reply_hton,
    (generic_swap_fn_t)vapi_msg_show_version_reply_ntoh,
    VAPI_INVALID_MSG_ID,
  };

  vapi_msg_id_show_version_reply = vapi_register_msg(&__vapi_metadata_show_version_reply);
  VAPI_DBG("Assigned msg id %d to show_version_reply", vapi_msg_id_show_version_reply);
}


static inline void vapi_set_vapi_msg_get_next_index_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_get_next_index_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_get_next_index_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_get_node_index_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_get_node_index_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_get_node_index_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_add_node_next_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_add_node_next_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_add_node_next_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_cli_inband_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_cli_inband_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_cli_inband_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_get_node_graph_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_get_node_graph_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_get_node_graph_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_cli_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_cli_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_cli_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_control_ping_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_control_ping_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_control_ping_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_show_version_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_show_version_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_show_version_reply, (vapi_event_cb)callback, callback_ctx);
};



static inline vapi_error_e
vapi_send_with_control_ping (vapi_ctx_t ctx, void *msg, u32 context)
{
  vapi_msg_control_ping *ping = vapi_alloc_control_ping (ctx);
  if (!ping)
    {
      return VAPI_ENOMEM;
    }
  ping->header.context = context;
  vapi_msg_control_ping_hton (ping);
  return vapi_send2 (ctx, msg, ping);
}


#ifdef __cplusplus
}
#endif

#endif
